LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY BOARDID IS

	PORT(
      MPCIDIN	     : in std_logic_vector (5 downto 0);
    CNT              : in std_logic;
    POS              : in std_logic;	 
    NEG              : in std_logic;	 
	 PAT              : in std_logic_vector (15 downto 0);
	 
	 MPCIDOUTAOLD   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTBOLD   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTCOLD   	: OUT STD_LOGIC_VECTOR (15 downto 0);		
		
	 MPCIDOUTANEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTBNEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTCNEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTDNEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTENEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTFNEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTGNEW   	: OUT STD_LOGIC_VECTOR (15 downto 0);
	 MPCIDOUTHNEW   	: OUT STD_LOGIC_VECTOR (15 downto 0)
 );

END ENTITY BOARDID;

ARCHITECTURE ARC  OF BOARDID IS

BEGIN


MPCIDOUTAOLD(0) <= '1';
MPCIDOUTAOLD(1) <= '0';
MPCIDOUTAOLD(2) <= MPCIDIN(0);
MPCIDOUTAOLD(3) <= MPCIDIN(1);
MPCIDOUTAOLD(4) <= MPCIDIN(2);
MPCIDOUTAOLD(5) <= MPCIDIN(3);
MPCIDOUTAOLD(6) <= MPCIDIN(4);
MPCIDOUTAOLD(7) <= MPCIDIN(5);
MPCIDOUTAOLD(8) <= '0'; 
MPCIDOUTAOLD(9) <= '0';
MPCIDOUTAOLD(10) <= '0';
MPCIDOUTAOLD(11) <= '0'; 
MPCIDOUTAOLD(12) <= '0'; 
MPCIDOUTAOLD(13) <= '0';
MPCIDOUTAOLD(14) <= '0';
MPCIDOUTAOLD(15) <= '0'; 

MPCIDOUTBOLD(0) <= '0';
MPCIDOUTBOLD(1) <= '1';
MPCIDOUTBOLD(2) <= MPCIDIN(0);
MPCIDOUTBOLD(3) <= MPCIDIN(1);
MPCIDOUTBOLD(4) <= MPCIDIN(2);
MPCIDOUTBOLD(5) <= MPCIDIN(3);
MPCIDOUTBOLD(6) <= MPCIDIN(4);
MPCIDOUTBOLD(7) <= MPCIDIN(5);
MPCIDOUTBOLD(8) <= '0'; 
MPCIDOUTBOLD(9) <= '0';
MPCIDOUTBOLD(10) <= '0';
MPCIDOUTBOLD(11) <= '0';
MPCIDOUTBOLD(12) <= '0'; 
MPCIDOUTBOLD(13) <= '0';
MPCIDOUTBOLD(14) <= '0';
MPCIDOUTBOLD(15) <= '0';
 
MPCIDOUTCOLD(0) <= '1';
MPCIDOUTCOLD(1) <= '1';
MPCIDOUTCOLD(2) <= MPCIDIN(0);
MPCIDOUTCOLD(3) <= MPCIDIN(1);
MPCIDOUTCOLD(4) <= MPCIDIN(2);
MPCIDOUTCOLD(5) <= MPCIDIN(3);
MPCIDOUTCOLD(6) <= MPCIDIN(4);
MPCIDOUTCOLD(7) <= MPCIDIN(5);
MPCIDOUTCOLD(8) <= '0'; 
MPCIDOUTCOLD(9) <= '0';
MPCIDOUTCOLD(10) <= '0';
MPCIDOUTCOLD(11) <= '0'; 
MPCIDOUTCOLD(12) <= '0'; 
MPCIDOUTCOLD(13) <= '0';
MPCIDOUTCOLD(14) <= '0';
MPCIDOUTCOLD(15) <= '0'; 

MPCIDOUTANEW(0) <= (POS AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTANEW(1) <= (NEG AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTANEW(2) <= (NEG AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTANEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTANEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTANEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTANEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTANEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTANEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTANEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTANEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTANEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTANEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTANEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTANEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTANEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTBNEW(0) <= (NEG AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTBNEW(1) <= (POS AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTBNEW(2) <= (NEG AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTBNEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTBNEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTBNEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTBNEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTBNEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTBNEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTBNEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTBNEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTBNEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTBNEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTBNEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTBNEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTBNEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTCNEW(0) <= (POS AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTCNEW(1) <= (POS AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTCNEW(2) <= (NEG AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTCNEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTCNEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTCNEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTCNEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTCNEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTCNEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTCNEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTCNEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTCNEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTCNEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTCNEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTCNEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTCNEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTDNEW(0) <= (NEG AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTDNEW(1) <= (NEG AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTDNEW(2) <= (POS AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTDNEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTDNEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTDNEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTDNEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTDNEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTDNEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTDNEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTDNEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTDNEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTDNEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTDNEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTDNEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTDNEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTENEW(0) <= (POS AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTENEW(1) <= (NEG AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTENEW(2) <= (POS AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTENEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTENEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTENEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTENEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTENEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTENEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTENEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTENEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTENEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTENEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTENEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTENEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTENEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTFNEW(0) <= (NEG AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTFNEW(1) <= (POS AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTFNEW(2) <= (POS AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTFNEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTFNEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTFNEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTFNEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTFNEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTFNEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTFNEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTFNEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTFNEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTFNEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTFNEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTFNEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTFNEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTGNEW(0) <= (POS AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTGNEW(1) <= (POS AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTGNEW(2) <= (POS AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTGNEW(3) <= (NEG AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTGNEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTGNEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTGNEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTGNEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTGNEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTGNEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTGNEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTGNEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTGNEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTGNEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTGNEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTGNEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

MPCIDOUTHNEW(0) <= (NEG AND NOT CNT) OR (PAT(0) AND CNT);
MPCIDOUTHNEW(1) <= (NEG AND NOT CNT) OR (PAT(1) AND CNT);
MPCIDOUTHNEW(2) <= (NEG AND NOT CNT) OR (PAT(2) AND CNT);
MPCIDOUTHNEW(3) <= (POS AND NOT CNT) OR (PAT(3) AND CNT);
MPCIDOUTHNEW(4) <= (MPCIDIN(0) AND NOT CNT) OR (PAT(4) AND CNT);
MPCIDOUTHNEW(5) <= (MPCIDIN(1) AND NOT CNT) OR (PAT(5) AND CNT);
MPCIDOUTHNEW(6) <= (MPCIDIN(2) AND NOT CNT) OR (PAT(6) AND CNT);
MPCIDOUTHNEW(7) <= (MPCIDIN(3) AND NOT CNT) OR (PAT(7) AND CNT);
MPCIDOUTHNEW(8) <= (MPCIDIN(4) AND NOT CNT) OR (PAT(8) AND CNT);
MPCIDOUTHNEW(9) <= (MPCIDIN(5) AND NOT CNT) OR (PAT(9) AND CNT);
MPCIDOUTHNEW(10) <= (NEG AND NOT CNT) OR (PAT(10) AND CNT);
MPCIDOUTHNEW(11) <= (NEG AND NOT CNT) OR (PAT(11) AND CNT); 
MPCIDOUTHNEW(12) <= (NEG AND NOT CNT) OR (PAT(12) AND CNT);
MPCIDOUTHNEW(13) <= (NEG AND NOT CNT) OR (PAT(13) AND CNT);
MPCIDOUTHNEW(14) <= (NEG AND NOT CNT) OR (PAT(14) AND CNT);
MPCIDOUTHNEW(15) <= (NEG AND NOT CNT) OR (PAT(15) AND CNT);

END ARC;
