LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY MUX64X16 IS

-- unified version 08/19/2013

    Port ( FA : in std_logic_vector(31 downto 0);
           FB : in std_logic_vector(31 downto 0);
           FC : in std_logic_vector(31 downto 0);
           FDD : in std_logic_vector(31 downto 0);
           FE : in std_logic_vector(31 downto 0);
           FF : in std_logic_vector(31 downto 0);
           FG : in std_logic_vector(31 downto 0);
           FH : in std_logic_vector(31 downto 0);
           FI : in std_logic_vector(31 downto 0);

           SA : in std_logic_vector(31 downto 0);
           SB : in std_logic_vector(31 downto 0);
           SC : in std_logic_vector(31 downto 0);
           SD : in std_logic_vector(31 downto 0);
           SE : in std_logic_vector(31 downto 0);
           SF : in std_logic_vector(31 downto 0);
           SG : in std_logic_vector(31 downto 0);
           SH : in std_logic_vector(31 downto 0);
           SI : in std_logic_vector(31 downto 0);
 
           DA : out std_logic_vector(15 downto 0);
           DB : out std_logic_vector(15 downto 0);
           DC : out std_logic_vector(15 downto 0);
           DD : out std_logic_vector(15 downto 0);
           DE : out std_logic_vector(15 downto 0);
           DF : out std_logic_vector(15 downto 0);
           DG : out std_logic_vector(15 downto 0);
           DH : out std_logic_vector(15 downto 0);
 	
           BC0A : in std_logic_vector(1 downto 0);		
           BC0B : in std_logic_vector(1 downto 0);					  
           BC0C : in std_logic_vector(1 downto 0);		
           BC0D : in std_logic_vector(1 downto 0);		
           BC0E : in std_logic_vector(1 downto 0);		
           BC0F : in std_logic_vector(1 downto 0);					  
           BC0G : in std_logic_vector(1 downto 0);		
           BC0H : in std_logic_vector(1 downto 0);		
           BC0I : in std_logic_vector(1 downto 0);			
           BC0J : in std_logic_vector(1 downto 0);		
           BC0K : in std_logic_vector(1 downto 0);					  
           BC0L : in std_logic_vector(1 downto 0);		
           BC0M : in std_logic_vector(1 downto 0);		
           BC0N : in std_logic_vector(1 downto 0);		
           BC0P : in std_logic_vector(1 downto 0);					  
           BC0Q : in std_logic_vector(1 downto 0);		
           BC0R : in std_logic_vector(1 downto 0);		
           BC0S : in std_logic_vector(1 downto 0);				  

           CA : in std_logic_vector(1 downto 0);			  
           CB : in std_logic_vector(1 downto 0);					  
           CC : in std_logic_vector(1 downto 0);			  
           CD : in std_logic_vector(1 downto 0);				  
           CE : in std_logic_vector(1 downto 0);			  
           CF : in std_logic_vector(1 downto 0);					  
           CG : in std_logic_vector(1 downto 0);			  
           CH : in std_logic_vector(1 downto 0);	
           CI : in std_logic_vector(1 downto 0);	
           CJ : in std_logic_vector(1 downto 0);			  
           CK : in std_logic_vector(1 downto 0);					  
           CL : in std_logic_vector(1 downto 0);			  
           CM : in std_logic_vector(1 downto 0);				  
           CN : in std_logic_vector(1 downto 0);			  
           CP : in std_logic_vector(1 downto 0);					  
           CQ : in std_logic_vector(1 downto 0);			  
           CR : in std_logic_vector(1 downto 0);	
           CS : in std_logic_vector(1 downto 0);

           FFRAME : in std_logic;
			  POS : in std_logic;
           NEG : in std_logic		  
			  
 );

END ENTITY MUX64X16;

ARCHITECTURE ARC OF MUX64X16 IS

BEGIN

-- LINK 1  -- DONE
DA(0) <= (FB(11) AND CC(0) AND CC(1)) OR (FB(27) AND NOT CD(0) AND CD(1)) OR (SB(0) AND CC(0) AND NOT CC(1)) OR (SB(16) AND NOT CD(0) AND NOT CD(1)); 
DA(1) <= (FB(12) AND CC(0) AND CC(1)) OR (FB(28) AND NOT CD(0) AND CD(1)) OR (SB(1) AND CC(0) AND NOT CC(1)) OR (SB(17) AND NOT CD(0) AND NOT CD(1)); 
DA(2) <= (FB(13) AND CC(0) AND CC(1)) OR (FB(29) AND NOT CD(0) AND CD(1)) OR (SB(2) AND CC(0) AND NOT CC(1)) OR (SB(18) AND NOT CD(0) AND NOT CD(1)); 
DA(3) <= (FB(14) AND CC(0) AND CC(1)) OR (FB(30) AND NOT CD(0) AND CD(1)) OR (SB(3) AND CC(0) AND NOT CC(1)) OR (SB(19) AND NOT CD(0) AND NOT CD(1)); 
DA(4) <= (FB(7) AND CC(0) AND  CC(1)) OR (FB(23) AND NOT CD(0) AND CD(1)) OR (SB(4) AND CC(0) AND NOT CC(1)) OR (SB(20) AND NOT CD(0) AND NOT CD(1)); 
DA(5) <= (FB(8) AND CC(0) AND  CC(1)) OR (FB(24) AND NOT CD(0) AND CD(1)) OR (SB(5) AND CC(0) AND NOT CC(1)) OR (SB(21) AND NOT CD(0) AND NOT CD(1)); 
DA(6) <= (FB(9) AND CC(0) AND  CC(1)) OR (FB(25) AND NOT CD(0) AND CD(1)) OR (SB(6) AND CC(0) AND NOT CC(1)) OR (SB(22) AND NOT CD(0) AND NOT CD(1)); 
DA(7) <= (FB(10) AND CC(0) AND CC(1)) OR (FB(26) AND NOT CD(0) AND CD(1)) OR (SB(7) AND CC(0) AND NOT CC(1)) OR (SB(23) AND NOT CD(0) AND NOT CD(1)); 
DA(8) <= (FA(16) AND CB(0) AND CB(1)) OR (SB(24) AND NOT CD(0) AND CD(1)) OR (FB(0) AND CC(0) AND NOT CC(1)) OR (FB(16) AND NOT CD(0) AND NOT CD(1)); 
DA(9) <= (FA(17) AND CB(0) AND CB(1)) OR (SB(8) AND NOT CC(0) AND CC(1)) OR (FB(1) AND CC(0) AND NOT CC(1)) OR (FB(17) AND NOT CD(0) AND NOT CD(1)); 
DA(10) <= (FA(18) AND CB(0) AND CB(1)) OR (FB(31) AND NOT CD(0) AND CD(1)) OR (FB(2) AND CC(0) AND NOT CC(1)) OR (FB(18) AND NOT CD(0) AND NOT CD(1)); 
DA(11) <= (FA(19) AND CB(0) AND CB(1)) OR (FB(15) AND NOT CC(0) AND CC(1)) OR (FB(3) AND CC(0) AND NOT CC(1)) OR (FB(19) AND NOT CD(0) AND NOT CD(1)); 
DA(12) <= (FA(20) AND CB(0) AND CB(1)) OR (SB(27) AND NOT BC0D(0) AND BC0D(1)) OR (FB(4) AND CC(0) AND NOT CC(1)) OR (FB(20) AND NOT CD(0) AND NOT CD(1)); 
DA(13) <= (FA(21) AND CB(0) AND CB(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FB(5) AND CC(0) AND NOT CC(1)) OR (FB(21) AND NOT CD(0) AND NOT CD(1)); 
DA(14) <= (FA(22) AND CB(0) AND CB(1)) OR (SB(25) AND NOT CD(0) AND CD(1)) OR (FB(6) AND CC(0) AND NOT CC(1)) OR (FB(22) AND NOT CD(0) AND NOT CD(1)); 
DA(15) <= FFRAME; 

-- LINK 2  -- DONE
DB(0) <= (FC(11) AND CE(0) AND CE(1)) OR (FC(27) AND NOT CF(0) AND CF(1)) OR (SC(0) AND CE(0) AND NOT CE(1)) OR (SC(16) AND NOT CF(0) AND NOT CF(1)); 
DB(1) <= (FC(12) AND CE(0) AND CE(1)) OR (FC(28) AND NOT CF(0) AND CF(1)) OR (SC(1) AND CE(0) AND NOT CE(1)) OR (SC(17) AND NOT CF(0) AND NOT CF(1)); 
DB(2) <= (FC(13) AND CE(0) AND CE(1)) OR (FC(29) AND NOT CF(0) AND CF(1)) OR (SC(2) AND CE(0) AND NOT CE(1)) OR (SC(18) AND NOT CF(0) AND NOT CF(1)); 
DB(3) <= (FC(14) AND CE(0) AND CE(1)) OR (FC(30) AND NOT CF(0) AND CF(1)) OR (SC(3) AND CE(0) AND NOT CE(1)) OR (SC(19) AND NOT CF(0) AND NOT CF(1)); 
DB(4) <= (FC(7) AND CE(0) AND  CE(1)) OR (FC(23) AND NOT CF(0) AND CF(1)) OR (SC(4) AND CE(0) AND NOT CE(1)) OR (SC(20) AND NOT CF(0) AND NOT CF(1)); 
DB(5) <= (FC(8) AND CE(0) AND  CE(1)) OR (FC(24) AND NOT CF(0) AND CF(1)) OR (SC(5) AND CE(0) AND NOT CE(1)) OR (SC(21) AND NOT CF(0) AND NOT CF(1)); 
DB(6) <= (FC(9) AND CE(0) AND  CE(1)) OR (FC(25) AND NOT CF(0) AND CF(1)) OR (SC(6) AND CE(0) AND NOT CE(1)) OR (SC(22) AND NOT CF(0) AND NOT CF(1)); 
DB(7) <= (FC(10) AND CE(0) AND CE(1)) OR (FC(26) AND NOT CF(0) AND CF(1)) OR (SC(7) AND CE(0) AND NOT CE(1)) OR (SC(23) AND NOT CF(0) AND NOT CF(1)); 
DB(8) <= (FA(0) AND CA(0) AND  CA(1)) OR (SC(24) AND NOT CF(0) AND CF(1)) OR (FC(0) AND CE(0) AND NOT CE(1)) OR (FC(16) AND NOT CF(0) AND NOT CF(1)); 
DB(9) <= (FA(1) AND CA(0) AND  CA(1)) OR (SC(8) AND NOT CE(0) AND CE(1)) OR (FC(1) AND CE(0) AND NOT CE(1)) OR (FC(17) AND NOT CF(0) AND NOT CF(1)); 
DB(10) <= (FA(2) AND CA(0) AND CA(1)) OR (FC(31) AND NOT CF(0) AND CF(1)) OR (FC(2) AND CE(0) AND NOT CE(1)) OR (FC(18) AND NOT CF(0) AND NOT CF(1)); 
DB(11) <= (FA(3) AND CA(0) AND CA(1)) OR (FC(15) AND NOT CE(0) AND CE(1)) OR (FC(3) AND CE(0) AND NOT CE(1)) OR (FC(19) AND NOT CF(0) AND NOT CF(1)); 
DB(12) <= (FA(4) AND CA(0) AND CA(1)) OR (SC(27) AND NOT BC0F(0) AND BC0F(1)) OR (FC(4) AND CE(0) AND NOT CE(1)) OR (FC(20) AND NOT CF(0) AND NOT CF(1)); 
DB(13) <= (FA(5) AND CA(0) AND CA(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FC(5) AND CE(0) AND NOT CE(1)) OR (FC(21) AND NOT CF(0) AND NOT CF(1)); 
DB(14) <= (FA(6) AND CA(0) AND CA(1)) OR (SC(25) AND NOT CF(0) AND CF(1)) OR (FC(6) AND CE(0) AND NOT CE(1)) OR (FC(22) AND NOT CF(0) AND NOT CF(1)); 
DB(15) <= FFRAME; 

-- LINK 3   -- DONE
DC(0) <= (FDD(11) AND CG(0) AND CG(1)) OR (FDD(27) AND NOT CH(0) AND CH(1)) OR (SD(0) AND CG(0) AND NOT CG(1)) OR (SD(16) AND NOT CH(0) AND NOT CH(1)); 
DC(1) <= (FDD(12) AND CG(0) AND CG(1)) OR (FDD(28) AND NOT CH(0) AND CH(1)) OR (SD(1) AND CG(0) AND NOT CG(1)) OR (SD(17) AND NOT CH(0) AND NOT CH(1)); 
DC(2) <= (FDD(13) AND CG(0) AND CG(1)) OR (FDD(29) AND NOT CH(0) AND CH(1)) OR (SD(2) AND CG(0) AND NOT CG(1)) OR (SD(18) AND NOT CH(0) AND NOT CH(1)); 
DC(3) <= (FDD(14) AND CG(0) AND CG(1)) OR (FDD(30) AND NOT CH(0) AND CH(1)) OR (SD(3) AND CG(0) AND NOT CG(1)) OR (SD(19) AND NOT CH(0) AND NOT CH(1)); 
DC(4) <= (FDD(7) AND CG(0) AND CG(1)) OR (FDD(23) AND NOT CH(0) AND CH(1)) OR (SD(4) AND CG(0) AND NOT CG(1)) OR (SD(20) AND NOT CH(0) AND NOT CH(1)); 
DC(5) <= (FDD(8) AND CG(0) AND  CG(1)) OR (FDD(24) AND NOT CH(0) AND CH(1)) OR (SD(5) AND CG(0) AND NOT CG(1)) OR (SD(21) AND NOT CH(0) AND NOT CH(1)); 
DC(6) <= (FDD(9) AND CG(0) AND  CG(1)) OR (FDD(25) AND NOT CH(0) AND CH(1)) OR (SD(6) AND CG(0) AND NOT CG(1)) OR (SD(22) AND NOT CH(0) AND NOT CH(1)); 
DC(7) <= (FDD(10) AND CG(0) AND CG(1)) OR (FDD(26) AND NOT CH(0) AND CH(1)) OR (SD(7) AND CG(0) AND NOT CG(1)) OR (SD(23) AND NOT CH(0) AND NOT CH(1)); 
DC(8) <= (SA(16) AND CB(0) AND CB(1)) OR (SD(24) AND NOT CH(0) AND CH(1)) OR (FDD(0) AND CG(0) AND NOT CG(1)) OR (FDD(16) AND NOT CH(0) AND NOT CH(1)); 
DC(9) <= (SA(17) AND CB(0) AND CB(1)) OR (SD(8) AND NOT CG(0) AND CG(1)) OR (FDD(1) AND CG(0) AND NOT CG(1)) OR (FDD(17) AND NOT CH(0) AND NOT CH(1)); 
DC(10) <= (SA(18) AND CB(0) AND CB(1)) OR (FDD(31) AND NOT CH(0) AND CH(1)) OR (FDD(2) AND CG(0) AND NOT CG(1)) OR (FDD(18) AND NOT CH(0) AND NOT CH(1)); 
DC(11) <= (SA(19) AND CB(0) AND CB(1)) OR (FDD(15) AND NOT CG(0) AND CG(1)) OR (FDD(3) AND CG(0) AND NOT CG(1)) OR (FDD(19) AND NOT CH(0) AND NOT CH(1)); 
DC(12) <= (SA(20) AND CB(0) AND CB(1)) OR (SD(27) AND NOT BC0H(0) AND BC0H(1)) OR (FDD(4) AND CG(0) AND NOT CG(1)) OR (FDD(20) AND NOT CH(0) AND NOT CH(1)); 
DC(13) <= (SA(21) AND CB(0) AND CB(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FDD(5) AND CG(0) AND NOT CG(1)) OR (FDD(21) AND NOT CH(0) AND NOT CH(1)); 
DC(14) <= (SA(22) AND CB(0) AND CB(1)) OR (SD(25) AND NOT CH(0) AND CH(1)) OR (FDD(6) AND CG(0) AND NOT CG(1)) OR (FDD(22) AND NOT CH(0) AND NOT CH(1)); 
DC(15) <= FFRAME; 

-- LINK 4 -- DONE
DD(0) <= (FE(11) AND CI(0) AND CI(1)) OR (FE(27) AND NOT CJ(0) AND CJ(1)) OR (SE(0) AND CI(0) AND NOT CI(1)) OR (SE(16) AND NOT CJ(0) AND NOT CJ(1)); 
DD(1) <= (FE(12) AND CI(0) AND CI(1)) OR (FE(28) AND NOT CJ(0) AND CJ(1)) OR (SE(1) AND CI(0) AND NOT CI(1)) OR (SE(17) AND NOT CJ(0) AND NOT CJ(1)); 
DD(2) <= (FE(13) AND CI(0) AND CI(1)) OR (FE(29) AND NOT CJ(0) AND CJ(1)) OR (SE(2) AND CI(0) AND NOT CI(1)) OR (SE(18) AND NOT CJ(0) AND NOT CJ(1)); 
DD(3) <= (FE(14) AND CI(0) AND CI(1)) OR (FE(30) AND NOT CJ(0) AND CJ(1)) OR (SE(3) AND CI(0) AND NOT CI(1)) OR (SE(19) AND NOT CJ(0) AND NOT CJ(1)); 
DD(4) <= (FE(7) AND CI(0) AND CI(1)) OR (FE(23) AND NOT CJ(0) AND CJ(1)) OR (SE(4) AND CI(0) AND NOT CI(1)) OR (SE(20) AND NOT CJ(0) AND NOT CJ(1)); 
DD(5) <= (FE(8) AND CI(0) AND CI(1)) OR (FE(24) AND NOT CJ(0) AND CJ(1)) OR (SE(5) AND CI(0) AND NOT CI(1)) OR (SE(21) AND NOT CJ(0) AND NOT CJ(1)); 
DD(6) <= (FE(9) AND CI(0) AND CI(1)) OR (FE(25) AND NOT CJ(0) AND CJ(1)) OR (SE(6) AND CI(0) AND NOT CI(1)) OR (SE(22) AND NOT CJ(0) AND NOT CJ(1)); 
DD(7) <= (FE(10) AND CI(0) AND CI(1)) OR (FE(26) AND NOT CJ(0) AND CJ(1)) OR (SE(7) AND CI(0) AND NOT CI(1)) OR (SE(23) AND NOT CJ(0) AND NOT CJ(1)); 
DD(8) <= (SA(0) AND CA(0) AND CA(1)) OR (SE(24) AND NOT CJ(0) AND CJ(1)) OR (FE(0) AND CI(0) AND NOT CI(1)) OR (FE(16) AND NOT CJ(0) AND NOT CJ(1)); 
DD(9) <= (SA(1) AND CA(0) AND CA(1)) OR (SE(8) AND NOT CI(0) AND CI(1)) OR (FE(1) AND CI(0) AND NOT CI(1)) OR (FE(17) AND NOT CJ(0) AND NOT CJ(1)); 
DD(10) <= (SA(2) AND CA(0) AND CA(1)) OR (FE(31) AND NOT CJ(0) AND CJ(1)) OR (FE(2) AND CI(0) AND NOT CI(1)) OR (FE(18) AND NOT CJ(0) AND NOT CJ(1)); 
DD(11) <= (SA(3) AND CA(0) AND CA(1)) OR (FE(15) AND NOT CI(0) AND CI(1)) OR (FE(3) AND CI(0) AND NOT CI(1)) OR (FE(19) AND NOT CJ(0) AND NOT CJ(1)); 
DD(12) <= (SA(4) AND CA(0) AND CA(1)) OR (SE(27) AND NOT BC0J(0) AND BC0J(1)) OR (FE(4) AND CI(0) AND NOT CI(1)) OR (FE(20) AND NOT CJ(0) AND NOT CJ(1)); 
DD(13) <= (SA(5) AND CA(0) AND CA(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FE(5) AND CI(0) AND NOT CI(1)) OR (FE(21) AND NOT CJ(0) AND NOT CJ(1)); 
DD(14) <= (SA(6) AND CA(0) AND CA(1)) OR (SE(25) AND NOT CJ(0) AND CJ(1)) OR (FE(6) AND CI(0) AND NOT CI(1)) OR (FE(22) AND NOT CJ(0) AND NOT CJ(1)); 
DD(15) <= FFRAME; 

-- LINK 5 -- DONE
DE(0) <= (FF(11) AND CK(0) AND CK(1)) OR (FF(27) AND NOT CL(0) AND CL(1)) OR (SF(0) AND CK(0) AND NOT CK(1)) OR (SF(16) AND NOT CL(0) AND NOT CL(1)); 
DE(1) <= (FF(12) AND CK(0) AND CK(1)) OR (FF(28) AND NOT CL(0) AND CL(1)) OR (SF(1) AND CK(0) AND NOT CK(1)) OR (SF(17) AND NOT CL(0) AND NOT CL(1)); 
DE(2) <= (FF(13) AND CK(0) AND CK(1)) OR (FF(29) AND NOT CL(0) AND CL(1)) OR (SF(2) AND CK(0) AND NOT CK(1)) OR (SF(18) AND NOT CL(0) AND NOT CL(1)); 
DE(3) <= (FF(14) AND CK(0) AND CK(1)) OR (FF(30) AND NOT CL(0) AND CL(1)) OR (SF(3) AND CK(0) AND NOT CK(1)) OR (SF(19) AND NOT CL(0) AND NOT CL(1)); 
DE(4) <= (FF(7) AND CK(0) AND CK(1)) OR (FF(23) AND NOT CL(0) AND CL(1)) OR (SF(4) AND CK(0) AND NOT CK(1)) OR (SF(20) AND NOT CL(0) AND NOT CL(1)); 
DE(5) <= (FF(8) AND CK(0) AND CK(1)) OR (FF(24) AND NOT CL(0) AND CL(1)) OR (SF(5) AND CK(0) AND NOT CK(1)) OR (SF(21) AND NOT CL(0) AND NOT CL(1)); 
DE(6) <= (FF(9) AND CK(0) AND CK(1)) OR (FF(25) AND NOT CL(0) AND CL(1)) OR (SF(6) AND CK(0) AND NOT CK(1)) OR (SF(22) AND NOT CL(0) AND NOT CL(1)); 
DE(7) <= (FF(10) AND CK(0) AND CK(1)) OR (FF(26) AND NOT CL(0) AND CL(1)) OR (SF(7) AND CK(0) AND NOT CK(1)) OR (SF(23) AND NOT CL(0) AND NOT CL(1)); 
DE(8) <= (FA(27) AND CB(0) AND CB(1)) OR (SF(24) AND NOT CL(0) AND CL(1)) OR (FF(0) AND CK(0) AND NOT CK(1)) OR (FF(16) AND NOT CL(0) AND NOT CL(1)); 
DE(9) <= (FA(28) AND CB(0) AND CB(1)) OR (SF(8) AND NOT CK(0) AND CK(1)) OR (FF(1) AND CK(0) AND NOT CK(1)) OR (FF(17) AND NOT CL(0) AND NOT CL(1)); 
DE(10) <= (FA(29) AND CB(0) AND CB(1)) OR (FF(31) AND NOT CL(0) AND CL(1)) OR (FF(2) AND CK(0) AND NOT CK(1)) OR (FF(18) AND NOT CL(0) AND NOT CL(1)); 
DE(11) <= (FA(30) AND CB(0) AND CB(1)) OR (FF(15) AND NOT CK(0) AND CK(1)) OR (FF(3) AND CK(0) AND NOT CK(1)) OR (FF(19) AND NOT CL(0) AND NOT CL(1)); 
DE(12) <= (SA(24) AND CB(0) AND CB(1)) OR (SF(27) AND NOT BC0L(0) AND BC0L(1)) OR (FF(4) AND CK(0) AND NOT CK(1)) OR (FF(20) AND NOT CL(0) AND NOT CL(1)); 
DE(13) <= (FA(31) AND CB(0) AND CB(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FF(5) AND CK(0) AND NOT CK(1)) OR (FF(21) AND NOT CL(0) AND NOT CL(1)); 
DE(14) <= (SA(23) AND CB(0) AND CB(1)) OR (SF(25) AND NOT CL(0) AND CL(1)) OR (FF(6) AND CK(0) AND NOT CK(1)) OR (FF(22) AND NOT CL(0) AND NOT CL(1)); 
DE(15) <= FFRAME; 

-- LINK 6 -- DONE
DF(0) <= (FG(11) AND CM(0) AND CM(1)) OR (FG(27) AND NOT CN(0) AND CN(1)) OR (SG(0) AND CM(0) AND NOT CM(1)) OR (SG(16) AND NOT CN(0) AND NOT CN(1)); 
DF(1) <= (FG(12) AND CM(0) AND CM(1)) OR (FG(28) AND NOT CN(0) AND CN(1)) OR (SG(1) AND CM(0) AND NOT CM(1)) OR (SG(17) AND NOT CN(0) AND NOT CN(1)); 
DF(2) <= (FG(13) AND CM(0) AND CM(1)) OR (FG(29) AND NOT CN(0) AND CN(1)) OR (SG(2) AND CM(0) AND NOT CM(1)) OR (SG(18) AND NOT CN(0) AND NOT CN(1)); 
DF(3) <= (FG(14) AND CM(0) AND CM(1)) OR (FG(30) AND NOT CN(0) AND CN(1)) OR (SG(3) AND CM(0) AND NOT CM(1)) OR (SG(19) AND NOT CN(0) AND NOT CN(1)); 
DF(4) <= (FG(7) AND CM(0) AND CM(1)) OR (FG(23) AND NOT CN(0) AND CN(1)) OR (SG(4) AND CM(0) AND NOT CM(1)) OR (SG(20) AND NOT CN(0) AND NOT CN(1)); 
DF(5) <= (FG(8) AND CM(0) AND CM(1)) OR (FG(24) AND NOT CN(0) AND CN(1)) OR (SG(5) AND CM(0) AND NOT CM(1)) OR (SG(21) AND NOT CN(0) AND NOT CN(1)); 
DF(6) <= (FG(9) AND CM(0) AND CM(1)) OR (FG(25) AND NOT CN(0) AND CN(1)) OR (SG(6) AND CM(0) AND NOT CM(1)) OR (SG(22) AND NOT CN(0) AND NOT CN(1)); 
DF(7) <= (FG(10) AND CM(0) AND CM(1)) OR (FG(26) AND NOT CN(0) AND CN(1)) OR (SG(7) AND CM(0) AND NOT CM(1)) OR (SG(23) AND NOT CN(0) AND NOT CN(1)); 
DF(8) <= (FA(11) AND CA(0) AND CA(1)) OR (SG(24) AND NOT CN(0) AND CN(1)) OR (FG(0) AND CM(0) AND NOT CM(1)) OR (FG(16) AND NOT CN(0) AND NOT CN(1)); 
DF(9) <= (FA(12) AND CA(0) AND CA(1)) OR (SG(8) AND NOT CM(0) AND CM(1)) OR (FG(1) AND CM(0) AND NOT CM(1)) OR (FG(17) AND NOT CN(0) AND NOT CN(1)); 
DF(10) <= (FA(13) AND CA(0) AND CA(1)) OR (FG(31) AND NOT CN(0) AND CN(1)) OR (FG(2) AND CM(0) AND NOT CM(1)) OR (FG(18) AND NOT CN(0) AND NOT CN(1)); 
DF(11) <= (FA(14) AND CA(0) AND CA(1)) OR (FG(15) AND NOT CM(0) AND CM(1)) OR (FG(3) AND CM(0) AND NOT CM(1)) OR (FG(19) AND NOT CN(0) AND NOT CN(1)); 
DF(12) <= (SA(8) AND CA(0) AND CA(1)) OR (SG(27) AND NOT BC0N(0) AND BC0N(1)) OR (FG(4) AND CM(0) AND NOT CM(1)) OR (FG(20) AND NOT CN(0) AND NOT CN(1)); 
DF(13) <= (FA(15) AND CA(0) AND CA(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FG(5) AND CM(0) AND NOT CM(1)) OR (FG(21) AND NOT CN(0) AND NOT CN(1)); 
DF(14) <= (SA(7) AND CA(0) AND CA(1)) OR (SG(25) AND NOT CN(0) AND CN(1)) OR (FG(6) AND CM(0) AND NOT CM(1)) OR (FG(22) AND NOT CN(0) AND NOT CN(1)); 
DF(15) <= FFRAME; 

-- LINK 7 -- DONE
DG(0) <= (FH(11) AND CP(0) AND CP(1)) OR (FH(27) AND NOT CQ(0) AND CQ(1)) OR (SH(0) AND CP(0) AND NOT CP(1)) OR (SH(16) AND NOT CQ(0) AND NOT CQ(1)); 
DG(1) <= (FH(12) AND CP(0) AND CP(1)) OR (FH(28) AND NOT CQ(0) AND CQ(1)) OR (SH(1) AND CP(0) AND NOT CP(1)) OR (SH(17) AND NOT CQ(0) AND NOT CQ(1)); 
DG(2) <= (FH(13) AND CP(0) AND CP(1)) OR (FH(29) AND NOT CQ(0) AND CQ(1)) OR (SH(2) AND CP(0) AND NOT CP(1)) OR (SH(18) AND NOT CQ(0) AND NOT CQ(1)); 
DG(3) <= (FH(14) AND CP(0) AND CP(1)) OR (FH(30) AND NOT CQ(0) AND CQ(1)) OR (SH(3) AND CP(0) AND NOT CP(1)) OR (SH(19) AND NOT CQ(0) AND NOT CQ(1)); 
DG(4) <= (FH(7) AND CP(0) AND CP(1)) OR (FH(23) AND NOT CQ(0) AND CQ(1)) OR (SH(4) AND CP(0) AND NOT CP(1)) OR (SH(20) AND NOT CQ(0) AND NOT CQ(1)); 
DG(5) <= (FH(8) AND CP(0) AND CP(1)) OR (FH(24) AND NOT CQ(0) AND CQ(1)) OR (SH(5) AND CP(0) AND NOT CP(1)) OR (SH(21) AND NOT CQ(0) AND NOT CQ(1)); 
DG(6) <= (FH(9) AND CP(0) AND CP(1)) OR (FH(25) AND NOT CQ(0) AND CQ(1)) OR (SH(6) AND CP(0) AND NOT CP(1)) OR (SH(22) AND NOT CQ(0) AND NOT CQ(1)); 
DG(7) <= (FH(10) AND CP(0) AND CP(1)) OR (FH(26) AND NOT CQ(0) AND CQ(1)) OR (SH(7) AND CP(0) AND NOT CP(1)) OR (SH(23) AND NOT CQ(0) AND NOT CQ(1)); 
DG(8) <= (FA(23) AND CB(0) AND CB(1)) OR (SH(24) AND NOT CQ(0) AND CQ(1)) OR (FH(0) AND CP(0) AND NOT CP(1)) OR (FH(16) AND NOT CQ(0) AND NOT CQ(1)); 
DG(9) <= (FA(24) AND CB(0) AND CB(1)) OR (SH(8) AND NOT CP(0) AND CP(1)) OR (FH(1) AND CP(0) AND NOT CP(1)) OR (FH(17) AND NOT CQ(0) AND NOT CQ(1)); 
DG(10) <= (FA(25) AND CB(0) AND CB(1)) OR (FH(31) AND NOT CQ(0) AND CQ(1)) OR (FH(2) AND CP(0) AND NOT CP(1)) OR (FH(18) AND NOT CQ(0) AND NOT CQ(1)); 
DG(11) <= (FA(26) AND CB(0) AND CB(1)) OR (FH(15) AND NOT CP(0) AND CP(1)) OR (FH(3) AND CP(0) AND NOT CP(1)) OR (FH(19) AND NOT CQ(0) AND NOT CQ(1)); 
DG(12) <= (SA(27) AND BC0B(0) AND BC0B(1)) OR (SH(27) AND NOT BC0Q(0) AND BC0Q(1)) OR (FH(4) AND CP(0) AND NOT CP(1)) OR (FH(20) AND NOT CQ(0) AND NOT CQ(1)); 
DG(13) <= (SA(26) AND CB(0) AND CB(1)) OR  (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FH(5) AND CP(0) AND NOT CP(1)) OR (FH(21) AND NOT CQ(0) AND NOT CQ(1)); 
DG(14) <= (SA(25) AND CB(0) AND CB(1)) OR (SH(25) AND NOT CQ(0) AND CQ(1)) OR (FH(6) AND CP(0) AND NOT CP(1)) OR (FH(22) AND NOT CQ(0) AND NOT CQ(1)); 
DG(15) <= FFRAME; 

-- LINK 8 -- DONE
DH(0) <= (FI(11) AND CR(0) AND CR(1)) OR (FI(27) AND NOT CS(0) AND CS(1)) OR (SI(0) AND CR(0) AND NOT CR(1)) OR (SI(16) AND NOT CS(0) AND NOT CS(1)); 
DH(1) <= (FI(12) AND CR(0) AND CR(1)) OR (FI(28) AND NOT CS(0) AND CS(1)) OR (SI(1) AND CR(0) AND NOT CR(1)) OR (SI(17) AND NOT CS(0) AND NOT CS(1)); 
DH(2) <= (FI(13) AND CR(0) AND CR(1)) OR (FI(29) AND NOT CS(0) AND CS(1)) OR (SI(2) AND CR(0) AND NOT CR(1)) OR (SI(18) AND NOT CS(0) AND NOT CS(1)); 
DH(3) <= (FI(14) AND CR(0) AND CR(1)) OR (FI(30) AND NOT CS(0) AND CS(1)) OR (SI(3) AND CR(0) AND NOT CR(1)) OR (SI(19) AND NOT CS(0) AND NOT CS(1)); 
DH(4) <= (FI(7) AND CR(0) AND CR(1)) OR (FI(23) AND NOT CS(0) AND CS(1)) OR (SI(4) AND CR(0) AND NOT CR(1)) OR (SI(20) AND NOT CS(0) AND NOT CS(1)); 
DH(5) <= (FI(8) AND CR(0) AND CR(1)) OR (FI(24) AND NOT CS(0) AND CS(1)) OR (SI(5) AND CR(0) AND NOT CR(1)) OR (SI(21) AND NOT CS(0) AND NOT CS(1)); 
DH(6) <= (FI(9) AND CR(0) AND CR(1)) OR (FI(25) AND NOT CS(0) AND CS(1)) OR (SI(6) AND CR(0) AND NOT CR(1)) OR (SI(22) AND NOT CS(0) AND NOT CS(1)); 
DH(7) <= (FI(10) AND CR(0) AND CR(1)) OR (FI(26) AND NOT CS(0) AND CS(1)) OR (SI(7) AND CR(0) AND NOT CR(1)) OR (SI(23) AND NOT CS(0) AND NOT CS(1)); 
DH(8) <= (FA(7) AND CA(0) AND CA(1)) OR (SI(24) AND NOT CS(0) AND CS(1)) OR (FI(0) AND CR(0) AND NOT CR(1)) OR (FI(16) AND NOT CS(0) AND NOT CS(1)); 
DH(9) <= (FA(8) AND CA(0) AND CA(1)) OR (SI(8) AND NOT CR(0) AND CR(1)) OR (FI(1) AND CR(0) AND NOT CR(1)) OR (FI(17) AND NOT CS(0) AND NOT CS(1)); 
DH(10) <= (FA(9) AND CA(0) AND CA(1)) OR (FI(31) AND NOT CS(0) AND CS(1)) OR (FI(2) AND CR(0) AND NOT CR(1)) OR (FI(18) AND NOT CS(0) AND NOT CS(1)); 
DH(11) <= (FA(10) AND CA(0) AND CA(1)) OR (FI(15) AND NOT CR(0) AND CR(1)) OR (FI(3) AND CR(0) AND NOT CR(1)) OR (FI(19) AND NOT CS(0) AND NOT CS(1)); 
DH(12) <= (NEG AND CA(0) AND CA(1)) OR (SI(27) AND NOT BC0S(0) AND BC0S(1)) OR (FI(4) AND CR(0) AND NOT CR(1)) OR (FI(20) AND NOT CS(0) AND NOT CS(1)); 
DH(13) <= (NEG AND CA(0) AND CA(1)) OR (SA(27) AND NOT BC0B(0) AND BC0B(1)) OR (FI(5) AND CR(0) AND NOT CR(1)) OR (FI(21) AND NOT CS(0) AND NOT CS(1)); 
DH(14) <= (NEG AND CA(0) AND CA(1)) OR (SI(25) AND NOT CS(0) AND CS(1)) OR (FI(6) AND CR(0) AND NOT CR(1)) OR (FI(22) AND NOT CS(0) AND NOT CS(1)); 
DH(15) <= FFRAME; 

END ARC;
