////////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /    Vendor: Xilinx
// \   \   \/     Version : 1.7
//  \   \         Application : Spartan-6 FPGA GTP Transceiver Wizard
//  /   /         Filename : ser16_top.v
// /___/   /\     Timestamp :
// \   \  /  \ 
//  \___\/\___\
//
//
// Module SER16_TOP
// Generated by Xilinx Spartan-6 FPGA GTP Transceiver Wizard
// 
// 
// (c) Copyright 2009 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES. 


`timescale 1ns / 1ps
`define DLY #1


//***********************************Entity Declaration************************

module SER16_TOP #
(
    parameter EXAMPLE_CONFIG_INDEPENDENT_LANES          =   1,   //configuration for frame gen and check
    parameter EXAMPLE_LANE_WITH_START_CHAR              =   0,   // specifies lane with unique start frame char
    parameter EXAMPLE_WORDS_IN_BRAM                     =   512, // specifies amount of data in BRAM   
    parameter EXAMPLE_SIM_GTPRESET_SPEEDUP              =   1,   // simulation setting for GTP SecureIP model
    parameter EXAMPLE_USE_CHIPSCOPE                     =   1,    // Set to 1 to use Chipscope to drive resets
    parameter EXAMPLE_SIMULATION                        =   0    // Set to 1 in testbench for simulation
)
(
    input  wire          TILE0_GTP0_REFCLK_PAD_N_IN,
    input  wire          TILE0_GTP0_REFCLK_PAD_P_IN,
    input  wire          TILE1_GTP0_REFCLK_PAD_N_IN,
    input  wire          TILE1_GTP0_REFCLK_PAD_P_IN,
    input  wire          TILE2_GTP0_REFCLK_PAD_N_IN,
    input  wire          TILE2_GTP0_REFCLK_PAD_P_IN,
    input  wire          TILE3_GTP0_REFCLK_PAD_N_IN,
    input  wire          TILE3_GTP0_REFCLK_PAD_P_IN,
    input  wire          GTP0_RESET_IN,
    input  wire          GTP1_RESET_IN,
    output wire          TILE0_GTP0_PLLLKDET_OUT,
    output wire          TILE1_GTP0_PLLLKDET_OUT,
    output wire          TILE2_GTP0_PLLLKDET_OUT,
    output wire          TILE3_GTP0_PLLLKDET_OUT,
    output wire          TRACK_DATA_OUT,
    input  wire  [7:0]   RXN_IN,
    input  wire  [7:0]   RXP_IN,
    output wire  [7:0]   TXN_OUT,
    output wire  [7:0]   TXP_OUT
);

    
//************************** Register Declarations ****************************

    reg     [84:0]  ila_in0_r;
    reg     [84:0]  ila_in1_r;
    reg             tile0_resetdone0_r;
    reg             tile0_resetdone0_r2;
    reg             tile0_resetdone1_r;
    reg             tile0_resetdone1_r2;
    reg             tile1_resetdone0_r;
    reg             tile1_resetdone0_r2;
    reg             tile1_resetdone1_r;
    reg             tile1_resetdone1_r2;
    reg             tile2_resetdone0_r;
    reg             tile2_resetdone0_r2;
    reg             tile2_resetdone1_r;
    reg             tile2_resetdone1_r2;
    reg             tile3_resetdone0_r;
    reg             tile3_resetdone0_r2;
    reg             tile3_resetdone1_r;
    reg             tile3_resetdone1_r2;
    

//**************************** Wire Declarations ******************************

    //------------------------ MGT Wrapper Wires ------------------------------

    //________________________________________________________________________
    //________________________________________________________________________
    //TILE0   (X0_Y0)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [2:0]   tile0_loopback0_i;
    wire    [2:0]   tile0_loopback1_i;
    //------------------------------- PLL Ports --------------------------------
    wire            tile0_gtpreset0_i;
    wire            tile0_gtpreset1_i;
    wire            tile0_plllkdet0_i;
    wire            tile0_plllkdet1_i;
    wire            tile0_resetdone0_i;
    wire            tile0_resetdone1_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   tile0_rxdisperr0_i;
    wire    [1:0]   tile0_rxdisperr1_i;
    wire    [1:0]   tile0_rxnotintable0_i;
    wire    [1:0]   tile0_rxnotintable1_i;
    //--------------------- Receive Ports - PRBS Detection ---------------------
    wire            tile0_prbscntreset0_i;
    wire            tile0_prbscntreset1_i;
    wire    [2:0]   tile0_rxenprbstst0_i;
    wire    [2:0]   tile0_rxenprbstst1_i;
    wire            tile0_rxprbserr0_i;
    wire            tile0_rxprbserr1_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  tile0_rxdata0_i;
    wire    [15:0]  tile0_rxdata1_i;
    wire            tile0_rxrecclk0_i;
    wire            tile0_rxrecclk1_i;
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    wire    [1:0]   tile0_rxeqmix0_i;
    wire    [1:0]   tile0_rxeqmix1_i;
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    wire            tile0_rxenpmaphasealign0_i;
    wire            tile0_rxenpmaphasealign1_i;
    wire            tile0_rxpmasetphase0_i;
    wire            tile0_rxpmasetphase1_i;
    //-------------------------- TX/RX Datapath Ports --------------------------
    wire    [1:0]   tile0_gtpclkfbeast_i;
    wire    [1:0]   tile0_gtpclkfbwest_i;
    wire    [1:0]   tile0_gtpclkout0_i;
    wire    [1:0]   tile0_gtpclkout1_i;
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    wire    [1:0]   tile0_txcharisk0_i;
    wire    [1:0]   tile0_txcharisk1_i;
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    wire            tile0_txenpmaphasealign0_i;
    wire            tile0_txenpmaphasealign1_i;
    wire            tile0_txpmasetphase0_i;
    wire            tile0_txpmasetphase1_i;
    //---------------- Transmit Ports - TX Data Path interface -----------------
    wire    [15:0]  tile0_txdata0_i;
    wire    [15:0]  tile0_txdata1_i;
    wire            tile0_txoutclk0_i;
    wire            tile0_txoutclk1_i;
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    wire    [2:0]   tile0_txenprbstst0_i;
    wire    [2:0]   tile0_txenprbstst1_i;



    //________________________________________________________________________
    //________________________________________________________________________
    //TILE1   (X1_Y0)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [2:0]   tile1_loopback0_i;
    wire    [2:0]   tile1_loopback1_i;
    //------------------------------- PLL Ports --------------------------------
    wire            tile1_gtpreset0_i;
    wire            tile1_gtpreset1_i;
    wire            tile1_plllkdet0_i;
    wire            tile1_plllkdet1_i;
    wire            tile1_resetdone0_i;
    wire            tile1_resetdone1_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   tile1_rxdisperr0_i;
    wire    [1:0]   tile1_rxdisperr1_i;
    wire    [1:0]   tile1_rxnotintable0_i;
    wire    [1:0]   tile1_rxnotintable1_i;
    //--------------------- Receive Ports - PRBS Detection ---------------------
    wire            tile1_prbscntreset0_i;
    wire            tile1_prbscntreset1_i;
    wire    [2:0]   tile1_rxenprbstst0_i;
    wire    [2:0]   tile1_rxenprbstst1_i;
    wire            tile1_rxprbserr0_i;
    wire            tile1_rxprbserr1_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  tile1_rxdata0_i;
    wire    [15:0]  tile1_rxdata1_i;
    wire            tile1_rxrecclk0_i;
    wire            tile1_rxrecclk1_i;
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    wire    [1:0]   tile1_rxeqmix0_i;
    wire    [1:0]   tile1_rxeqmix1_i;
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    wire            tile1_rxenpmaphasealign0_i;
    wire            tile1_rxenpmaphasealign1_i;
    wire            tile1_rxpmasetphase0_i;
    wire            tile1_rxpmasetphase1_i;
    //-------------------------- TX/RX Datapath Ports --------------------------
    wire    [1:0]   tile1_gtpclkfbeast_i;
    wire    [1:0]   tile1_gtpclkfbwest_i;
    wire    [1:0]   tile1_gtpclkout0_i;
    wire    [1:0]   tile1_gtpclkout1_i;
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    wire    [1:0]   tile1_txcharisk0_i;
    wire    [1:0]   tile1_txcharisk1_i;
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    wire            tile1_txenpmaphasealign0_i;
    wire            tile1_txenpmaphasealign1_i;
    wire            tile1_txpmasetphase0_i;
    wire            tile1_txpmasetphase1_i;
    //---------------- Transmit Ports - TX Data Path interface -----------------
    wire    [15:0]  tile1_txdata0_i;
    wire    [15:0]  tile1_txdata1_i;
    wire            tile1_txoutclk0_i;
    wire            tile1_txoutclk1_i;
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    wire    [2:0]   tile1_txenprbstst0_i;
    wire    [2:0]   tile1_txenprbstst1_i;



    //________________________________________________________________________
    //________________________________________________________________________
    //TILE2   (X0_Y1)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [2:0]   tile2_loopback0_i;
    wire    [2:0]   tile2_loopback1_i;
    //------------------------------- PLL Ports --------------------------------
    wire            tile2_gtpreset0_i;
    wire            tile2_gtpreset1_i;
    wire            tile2_plllkdet0_i;
    wire            tile2_plllkdet1_i;
    wire            tile2_resetdone0_i;
    wire            tile2_resetdone1_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   tile2_rxdisperr0_i;
    wire    [1:0]   tile2_rxdisperr1_i;
    wire    [1:0]   tile2_rxnotintable0_i;
    wire    [1:0]   tile2_rxnotintable1_i;
    //--------------------- Receive Ports - PRBS Detection ---------------------
    wire            tile2_prbscntreset0_i;
    wire            tile2_prbscntreset1_i;
    wire    [2:0]   tile2_rxenprbstst0_i;
    wire    [2:0]   tile2_rxenprbstst1_i;
    wire            tile2_rxprbserr0_i;
    wire            tile2_rxprbserr1_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  tile2_rxdata0_i;
    wire    [15:0]  tile2_rxdata1_i;
    wire            tile2_rxrecclk0_i;
    wire            tile2_rxrecclk1_i;
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    wire    [1:0]   tile2_rxeqmix0_i;
    wire    [1:0]   tile2_rxeqmix1_i;
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    wire            tile2_rxenpmaphasealign0_i;
    wire            tile2_rxenpmaphasealign1_i;
    wire            tile2_rxpmasetphase0_i;
    wire            tile2_rxpmasetphase1_i;
    //-------------------------- TX/RX Datapath Ports --------------------------
    wire    [1:0]   tile2_gtpclkfbeast_i;
    wire    [1:0]   tile2_gtpclkfbwest_i;
    wire    [1:0]   tile2_gtpclkout0_i;
    wire    [1:0]   tile2_gtpclkout1_i;
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    wire    [1:0]   tile2_txcharisk0_i;
    wire    [1:0]   tile2_txcharisk1_i;
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    wire            tile2_txenpmaphasealign0_i;
    wire            tile2_txenpmaphasealign1_i;
    wire            tile2_txpmasetphase0_i;
    wire            tile2_txpmasetphase1_i;
    //---------------- Transmit Ports - TX Data Path interface -----------------
    wire    [15:0]  tile2_txdata0_i;
    wire    [15:0]  tile2_txdata1_i;
    wire            tile2_txoutclk0_i;
    wire            tile2_txoutclk1_i;
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    wire    [2:0]   tile2_txenprbstst0_i;
    wire    [2:0]   tile2_txenprbstst1_i;



    //________________________________________________________________________
    //________________________________________________________________________
    //TILE3   (X1_Y1)

    //---------------------- Loopback and Powerdown Ports ----------------------
    wire    [2:0]   tile3_loopback0_i;
    wire    [2:0]   tile3_loopback1_i;
    //------------------------------- PLL Ports --------------------------------
    wire            tile3_gtpreset0_i;
    wire            tile3_gtpreset1_i;
    wire            tile3_plllkdet0_i;
    wire            tile3_plllkdet1_i;
    wire            tile3_resetdone0_i;
    wire            tile3_resetdone1_i;
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    wire    [1:0]   tile3_rxdisperr0_i;
    wire    [1:0]   tile3_rxdisperr1_i;
    wire    [1:0]   tile3_rxnotintable0_i;
    wire    [1:0]   tile3_rxnotintable1_i;
    //--------------------- Receive Ports - PRBS Detection ---------------------
    wire            tile3_prbscntreset0_i;
    wire            tile3_prbscntreset1_i;
    wire    [2:0]   tile3_rxenprbstst0_i;
    wire    [2:0]   tile3_rxenprbstst1_i;
    wire            tile3_rxprbserr0_i;
    wire            tile3_rxprbserr1_i;
    //----------------- Receive Ports - RX Data Path interface -----------------
    wire    [15:0]  tile3_rxdata0_i;
    wire    [15:0]  tile3_rxdata1_i;
    wire            tile3_rxrecclk0_i;
    wire            tile3_rxrecclk1_i;
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    wire    [1:0]   tile3_rxeqmix0_i;
    wire    [1:0]   tile3_rxeqmix1_i;
    //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    wire            tile3_rxenpmaphasealign0_i;
    wire            tile3_rxenpmaphasealign1_i;
    wire            tile3_rxpmasetphase0_i;
    wire            tile3_rxpmasetphase1_i;
    //-------------------------- TX/RX Datapath Ports --------------------------
    wire    [1:0]   tile3_gtpclkfbeast_i;
    wire    [1:0]   tile3_gtpclkfbwest_i;
    wire    [1:0]   tile3_gtpclkout0_i;
    wire    [1:0]   tile3_gtpclkout1_i;
    //----------------- Transmit Ports - 8b10b Encoder Control -----------------
    wire    [1:0]   tile3_txcharisk0_i;
    wire    [1:0]   tile3_txcharisk1_i;
    //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    wire            tile3_txenpmaphasealign0_i;
    wire            tile3_txenpmaphasealign1_i;
    wire            tile3_txpmasetphase0_i;
    wire            tile3_txpmasetphase1_i;
    //---------------- Transmit Ports - TX Data Path interface -----------------
    wire    [15:0]  tile3_txdata0_i;
    wire    [15:0]  tile3_txdata1_i;
    wire            tile3_txoutclk0_i;
    wire            tile3_txoutclk1_i;
    //------------------- Transmit Ports - TX PRBS Generator -------------------
    wire    [2:0]   tile3_txenprbstst0_i;
    wire    [2:0]   tile3_txenprbstst1_i;


    //----------------------------- Global Signals -----------------------------
    wire            tile0_tx_system_reset0_c;
    wire            tile0_tx_system_reset1_c;
    wire            tile1_tx_system_reset0_c;
    wire            tile1_tx_system_reset1_c;
    wire            tile2_tx_system_reset0_c;
    wire            tile2_tx_system_reset1_c;
    wire            tile3_tx_system_reset0_c;
    wire            tile3_tx_system_reset1_c;
    wire            tile0_rx_system_reset0_c;
    wire            tile0_rx_system_reset1_c;
    wire            tile1_rx_system_reset0_c;
    wire            tile1_rx_system_reset1_c;
    wire            tile2_rx_system_reset0_c;
    wire            tile2_rx_system_reset1_c;
    wire            tile3_rx_system_reset0_c;
    wire            tile3_rx_system_reset1_c;
    wire            tied_to_ground_i;
    wire    [191:0] tied_to_ground_vec_i;
    wire            tied_to_vcc_i;
    wire    [7:0]   tied_to_vcc_vec_i;
    wire            drp_clk_in_i;
    wire            tile0_refclkout_bufg_i;
    
    
    //--------------------------- User Clocks ---------------------------------
    wire            tile0_txusrclk0_i;
    wire            tile0_txusrclk20_i;
    wire            tile0_rxusrclk0_i;
    wire            tile0_rxusrclk20_i;
    wire            tile0_rxusrclk1_i;
    wire            tile0_rxusrclk21_i;
    wire            tile1_txusrclk0_i;
    wire            tile1_txusrclk20_i;
    wire            tile1_rxusrclk0_i;
    wire            tile1_rxusrclk20_i;
    wire            tile1_rxusrclk1_i;
    wire            tile1_rxusrclk21_i;
    wire            tile2_txusrclk0_i;
    wire            tile2_txusrclk20_i;
    wire            tile2_rxusrclk0_i;
    wire            tile2_rxusrclk20_i;
    wire            tile2_rxusrclk1_i;
    wire            tile2_rxusrclk21_i;
    wire            tile3_txusrclk0_i;
    wire            tile3_txusrclk20_i;
    wire            tile3_rxusrclk0_i;
    wire            tile3_rxusrclk20_i;
    wire            tile3_rxusrclk1_i;
    wire            tile3_rxusrclk21_i;
    wire            gtpclkout0_0_pll0_locked_i;
    wire            gtpclkout0_0_pll0_reset_i;
    wire            tile0_gtpclkout0_0_to_cmt_i;
    wire            pll0_fb_out_i;
    wire            pll0_fb_in_i;
    wire            gtpclkout0_1_dcm1_locked_i;
    wire            gtpclkout0_1_dcm1_reset_i;
    wire            tile0_gtpclkout0_1_to_dcm_i;
    wire            dcm1_fb_in_i;
    wire            gtpclkout1_1_dcm2_locked_i;
    wire            gtpclkout1_1_dcm2_reset_i;
    wire            tile0_gtpclkout1_1_to_dcm_i;
    wire            dcm2_fb_in_i;
    wire            gtpclkout0_0_pll3_locked_i;
    wire            gtpclkout0_0_pll3_reset_i;
    wire            tile1_gtpclkout0_0_to_cmt_i;
    wire            pll3_fb_out_i;
    wire            pll3_fb_in_i;
    wire            gtpclkout0_1_dcm4_locked_i;
    wire            gtpclkout0_1_dcm4_reset_i;
    wire            tile1_gtpclkout0_1_to_dcm_i;
    wire            dcm4_fb_in_i;
    wire            gtpclkout1_1_dcm5_locked_i;
    wire            gtpclkout1_1_dcm5_reset_i;
    wire            tile1_gtpclkout1_1_to_dcm_i;
    wire            dcm5_fb_in_i;
    wire            gtpclkout0_0_pll6_locked_i;
    wire            gtpclkout0_0_pll6_reset_i;
    wire            tile2_gtpclkout0_0_to_cmt_i;
    wire            pll6_fb_out_i;
    wire            pll6_fb_in_i;
    wire            gtpclkout0_1_dcm7_locked_i;
    wire            gtpclkout0_1_dcm7_reset_i;
    wire            tile2_gtpclkout0_1_to_dcm_i;
    wire            dcm7_fb_in_i;
    wire            gtpclkout1_1_dcm8_locked_i;
    wire            gtpclkout1_1_dcm8_reset_i;
    wire            tile2_gtpclkout1_1_to_dcm_i;
    wire            dcm8_fb_in_i;
    wire            gtpclkout0_0_pll9_locked_i;
    wire            gtpclkout0_0_pll9_reset_i;
    wire            tile3_gtpclkout0_0_to_cmt_i;
    wire            pll9_fb_out_i;
    wire            pll9_fb_in_i;
    wire            gtpclkout0_1_dcm10_locked_i;
    wire            gtpclkout0_1_dcm10_reset_i;
    wire            tile3_gtpclkout0_1_to_dcm_i;
    wire            dcm10_fb_in_i;
    wire            gtpclkout1_1_dcm11_locked_i;
    wire            gtpclkout1_1_dcm11_reset_i;
    wire            tile3_gtpclkout1_1_to_dcm_i;
    wire            dcm11_fb_in_i;


    //--------------------- Frame check/gen Module Signals --------------------
    wire            tile0_gtp0_refclk_i;
    wire            tile1_gtp0_refclk_i;
    wire            tile2_gtp0_refclk_i;
    wire            tile3_gtp0_refclk_i;

    wire            tile0_matchn0_i;
    
    wire    [1:0]   tile0_txcharisk0_float_i;
    wire    [23:0]  tile0_txdata0_float_i;
    wire            tile0_track_data0_i;
    wire    [7:0]   tile0_error_count0_i;
    wire            tile0_frame_check0_reset_i;
    wire            tile0_inc_in0_i;
    wire            tile0_inc_out0_i;
    wire            tile0_matchn1_i;
    
    wire    [1:0]   tile0_txcharisk1_float_i;
    wire    [23:0]  tile0_txdata1_float_i;
    wire            tile0_track_data1_i;
    wire    [7:0]   tile0_error_count1_i;
    wire            tile0_frame_check1_reset_i;
    wire            tile0_inc_in1_i;
    wire            tile0_inc_out1_i;

    wire            tile1_matchn0_i;
    
    wire    [1:0]   tile1_txcharisk0_float_i;
    wire    [23:0]  tile1_txdata0_float_i;
    wire            tile1_track_data0_i;
    wire    [7:0]   tile1_error_count0_i;
    wire            tile1_frame_check0_reset_i;
    wire            tile1_inc_in0_i;
    wire            tile1_inc_out0_i;
    wire            tile1_matchn1_i;
    
    wire    [1:0]   tile1_txcharisk1_float_i;
    wire    [23:0]  tile1_txdata1_float_i;
    wire            tile1_track_data1_i;
    wire    [7:0]   tile1_error_count1_i;
    wire            tile1_frame_check1_reset_i;
    wire            tile1_inc_in1_i;
    wire            tile1_inc_out1_i;

    wire            tile2_matchn0_i;
    
    wire    [1:0]   tile2_txcharisk0_float_i;
    wire    [23:0]  tile2_txdata0_float_i;
    wire            tile2_track_data0_i;
    wire    [7:0]   tile2_error_count0_i;
    wire            tile2_frame_check0_reset_i;
    wire            tile2_inc_in0_i;
    wire            tile2_inc_out0_i;
    wire            tile2_matchn1_i;
    
    wire    [1:0]   tile2_txcharisk1_float_i;
    wire    [23:0]  tile2_txdata1_float_i;
    wire            tile2_track_data1_i;
    wire    [7:0]   tile2_error_count1_i;
    wire            tile2_frame_check1_reset_i;
    wire            tile2_inc_in1_i;
    wire            tile2_inc_out1_i;

    wire            tile3_matchn0_i;
    
    wire    [1:0]   tile3_txcharisk0_float_i;
    wire    [23:0]  tile3_txdata0_float_i;
    wire            tile3_track_data0_i;
    wire    [7:0]   tile3_error_count0_i;
    wire            tile3_frame_check0_reset_i;
    wire            tile3_inc_in0_i;
    wire            tile3_inc_out0_i;
    wire            tile3_matchn1_i;
    
    wire    [1:0]   tile3_txcharisk1_float_i;
    wire    [23:0]  tile3_txdata1_float_i;
    wire            tile3_track_data1_i;
    wire    [7:0]   tile3_error_count1_i;
    wire            tile3_frame_check1_reset_i;
    wire            tile3_inc_in1_i;
    wire            tile3_inc_out1_i;

    wire            reset_on_data_error_i;
    wire            track_data_out_i;
    
    //----------------------- Sync Module Signals -----------------------------
    wire            tile0_rx_sync_done0_i;
    wire            tile0_rx_sync_done1_i;
    wire            tile1_rx_sync_done0_i;
    wire            tile1_rx_sync_done1_i;
    wire            tile2_rx_sync_done0_i;
    wire            tile2_rx_sync_done1_i;
    wire            tile3_rx_sync_done0_i;
    wire            tile3_rx_sync_done1_i;
    wire            tile0_tx_sync_done0_i;
    wire            tile0_tx_sync_done1_i;
    wire            tile1_tx_sync_done0_i;
    wire            tile1_tx_sync_done1_i;
    wire            tile2_tx_sync_done0_i;
    wire            tile2_tx_sync_done1_i;
    wire            tile3_tx_sync_done0_i;
    wire            tile3_tx_sync_done1_i;
    //--------------------- Chipscope Signals ---------------------------------

    wire    [35:0]  shared_vio_control_i;
    wire    [35:0]  tile0_data_vio_control_i;
    wire    [35:0]  tile1_data_vio_control_i;
    wire    [35:0]  tile2_data_vio_control_i;
    wire    [35:0]  tile3_data_vio_control_i;
    wire    [35:0]  tile0_gtp0_ila_control_i;
    wire    [35:0]  tile0_gtp1_ila_control_i;
    wire    [35:0]  tile1_gtp0_ila_control_i;
    wire    [35:0]  tile1_gtp1_ila_control_i;
    wire    [35:0]  tile2_gtp0_ila_control_i;
    wire    [35:0]  tile2_gtp1_ila_control_i;
    wire    [35:0]  tile3_gtp0_ila_control_i;
    wire    [35:0]  tile3_gtp1_ila_control_i;
    wire    [31:0]  shared_vio_in_i;
    wire    [31:0]  shared_vio_out_i;

    wire    [139:0] tile0_data_vio_in_i;
    wire    [139:0] tile0_data_vio_out_i;
    wire    [139:0] tile1_data_vio_in_i;
    wire    [139:0] tile1_data_vio_out_i;
    wire    [139:0] tile2_data_vio_in_i;
    wire    [139:0] tile2_data_vio_out_i;
    wire    [139:0] tile3_data_vio_in_i;
    wire    [139:0] tile3_data_vio_out_i;
    wire    [84:0]  tile0_ila_in0_i;
    wire    [84:0]  tile0_ila_in1_i;

    wire    [84:0]  tile1_ila_in0_i;
    wire    [84:0]  tile1_ila_in1_i;

    wire    [84:0]  tile2_ila_in0_i;
    wire    [84:0]  tile2_ila_in1_i;

    wire    [84:0]  tile3_ila_in0_i;
    wire    [84:0]  tile3_ila_in1_i;


    wire            gtpreset0_i;
    wire            gtpreset1_i;
    wire            user_tx_reset_i;
    wire            user_rx_reset_i;


//**************************** Main Body of Code *******************************

    //  Static signal Assigments    
    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 192'h000000000000000000000000000000000000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 8'hff;


    


    //---------------------Dedicated GTP Reference Clock Inputs ---------------
    // The dedicated reference clock inputs you selected in the GUI are implemented using
    // IBUFDS instances.
    //
    // In the UCF file for this example design, you will see that each of
    // these IBUFDS instances has been LOCed to a particular set of pins. By LOCing to these
    // locations, we tell the tools to use the dedicated input buffers to the GTP reference
    // clock network, rather than general purpose IOs. To select other pins, consult the 
    // Implementation chapter of UG___, or rerun the wizard.
    //
    // This network is the highest performace (lowest jitter) option for providing clocks
    // to the GTP transceivers.
    
    IBUFDS tile0_gtp0_refclk_ibufds_i
    (
        .O                              (tile0_gtp0_refclk_i),
        .I                              (TILE0_GTP0_REFCLK_PAD_P_IN),
        .IB                             (TILE0_GTP0_REFCLK_PAD_N_IN)
    );

    IBUFDS tile1_gtp0_refclk_ibufds_i
    (
        .O                              (tile1_gtp0_refclk_i),
        .I                              (TILE1_GTP0_REFCLK_PAD_P_IN),
        .IB                             (TILE1_GTP0_REFCLK_PAD_N_IN)
    );

    IBUFDS tile2_gtp0_refclk_ibufds_i
    (
        .O                              (tile2_gtp0_refclk_i),
        .I                              (TILE2_GTP0_REFCLK_PAD_P_IN),
        .IB                             (TILE2_GTP0_REFCLK_PAD_N_IN)
    );

    IBUFDS tile3_gtp0_refclk_ibufds_i
    (
        .O                              (tile3_gtp0_refclk_i),
        .I                              (TILE3_GTP0_REFCLK_PAD_P_IN),
        .IB                             (TILE3_GTP0_REFCLK_PAD_N_IN)
    );

    //--------------------------------- User Clocks ---------------------------
    
    // The clock resources in this section were added based on userclk source selections on
    // the Latency, Buffering, and Clocking page of the GUI. A few notes about user clocks:
    // * The userclk and userclk2 for each GTP datapath (TX and RX) must be phase aligned to 
    //   avoid data errors in the fabric interface whenever the datapath is wider than 10 bits
    // * To minimize clock resources, you can share clocks between GTPs. GTPs using the same frequency
    //   or multiples of the same frequency can be accomadated using DCMs and PLLs. Use caution when
    //   using RXRECCLK as a clock source, however - these clocks can typically only be shared if all
    //   the channels using the clock are receiving data from TX channels that share a reference clock 
    //   source with each other.

    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll0_bufio2_i
    (
        .I                              (tile0_gtpclkout0_i[0]),
        .DIVCLK                         (tile0_gtpclkout0_0_to_cmt_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll0_bufio2fb_i
    (
        .I                              (tile0_gtpclkfbwest_i[0]),
        .O                              (pll0_fb_in_i)
    );

    assign  gtpclkout0_0_pll0_reset_i       =  !tile0_plllkdet0_i;
    MGT_USRCLK_SOURCE_PLL #
    (
        .MULT                           (4),
        .DIVIDE                         (2),
        .FEEDBACK                       ("CLKOUT0"),
        .CLK_PERIOD                     (6.25),
        .OUT0_DIVIDE                    (2),
        .OUT1_DIVIDE                    (4),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    gtpclkout0_0_pll0_i
    (
        .CLK0_OUT                       (tile0_txusrclk0_i),
        .CLK1_OUT                       (tile0_txusrclk20_i),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (tile0_gtpclkout0_0_to_cmt_i),
        .CLKFB_IN                       (pll0_fb_in_i),
        .CLKFB_OUT                      (pll0_fb_out_i),
        .PLL_LOCKED_OUT                 (gtpclkout0_0_pll0_locked_i),
        .PLL_RESET_IN                   (gtpclkout0_0_pll0_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm1_bufio2_i
    (
        .I                              (tile0_gtpclkout0_i[1]),
        .DIVCLK                         (tile0_gtpclkout0_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm1_bufio2fb_i
    (
        .I                              (tile0_gtpclkfbwest_i[1]),
        .O                              (dcm1_fb_in_i)
    );

    assign  gtpclkout0_1_dcm1_reset_i       =  !tile0_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout0_1_dcm1_i
    (
        .DIV1_OUT                       (tile0_rxusrclk20_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile0_rxusrclk0_i),
        .DCM_LOCKED_OUT                 (gtpclkout0_1_dcm1_locked_i),
        .CLK_IN                         (tile0_gtpclkout0_1_to_dcm_i),
        .FB_IN                          (dcm1_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout0_1_dcm1_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm2_bufio2_i
    (
        .I                              (tile0_gtpclkout1_i[1]),
        .DIVCLK                         (tile0_gtpclkout1_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm2_bufio2fb_i
    (
        .I                              (tile0_gtpclkfbeast_i[1]),
        .O                              (dcm2_fb_in_i)
    );

    assign  gtpclkout1_1_dcm2_reset_i       =  !tile0_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout1_1_dcm2_i
    (
        .DIV1_OUT                       (tile0_rxusrclk21_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile0_rxusrclk1_i),
        .DCM_LOCKED_OUT                 (gtpclkout1_1_dcm2_locked_i),
        .CLK_IN                         (tile0_gtpclkout1_1_to_dcm_i),
        .FB_IN                          (dcm2_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout1_1_dcm2_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll3_bufio2_i
    (
        .I                              (tile1_gtpclkout0_i[0]),
        .DIVCLK                         (tile1_gtpclkout0_0_to_cmt_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll3_bufio2fb_i
    (
        .I                              (tile1_gtpclkfbwest_i[0]),
        .O                              (pll3_fb_in_i)
    );

    assign  gtpclkout0_0_pll3_reset_i       =  !tile1_plllkdet0_i;
    MGT_USRCLK_SOURCE_PLL #
    (
        .MULT                           (4),
        .DIVIDE                         (2),
        .FEEDBACK                       ("CLKOUT0"),
        .CLK_PERIOD                     (6.25),
        .OUT0_DIVIDE                    (2),
        .OUT1_DIVIDE                    (4),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    gtpclkout0_0_pll3_i
    (
        .CLK0_OUT                       (tile1_txusrclk0_i),
        .CLK1_OUT                       (tile1_txusrclk20_i),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (tile1_gtpclkout0_0_to_cmt_i),
        .CLKFB_IN                       (pll3_fb_in_i),
        .CLKFB_OUT                      (pll3_fb_out_i),
        .PLL_LOCKED_OUT                 (gtpclkout0_0_pll3_locked_i),
        .PLL_RESET_IN                   (gtpclkout0_0_pll3_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm4_bufio2_i
    (
        .I                              (tile1_gtpclkout0_i[1]),
        .DIVCLK                         (tile1_gtpclkout0_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm4_bufio2fb_i
    (
        .I                              (tile1_gtpclkfbwest_i[1]),
        .O                              (dcm4_fb_in_i)
    );

    assign  gtpclkout0_1_dcm4_reset_i       =  !tile1_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout0_1_dcm4_i
    (
        .DIV1_OUT                       (tile1_rxusrclk20_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile1_rxusrclk0_i),
        .DCM_LOCKED_OUT                 (gtpclkout0_1_dcm4_locked_i),
        .CLK_IN                         (tile1_gtpclkout0_1_to_dcm_i),
        .FB_IN                          (dcm4_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout0_1_dcm4_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm5_bufio2_i
    (
        .I                              (tile1_gtpclkout1_i[1]),
        .DIVCLK                         (tile1_gtpclkout1_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm5_bufio2fb_i
    (
        .I                              (tile1_gtpclkfbeast_i[1]),
        .O                              (dcm5_fb_in_i)
    );

    assign  gtpclkout1_1_dcm5_reset_i       =  !tile1_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout1_1_dcm5_i
    (
        .DIV1_OUT                       (tile1_rxusrclk21_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile1_rxusrclk1_i),
        .DCM_LOCKED_OUT                 (gtpclkout1_1_dcm5_locked_i),
        .CLK_IN                         (tile1_gtpclkout1_1_to_dcm_i),
        .FB_IN                          (dcm5_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout1_1_dcm5_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll6_bufio2_i
    (
        .I                              (tile2_gtpclkout0_i[0]),
        .DIVCLK                         (tile2_gtpclkout0_0_to_cmt_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll6_bufio2fb_i
    (
        .I                              (tile2_gtpclkfbwest_i[0]),
        .O                              (pll6_fb_in_i)
    );

    assign  gtpclkout0_0_pll6_reset_i       =  !tile2_plllkdet0_i;
    MGT_USRCLK_SOURCE_PLL #
    (
        .MULT                           (4),
        .DIVIDE                         (2),
        .FEEDBACK                       ("CLKOUT0"),
        .CLK_PERIOD                     (6.25),
        .OUT0_DIVIDE                    (2),
        .OUT1_DIVIDE                    (4),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    gtpclkout0_0_pll6_i
    (
        .CLK0_OUT                       (tile2_txusrclk0_i),
        .CLK1_OUT                       (tile2_txusrclk20_i),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (tile2_gtpclkout0_0_to_cmt_i),
        .CLKFB_IN                       (pll6_fb_in_i),
        .CLKFB_OUT                      (pll6_fb_out_i),
        .PLL_LOCKED_OUT                 (gtpclkout0_0_pll6_locked_i),
        .PLL_RESET_IN                   (gtpclkout0_0_pll6_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm7_bufio2_i
    (
        .I                              (tile2_gtpclkout0_i[1]),
        .DIVCLK                         (tile2_gtpclkout0_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm7_bufio2fb_i
    (
        .I                              (tile2_gtpclkfbwest_i[1]),
        .O                              (dcm7_fb_in_i)
    );

    assign  gtpclkout0_1_dcm7_reset_i       =  !tile2_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout0_1_dcm7_i
    (
        .DIV1_OUT                       (tile2_rxusrclk20_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile2_rxusrclk0_i),
        .DCM_LOCKED_OUT                 (gtpclkout0_1_dcm7_locked_i),
        .CLK_IN                         (tile2_gtpclkout0_1_to_dcm_i),
        .FB_IN                          (dcm7_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout0_1_dcm7_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm8_bufio2_i
    (
        .I                              (tile2_gtpclkout1_i[1]),
        .DIVCLK                         (tile2_gtpclkout1_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm8_bufio2fb_i
    (
        .I                              (tile2_gtpclkfbeast_i[1]),
        .O                              (dcm8_fb_in_i)
    );

    assign  gtpclkout1_1_dcm8_reset_i       =  !tile2_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout1_1_dcm8_i
    (
        .DIV1_OUT                       (tile2_rxusrclk21_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile2_rxusrclk1_i),
        .DCM_LOCKED_OUT                 (gtpclkout1_1_dcm8_locked_i),
        .CLK_IN                         (tile2_gtpclkout1_1_to_dcm_i),
        .FB_IN                          (dcm8_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout1_1_dcm8_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll9_bufio2_i
    (
        .I                              (tile3_gtpclkout0_i[0]),
        .DIVCLK                         (tile3_gtpclkout0_0_to_cmt_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_0_pll9_bufio2fb_i
    (
        .I                              (tile3_gtpclkfbwest_i[0]),
        .O                              (pll9_fb_in_i)
    );

    assign  gtpclkout0_0_pll9_reset_i       =  !tile3_plllkdet0_i;
    MGT_USRCLK_SOURCE_PLL #
    (
        .MULT                           (4),
        .DIVIDE                         (2),
        .FEEDBACK                       ("CLKOUT0"),
        .CLK_PERIOD                     (6.25),
        .OUT0_DIVIDE                    (2),
        .OUT1_DIVIDE                    (4),
        .OUT2_DIVIDE                    (1),
        .OUT3_DIVIDE                    (1)
    )
    gtpclkout0_0_pll9_i
    (
        .CLK0_OUT                       (tile3_txusrclk0_i),
        .CLK1_OUT                       (tile3_txusrclk20_i),
        .CLK2_OUT                       (),
        .CLK3_OUT                       (),
        .CLK_IN                         (tile3_gtpclkout0_0_to_cmt_i),
        .CLKFB_IN                       (pll9_fb_in_i),
        .CLKFB_OUT                      (pll9_fb_out_i),
        .PLL_LOCKED_OUT                 (gtpclkout0_0_pll9_locked_i),
        .PLL_RESET_IN                   (gtpclkout0_0_pll9_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm10_bufio2_i
    (
        .I                              (tile3_gtpclkout0_i[1]),
        .DIVCLK                         (tile3_gtpclkout0_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout0_1_dcm10_bufio2fb_i
    (
        .I                              (tile3_gtpclkfbwest_i[1]),
        .O                              (dcm10_fb_in_i)
    );

    assign  gtpclkout0_1_dcm10_reset_i      =  !tile3_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout0_1_dcm10_i
    (
        .DIV1_OUT                       (tile3_rxusrclk20_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile3_rxusrclk0_i),
        .DCM_LOCKED_OUT                 (gtpclkout0_1_dcm10_locked_i),
        .CLK_IN                         (tile3_gtpclkout0_1_to_dcm_i),
        .FB_IN                          (dcm10_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout0_1_dcm10_reset_i)
    );


    BUFIO2 #
    (
        .DIVIDE                         (1),
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm11_bufio2_i
    (
        .I                              (tile3_gtpclkout1_i[1]),
        .DIVCLK                         (tile3_gtpclkout1_1_to_dcm_i),
        .IOCLK                          (),
        .SERDESSTROBE                   ()
    );

    BUFIO2FB #
    (
        .DIVIDE_BYPASS                  ("TRUE")
    )
    gtpclkout1_1_dcm11_bufio2fb_i
    (
        .I                              (tile3_gtpclkfbeast_i[1]),
        .O                              (dcm11_fb_in_i)
    );

    assign  gtpclkout1_1_dcm11_reset_i      =  !tile3_plllkdet0_i;
    MGT_USRCLK_SOURCE #
    (
        .FREQUENCY_MODE                 ("LOW"),
        .DIVIDE_2                       ("TRUE"),
        .FEEDBACK                       ("2X"),
        .DIVIDE                         (2.0)
    )
    gtpclkout1_1_dcm11_i
    (
        .DIV1_OUT                       (tile3_rxusrclk21_i),
        .DIV2_OUT                       (),
        .CLK2X_OUT                      (tile3_rxusrclk1_i),
        .DCM_LOCKED_OUT                 (gtpclkout1_1_dcm11_locked_i),
        .CLK_IN                         (tile3_gtpclkout1_1_to_dcm_i),
        .FB_IN                          (dcm11_fb_in_i),
        .DCM_RESET_IN                   (gtpclkout1_1_dcm11_reset_i)
    );






    //--------------------------- The GTP Wrapper -----------------------------
    
    // Use the instantiation template in the examples directory to add the GTP wrapper to your design.
    // In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    // checker. The GTPs will reset, then attempt to align and transmit data. If channel bonding is 
    // enabled, bonding should occur after alignment.


    // Wire all PLLLKDET signals to the top level as output ports
    assign TILE0_GTP0_PLLLKDET_OUT = tile0_plllkdet0_i;
    assign TILE1_GTP0_PLLLKDET_OUT = tile1_plllkdet0_i;
    assign TILE2_GTP0_PLLLKDET_OUT = tile2_plllkdet0_i;
    assign TILE3_GTP0_PLLLKDET_OUT = tile3_plllkdet0_i;

    SER16 #
    (
        .WRAPPER_SIM_GTPRESET_SPEEDUP           (EXAMPLE_SIM_GTPRESET_SPEEDUP),
        .WRAPPER_CLK25_DIVIDER_0                (10),
        .WRAPPER_CLK25_DIVIDER_1                (10),
        .WRAPPER_PLL_DIVSEL_FB_0                (2),
        .WRAPPER_PLL_DIVSEL_FB_1                (2),
        .WRAPPER_PLL_DIVSEL_REF_0               (1),
        .WRAPPER_PLL_DIVSEL_REF_1               (1),
        .WRAPPER_SIMULATION                     (EXAMPLE_SIMULATION)
    )
    ser16_i
    (
 
 
 
 
 
 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //TILE0  (X0_Y0)

        //---------------------- Loopback and Powerdown Ports ----------------------
        .TILE0_LOOPBACK0_IN             (tile0_loopback0_i),
        .TILE0_LOOPBACK1_IN             (tile0_loopback1_i),
        //------------------------------- PLL Ports --------------------------------
        .TILE0_CLK00_IN                 (tile0_gtp0_refclk_i),
        .TILE0_CLK01_IN                 (tied_to_ground_i),
        .TILE0_GTPRESET0_IN             (tile0_gtpreset0_i),
        .TILE0_GTPRESET1_IN             (tile0_gtpreset0_i),
        .TILE0_PLLLKDET0_OUT            (tile0_plllkdet0_i),
        .TILE0_RESETDONE0_OUT           (tile0_resetdone0_i),
        .TILE0_RESETDONE1_OUT           (tile0_resetdone1_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .TILE0_RXDISPERR0_OUT           (tile0_rxdisperr0_i),
        .TILE0_RXDISPERR1_OUT           (tile0_rxdisperr1_i),
        .TILE0_RXNOTINTABLE0_OUT        (tile0_rxnotintable0_i),
        .TILE0_RXNOTINTABLE1_OUT        (tile0_rxnotintable1_i),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .TILE0_PRBSCNTRESET0_IN         (tile0_prbscntreset0_i),
        .TILE0_PRBSCNTRESET1_IN         (tile0_prbscntreset1_i),
        .TILE0_RXENPRBSTST0_IN          (tile0_rxenprbstst0_i),
        .TILE0_RXENPRBSTST1_IN          (tile0_rxenprbstst1_i),
        .TILE0_RXPRBSERR0_OUT           (tile0_rxprbserr0_i),
        .TILE0_RXPRBSERR1_OUT           (tile0_rxprbserr1_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .TILE0_RXDATA0_OUT              (tile0_rxdata0_i),
        .TILE0_RXDATA1_OUT              (tile0_rxdata1_i),
        .TILE0_RXRECCLK0_OUT            (tile0_rxrecclk0_i),
        .TILE0_RXRECCLK1_OUT            (tile0_rxrecclk1_i),
        .TILE0_RXUSRCLK0_IN             (tile0_rxusrclk0_i),
        .TILE0_RXUSRCLK1_IN             (tile0_rxusrclk1_i),
        .TILE0_RXUSRCLK20_IN            (tile0_rxusrclk20_i),
        .TILE0_RXUSRCLK21_IN            (tile0_rxusrclk21_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .TILE0_RXEQMIX0_IN              (tile0_rxeqmix0_i),
        .TILE0_RXEQMIX1_IN              (tile0_rxeqmix1_i),
        .TILE0_RXN0_IN                  (RXN_IN[0]),
        .TILE0_RXN1_IN                  (RXN_IN[1]),
        .TILE0_RXP0_IN                  (RXP_IN[0]),
        .TILE0_RXP1_IN                  (RXP_IN[1]),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .TILE0_RXENPMAPHASEALIGN0_IN    (tile0_rxenpmaphasealign0_i),
        .TILE0_RXENPMAPHASEALIGN1_IN    (tile0_rxenpmaphasealign1_i),
        .TILE0_RXPMASETPHASE0_IN        (tile0_rxpmasetphase0_i),
        .TILE0_RXPMASETPHASE1_IN        (tile0_rxpmasetphase1_i),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .TILE0_GTPCLKFBEAST_OUT         (tile0_gtpclkfbeast_i),
        .TILE0_GTPCLKFBWEST_OUT         (tile0_gtpclkfbwest_i),
        .TILE0_GTPCLKOUT0_OUT           (tile0_gtpclkout0_i),
        .TILE0_GTPCLKOUT1_OUT           (tile0_gtpclkout1_i),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TILE0_TXCHARISK0_IN            (tile0_txcharisk0_i),
        .TILE0_TXCHARISK1_IN            (tile0_txcharisk1_i),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TILE0_TXENPMAPHASEALIGN0_IN    (tile0_txenpmaphasealign0_i),
        .TILE0_TXENPMAPHASEALIGN1_IN    (tile0_txenpmaphasealign1_i),
        .TILE0_TXPMASETPHASE0_IN        (tile0_txpmasetphase0_i),
        .TILE0_TXPMASETPHASE1_IN        (tile0_txpmasetphase1_i),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TILE0_TXDATA0_IN               (tile0_txdata0_i),
        .TILE0_TXDATA1_IN               (tile0_txdata1_i),
        .TILE0_TXOUTCLK0_OUT            (tile0_txoutclk0_i),
        .TILE0_TXOUTCLK1_OUT            (tile0_txoutclk1_i),
        .TILE0_TXUSRCLK0_IN             (tile0_txusrclk0_i),
        .TILE0_TXUSRCLK1_IN             (tile0_txusrclk0_i),
        .TILE0_TXUSRCLK20_IN            (tile0_txusrclk20_i),
        .TILE0_TXUSRCLK21_IN            (tile0_txusrclk20_i),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TILE0_TXN0_OUT                 (TXN_OUT[0]),
        .TILE0_TXN1_OUT                 (TXN_OUT[1]),
        .TILE0_TXP0_OUT                 (TXP_OUT[0]),
        .TILE0_TXP1_OUT                 (TXP_OUT[1]),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TILE0_TXENPRBSTST0_IN          (tile0_txenprbstst0_i),
        .TILE0_TXENPRBSTST1_IN          (tile0_txenprbstst1_i),


 
 
 
 
 
 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //TILE1  (X1_Y0)

        //---------------------- Loopback and Powerdown Ports ----------------------
        .TILE1_LOOPBACK0_IN             (tile1_loopback0_i),
        .TILE1_LOOPBACK1_IN             (tile1_loopback1_i),
        //------------------------------- PLL Ports --------------------------------
        .TILE1_CLK00_IN                 (tile1_gtp0_refclk_i),
        .TILE1_CLK01_IN                 (tied_to_ground_i),
        .TILE1_GTPRESET0_IN             (tile1_gtpreset0_i),
        .TILE1_GTPRESET1_IN             (tile1_gtpreset0_i),
        .TILE1_PLLLKDET0_OUT            (tile1_plllkdet0_i),
        .TILE1_RESETDONE0_OUT           (tile1_resetdone0_i),
        .TILE1_RESETDONE1_OUT           (tile1_resetdone1_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .TILE1_RXDISPERR0_OUT           (tile1_rxdisperr0_i),
        .TILE1_RXDISPERR1_OUT           (tile1_rxdisperr1_i),
        .TILE1_RXNOTINTABLE0_OUT        (tile1_rxnotintable0_i),
        .TILE1_RXNOTINTABLE1_OUT        (tile1_rxnotintable1_i),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .TILE1_PRBSCNTRESET0_IN         (tile1_prbscntreset0_i),
        .TILE1_PRBSCNTRESET1_IN         (tile1_prbscntreset1_i),
        .TILE1_RXENPRBSTST0_IN          (tile1_rxenprbstst0_i),
        .TILE1_RXENPRBSTST1_IN          (tile1_rxenprbstst1_i),
        .TILE1_RXPRBSERR0_OUT           (tile1_rxprbserr0_i),
        .TILE1_RXPRBSERR1_OUT           (tile1_rxprbserr1_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .TILE1_RXDATA0_OUT              (tile1_rxdata0_i),
        .TILE1_RXDATA1_OUT              (tile1_rxdata1_i),
        .TILE1_RXRECCLK0_OUT            (tile1_rxrecclk0_i),
        .TILE1_RXRECCLK1_OUT            (tile1_rxrecclk1_i),
        .TILE1_RXUSRCLK0_IN             (tile1_rxusrclk0_i),
        .TILE1_RXUSRCLK1_IN             (tile1_rxusrclk1_i),
        .TILE1_RXUSRCLK20_IN            (tile1_rxusrclk20_i),
        .TILE1_RXUSRCLK21_IN            (tile1_rxusrclk21_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .TILE1_RXEQMIX0_IN              (tile1_rxeqmix0_i),
        .TILE1_RXEQMIX1_IN              (tile1_rxeqmix1_i),
        .TILE1_RXN0_IN                  (RXN_IN[2]),
        .TILE1_RXN1_IN                  (RXN_IN[3]),
        .TILE1_RXP0_IN                  (RXP_IN[2]),
        .TILE1_RXP1_IN                  (RXP_IN[3]),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .TILE1_RXENPMAPHASEALIGN0_IN    (tile1_rxenpmaphasealign0_i),
        .TILE1_RXENPMAPHASEALIGN1_IN    (tile1_rxenpmaphasealign1_i),
        .TILE1_RXPMASETPHASE0_IN        (tile1_rxpmasetphase0_i),
        .TILE1_RXPMASETPHASE1_IN        (tile1_rxpmasetphase1_i),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .TILE1_GTPCLKFBEAST_OUT         (tile1_gtpclkfbeast_i),
        .TILE1_GTPCLKFBWEST_OUT         (tile1_gtpclkfbwest_i),
        .TILE1_GTPCLKOUT0_OUT           (tile1_gtpclkout0_i),
        .TILE1_GTPCLKOUT1_OUT           (tile1_gtpclkout1_i),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TILE1_TXCHARISK0_IN            (tile1_txcharisk0_i),
        .TILE1_TXCHARISK1_IN            (tile1_txcharisk1_i),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TILE1_TXENPMAPHASEALIGN0_IN    (tile1_txenpmaphasealign0_i),
        .TILE1_TXENPMAPHASEALIGN1_IN    (tile1_txenpmaphasealign1_i),
        .TILE1_TXPMASETPHASE0_IN        (tile1_txpmasetphase0_i),
        .TILE1_TXPMASETPHASE1_IN        (tile1_txpmasetphase1_i),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TILE1_TXDATA0_IN               (tile1_txdata0_i),
        .TILE1_TXDATA1_IN               (tile1_txdata1_i),
        .TILE1_TXOUTCLK0_OUT            (tile1_txoutclk0_i),
        .TILE1_TXOUTCLK1_OUT            (tile1_txoutclk1_i),
        .TILE1_TXUSRCLK0_IN             (tile1_txusrclk0_i),
        .TILE1_TXUSRCLK1_IN             (tile1_txusrclk0_i),
        .TILE1_TXUSRCLK20_IN            (tile1_txusrclk20_i),
        .TILE1_TXUSRCLK21_IN            (tile1_txusrclk20_i),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TILE1_TXN0_OUT                 (TXN_OUT[2]),
        .TILE1_TXN1_OUT                 (TXN_OUT[3]),
        .TILE1_TXP0_OUT                 (TXP_OUT[2]),
        .TILE1_TXP1_OUT                 (TXP_OUT[3]),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TILE1_TXENPRBSTST0_IN          (tile1_txenprbstst0_i),
        .TILE1_TXENPRBSTST1_IN          (tile1_txenprbstst1_i),


 
 
 
 
 
 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //TILE2  (X0_Y1)

        //---------------------- Loopback and Powerdown Ports ----------------------
        .TILE2_LOOPBACK0_IN             (tile2_loopback0_i),
        .TILE2_LOOPBACK1_IN             (tile2_loopback1_i),
        //------------------------------- PLL Ports --------------------------------
        .TILE2_CLK00_IN                 (tile2_gtp0_refclk_i),
        .TILE2_CLK01_IN                 (tied_to_ground_i),
        .TILE2_GTPRESET0_IN             (tile2_gtpreset0_i),
        .TILE2_GTPRESET1_IN             (tile2_gtpreset0_i),
        .TILE2_PLLLKDET0_OUT            (tile2_plllkdet0_i),
        .TILE2_RESETDONE0_OUT           (tile2_resetdone0_i),
        .TILE2_RESETDONE1_OUT           (tile2_resetdone1_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .TILE2_RXDISPERR0_OUT           (tile2_rxdisperr0_i),
        .TILE2_RXDISPERR1_OUT           (tile2_rxdisperr1_i),
        .TILE2_RXNOTINTABLE0_OUT        (tile2_rxnotintable0_i),
        .TILE2_RXNOTINTABLE1_OUT        (tile2_rxnotintable1_i),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .TILE2_PRBSCNTRESET0_IN         (tile2_prbscntreset0_i),
        .TILE2_PRBSCNTRESET1_IN         (tile2_prbscntreset1_i),
        .TILE2_RXENPRBSTST0_IN          (tile2_rxenprbstst0_i),
        .TILE2_RXENPRBSTST1_IN          (tile2_rxenprbstst1_i),
        .TILE2_RXPRBSERR0_OUT           (tile2_rxprbserr0_i),
        .TILE2_RXPRBSERR1_OUT           (tile2_rxprbserr1_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .TILE2_RXDATA0_OUT              (tile2_rxdata0_i),
        .TILE2_RXDATA1_OUT              (tile2_rxdata1_i),
        .TILE2_RXRECCLK0_OUT            (tile2_rxrecclk0_i),
        .TILE2_RXRECCLK1_OUT            (tile2_rxrecclk1_i),
        .TILE2_RXUSRCLK0_IN             (tile2_rxusrclk0_i),
        .TILE2_RXUSRCLK1_IN             (tile2_rxusrclk1_i),
        .TILE2_RXUSRCLK20_IN            (tile2_rxusrclk20_i),
        .TILE2_RXUSRCLK21_IN            (tile2_rxusrclk21_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .TILE2_RXEQMIX0_IN              (tile2_rxeqmix0_i),
        .TILE2_RXEQMIX1_IN              (tile2_rxeqmix1_i),
        .TILE2_RXN0_IN                  (RXN_IN[4]),
        .TILE2_RXN1_IN                  (RXN_IN[5]),
        .TILE2_RXP0_IN                  (RXP_IN[4]),
        .TILE2_RXP1_IN                  (RXP_IN[5]),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .TILE2_RXENPMAPHASEALIGN0_IN    (tile2_rxenpmaphasealign0_i),
        .TILE2_RXENPMAPHASEALIGN1_IN    (tile2_rxenpmaphasealign1_i),
        .TILE2_RXPMASETPHASE0_IN        (tile2_rxpmasetphase0_i),
        .TILE2_RXPMASETPHASE1_IN        (tile2_rxpmasetphase1_i),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .TILE2_GTPCLKFBEAST_OUT         (tile2_gtpclkfbeast_i),
        .TILE2_GTPCLKFBWEST_OUT         (tile2_gtpclkfbwest_i),
        .TILE2_GTPCLKOUT0_OUT           (tile2_gtpclkout0_i),
        .TILE2_GTPCLKOUT1_OUT           (tile2_gtpclkout1_i),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TILE2_TXCHARISK0_IN            (tile2_txcharisk0_i),
        .TILE2_TXCHARISK1_IN            (tile2_txcharisk1_i),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TILE2_TXENPMAPHASEALIGN0_IN    (tile2_txenpmaphasealign0_i),
        .TILE2_TXENPMAPHASEALIGN1_IN    (tile2_txenpmaphasealign1_i),
        .TILE2_TXPMASETPHASE0_IN        (tile2_txpmasetphase0_i),
        .TILE2_TXPMASETPHASE1_IN        (tile2_txpmasetphase1_i),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TILE2_TXDATA0_IN               (tile2_txdata0_i),
        .TILE2_TXDATA1_IN               (tile2_txdata1_i),
        .TILE2_TXOUTCLK0_OUT            (tile2_txoutclk0_i),
        .TILE2_TXOUTCLK1_OUT            (tile2_txoutclk1_i),
        .TILE2_TXUSRCLK0_IN             (tile2_txusrclk0_i),
        .TILE2_TXUSRCLK1_IN             (tile2_txusrclk0_i),
        .TILE2_TXUSRCLK20_IN            (tile2_txusrclk20_i),
        .TILE2_TXUSRCLK21_IN            (tile2_txusrclk20_i),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TILE2_TXN0_OUT                 (TXN_OUT[4]),
        .TILE2_TXN1_OUT                 (TXN_OUT[5]),
        .TILE2_TXP0_OUT                 (TXP_OUT[4]),
        .TILE2_TXP1_OUT                 (TXP_OUT[5]),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TILE2_TXENPRBSTST0_IN          (tile2_txenprbstst0_i),
        .TILE2_TXENPRBSTST1_IN          (tile2_txenprbstst1_i),


 
 
 
 
 
 
 
        //_____________________________________________________________________
        //_____________________________________________________________________
        //TILE3  (X1_Y1)

        //---------------------- Loopback and Powerdown Ports ----------------------
        .TILE3_LOOPBACK0_IN             (tile3_loopback0_i),
        .TILE3_LOOPBACK1_IN             (tile3_loopback1_i),
        //------------------------------- PLL Ports --------------------------------
        .TILE3_CLK00_IN                 (tile3_gtp0_refclk_i),
        .TILE3_CLK01_IN                 (tied_to_ground_i),
        .TILE3_GTPRESET0_IN             (tile3_gtpreset0_i),
        .TILE3_GTPRESET1_IN             (tile3_gtpreset0_i),
        .TILE3_PLLLKDET0_OUT            (tile3_plllkdet0_i),
        .TILE3_RESETDONE0_OUT           (tile3_resetdone0_i),
        .TILE3_RESETDONE1_OUT           (tile3_resetdone1_i),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .TILE3_RXDISPERR0_OUT           (tile3_rxdisperr0_i),
        .TILE3_RXDISPERR1_OUT           (tile3_rxdisperr1_i),
        .TILE3_RXNOTINTABLE0_OUT        (tile3_rxnotintable0_i),
        .TILE3_RXNOTINTABLE1_OUT        (tile3_rxnotintable1_i),
        //--------------------- Receive Ports - PRBS Detection ---------------------
        .TILE3_PRBSCNTRESET0_IN         (tile3_prbscntreset0_i),
        .TILE3_PRBSCNTRESET1_IN         (tile3_prbscntreset1_i),
        .TILE3_RXENPRBSTST0_IN          (tile3_rxenprbstst0_i),
        .TILE3_RXENPRBSTST1_IN          (tile3_rxenprbstst1_i),
        .TILE3_RXPRBSERR0_OUT           (tile3_rxprbserr0_i),
        .TILE3_RXPRBSERR1_OUT           (tile3_rxprbserr1_i),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .TILE3_RXDATA0_OUT              (tile3_rxdata0_i),
        .TILE3_RXDATA1_OUT              (tile3_rxdata1_i),
        .TILE3_RXRECCLK0_OUT            (tile3_rxrecclk0_i),
        .TILE3_RXRECCLK1_OUT            (tile3_rxrecclk1_i),
        .TILE3_RXUSRCLK0_IN             (tile3_rxusrclk0_i),
        .TILE3_RXUSRCLK1_IN             (tile3_rxusrclk1_i),
        .TILE3_RXUSRCLK20_IN            (tile3_rxusrclk20_i),
        .TILE3_RXUSRCLK21_IN            (tile3_rxusrclk21_i),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .TILE3_RXEQMIX0_IN              (tile3_rxeqmix0_i),
        .TILE3_RXEQMIX1_IN              (tile3_rxeqmix1_i),
        .TILE3_RXN0_IN                  (RXN_IN[6]),
        .TILE3_RXN1_IN                  (RXN_IN[7]),
        .TILE3_RXP0_IN                  (RXP_IN[6]),
        .TILE3_RXP1_IN                  (RXP_IN[7]),
        //--------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        .TILE3_RXENPMAPHASEALIGN0_IN    (tile3_rxenpmaphasealign0_i),
        .TILE3_RXENPMAPHASEALIGN1_IN    (tile3_rxenpmaphasealign1_i),
        .TILE3_RXPMASETPHASE0_IN        (tile3_rxpmasetphase0_i),
        .TILE3_RXPMASETPHASE1_IN        (tile3_rxpmasetphase1_i),
        //-------------------------- TX/RX Datapath Ports --------------------------
        .TILE3_GTPCLKFBEAST_OUT         (tile3_gtpclkfbeast_i),
        .TILE3_GTPCLKFBWEST_OUT         (tile3_gtpclkfbwest_i),
        .TILE3_GTPCLKOUT0_OUT           (tile3_gtpclkout0_i),
        .TILE3_GTPCLKOUT1_OUT           (tile3_gtpclkout1_i),
        //----------------- Transmit Ports - 8b10b Encoder Control -----------------
        .TILE3_TXCHARISK0_IN            (tile3_txcharisk0_i),
        .TILE3_TXCHARISK1_IN            (tile3_txcharisk1_i),
        //------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        .TILE3_TXENPMAPHASEALIGN0_IN    (tile3_txenpmaphasealign0_i),
        .TILE3_TXENPMAPHASEALIGN1_IN    (tile3_txenpmaphasealign1_i),
        .TILE3_TXPMASETPHASE0_IN        (tile3_txpmasetphase0_i),
        .TILE3_TXPMASETPHASE1_IN        (tile3_txpmasetphase1_i),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .TILE3_TXDATA0_IN               (tile3_txdata0_i),
        .TILE3_TXDATA1_IN               (tile3_txdata1_i),
        .TILE3_TXOUTCLK0_OUT            (tile3_txoutclk0_i),
        .TILE3_TXOUTCLK1_OUT            (tile3_txoutclk1_i),
        .TILE3_TXUSRCLK0_IN             (tile3_txusrclk0_i),
        .TILE3_TXUSRCLK1_IN             (tile3_txusrclk0_i),
        .TILE3_TXUSRCLK20_IN            (tile3_txusrclk20_i),
        .TILE3_TXUSRCLK21_IN            (tile3_txusrclk20_i),
        //------------- Transmit Ports - TX Driver and OOB signalling --------------
        .TILE3_TXN0_OUT                 (TXN_OUT[6]),
        .TILE3_TXN1_OUT                 (TXN_OUT[7]),
        .TILE3_TXP0_OUT                 (TXP_OUT[6]),
        .TILE3_TXP1_OUT                 (TXP_OUT[7]),
        //------------------- Transmit Ports - TX PRBS Generator -------------------
        .TILE3_TXENPRBSTST0_IN          (tile3_txenprbstst0_i),
        .TILE3_TXENPRBSTST1_IN          (tile3_txenprbstst1_i)


    );




    //---------------------------- TXSYNC module ------------------------------
    // The TXSYNC module performs phase synchronization for all the active TX datapaths. It
    // waits for the user clocks to be stable, then drives the phase align signals on each
    // GTP. When phase synchronization is complete, it asserts SYNC_DONE
    
    // Include the TX_SYNC module in your own design to perform phase synchronization if
    // your protocol bypasses the TX Buffers
  
    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile0_txsync0_i 
    (
        .TXENPMAPHASEALIGN(tile0_txenpmaphasealign0_i),
        .TXPMASETPHASE(tile0_txpmasetphase0_i),
        .SYNC_DONE(tile0_tx_sync_done0_i),
        .USER_CLK(tile0_txusrclk20_i),
        .RESET(!tile0_resetdone0_r2)
    );

    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile1_txsync0_i 
    (
        .TXENPMAPHASEALIGN(tile1_txenpmaphasealign0_i),
        .TXPMASETPHASE(tile1_txpmasetphase0_i),
        .SYNC_DONE(tile1_tx_sync_done0_i),
        .USER_CLK(tile1_txusrclk20_i),
        .RESET(!tile1_resetdone0_r2)
    );

    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile2_txsync0_i 
    (
        .TXENPMAPHASEALIGN(tile2_txenpmaphasealign0_i),
        .TXPMASETPHASE(tile2_txpmasetphase0_i),
        .SYNC_DONE(tile2_tx_sync_done0_i),
        .USER_CLK(tile2_txusrclk20_i),
        .RESET(!tile2_resetdone0_r2)
    );

    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile3_txsync0_i 
    (
        .TXENPMAPHASEALIGN(tile3_txenpmaphasealign0_i),
        .TXPMASETPHASE(tile3_txpmasetphase0_i),
        .SYNC_DONE(tile3_tx_sync_done0_i),
        .USER_CLK(tile3_txusrclk20_i),
        .RESET(!tile3_resetdone0_r2)
    );

  
    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile0_txsync1_i 
    (
        .TXENPMAPHASEALIGN(tile0_txenpmaphasealign1_i),
        .TXPMASETPHASE(tile0_txpmasetphase1_i),
        .SYNC_DONE(tile0_tx_sync_done1_i),
        .USER_CLK(tile0_txusrclk20_i),
        .RESET(!tile0_resetdone1_r2)
    );

    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile1_txsync1_i 
    (
        .TXENPMAPHASEALIGN(tile1_txenpmaphasealign1_i),
        .TXPMASETPHASE(tile1_txpmasetphase1_i),
        .SYNC_DONE(tile1_tx_sync_done1_i),
        .USER_CLK(tile1_txusrclk20_i),
        .RESET(!tile1_resetdone1_r2)
    );

    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile2_txsync1_i 
    (
        .TXENPMAPHASEALIGN(tile2_txenpmaphasealign1_i),
        .TXPMASETPHASE(tile2_txpmasetphase1_i),
        .SYNC_DONE(tile2_tx_sync_done1_i),
        .USER_CLK(tile2_txusrclk20_i),
        .RESET(!tile2_resetdone1_r2)
    );

    
    TX_SYNC #
    (
        .PLL_DIVSEL_OUT   (1)
    )
    tile3_txsync1_i 
    (
        .TXENPMAPHASEALIGN(tile3_txenpmaphasealign1_i),
        .TXPMASETPHASE(tile3_txpmasetphase1_i),
        .SYNC_DONE(tile3_tx_sync_done1_i),
        .USER_CLK(tile3_txusrclk20_i),
        .RESET(!tile3_resetdone1_r2)
    );



    //-------------------------- RXSYNC modules -------------------------------
    // The RXSYNC module performs phase synchronization for all the active RX datapaths. It
    // waits for the user clocks to be stable, then drives the RX phase align signals on each
    // GTP. When phase synchronization is complete, it asserts SYNC_DONE
    
    // Include one RX_SYNC module per Buffer bypassed RX datapath in your own design. RX_SYNC modules
    // can also be shared, but when sharing, make sure to hold the module in reset until all lanes have 
    // a stable clock
    
  
    
    RX_SYNC tile0_rxsync0_i 
    (
        .RXENPMAPHASEALIGN(tile0_rxenpmaphasealign0_i),
        .RXPMASETPHASE(tile0_rxpmasetphase0_i),
        .SYNC_DONE(tile0_rx_sync_done0_i),
        .USER_CLK(tile0_rxusrclk20_i),
        .RESET(!tile0_resetdone0_r2)
    );
    
    
    RX_SYNC tile1_rxsync0_i 
    (
        .RXENPMAPHASEALIGN(tile1_rxenpmaphasealign0_i),
        .RXPMASETPHASE(tile1_rxpmasetphase0_i),
        .SYNC_DONE(tile1_rx_sync_done0_i),
        .USER_CLK(tile1_rxusrclk20_i),
        .RESET(!tile1_resetdone0_r2)
    );
    
    
    RX_SYNC tile2_rxsync0_i 
    (
        .RXENPMAPHASEALIGN(tile2_rxenpmaphasealign0_i),
        .RXPMASETPHASE(tile2_rxpmasetphase0_i),
        .SYNC_DONE(tile2_rx_sync_done0_i),
        .USER_CLK(tile2_rxusrclk20_i),
        .RESET(!tile2_resetdone0_r2)
    );
    
    
    RX_SYNC tile3_rxsync0_i 
    (
        .RXENPMAPHASEALIGN(tile3_rxenpmaphasealign0_i),
        .RXPMASETPHASE(tile3_rxpmasetphase0_i),
        .SYNC_DONE(tile3_rx_sync_done0_i),
        .USER_CLK(tile3_rxusrclk20_i),
        .RESET(!tile3_resetdone0_r2)
    );
    
    
  
    
    RX_SYNC tile0_rxsync1_i 
    (
        .RXENPMAPHASEALIGN(tile0_rxenpmaphasealign1_i),
        .RXPMASETPHASE(tile0_rxpmasetphase1_i),
        .SYNC_DONE(tile0_rx_sync_done1_i),
        .USER_CLK(tile0_rxusrclk21_i),
        .RESET(!tile0_resetdone1_r2)
    );
    
    
    RX_SYNC tile1_rxsync1_i 
    (
        .RXENPMAPHASEALIGN(tile1_rxenpmaphasealign1_i),
        .RXPMASETPHASE(tile1_rxpmasetphase1_i),
        .SYNC_DONE(tile1_rx_sync_done1_i),
        .USER_CLK(tile1_rxusrclk21_i),
        .RESET(!tile1_resetdone1_r2)
    );
    
    
    RX_SYNC tile2_rxsync1_i 
    (
        .RXENPMAPHASEALIGN(tile2_rxenpmaphasealign1_i),
        .RXPMASETPHASE(tile2_rxpmasetphase1_i),
        .SYNC_DONE(tile2_rx_sync_done1_i),
        .USER_CLK(tile2_rxusrclk21_i),
        .RESET(!tile2_resetdone1_r2)
    );
    
    
    RX_SYNC tile3_rxsync1_i 
    (
        .RXENPMAPHASEALIGN(tile3_rxenpmaphasealign1_i),
        .RXPMASETPHASE(tile3_rxpmasetphase1_i),
        .SYNC_DONE(tile3_rx_sync_done1_i),
        .USER_CLK(tile3_rxusrclk21_i),
        .RESET(!tile3_resetdone1_r2)
    );
    
    


    //------------------------ User Module Resets -----------------------------
    // All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    // are held in reset till the RESETDONE goes high. 
    // The RESETDONE is registered a couple of times on USRCLK2 and connected 
    // to the reset of the modules
    
    always @(posedge tile0_rxusrclk20_i or negedge tile0_resetdone0_i)
    begin
        if (!tile0_resetdone0_i )
        begin
            tile0_resetdone0_r    <=    1'b0;
            tile0_resetdone0_r2   <=    1'b0;
        end
        else
        begin
            tile0_resetdone0_r    <=    tile0_resetdone0_i;
            tile0_resetdone0_r2   <=    tile0_resetdone0_r;
        end
    end
    always @(posedge tile0_rxusrclk21_i or negedge tile0_resetdone1_i)
    begin
        if (!tile0_resetdone1_i )
        begin
            tile0_resetdone1_r    <=    1'b0;
            tile0_resetdone1_r2   <=    1'b0;
        end
        else
        begin
            tile0_resetdone1_r    <=    tile0_resetdone1_i;
            tile0_resetdone1_r2   <=    tile0_resetdone1_r;
        end
    end
    always @(posedge tile1_rxusrclk20_i or negedge tile1_resetdone0_i)
    begin
        if (!tile1_resetdone0_i )
        begin
            tile1_resetdone0_r    <=    1'b0;
            tile1_resetdone0_r2   <=    1'b0;
        end
        else
        begin
            tile1_resetdone0_r    <=    tile1_resetdone0_i;
            tile1_resetdone0_r2   <=    tile1_resetdone0_r;
        end
    end
    always @(posedge tile1_rxusrclk21_i or negedge tile1_resetdone1_i)
    begin
        if (!tile1_resetdone1_i )
        begin
            tile1_resetdone1_r    <=    1'b0;
            tile1_resetdone1_r2   <=    1'b0;
        end
        else
        begin
            tile1_resetdone1_r    <=    tile1_resetdone1_i;
            tile1_resetdone1_r2   <=    tile1_resetdone1_r;
        end
    end
    always @(posedge tile2_rxusrclk20_i or negedge tile2_resetdone0_i)
    begin
        if (!tile2_resetdone0_i )
        begin
            tile2_resetdone0_r    <=    1'b0;
            tile2_resetdone0_r2   <=    1'b0;
        end
        else
        begin
            tile2_resetdone0_r    <=    tile2_resetdone0_i;
            tile2_resetdone0_r2   <=    tile2_resetdone0_r;
        end
    end
    always @(posedge tile2_rxusrclk21_i or negedge tile2_resetdone1_i)
    begin
        if (!tile2_resetdone1_i )
        begin
            tile2_resetdone1_r    <=    1'b0;
            tile2_resetdone1_r2   <=    1'b0;
        end
        else
        begin
            tile2_resetdone1_r    <=    tile2_resetdone1_i;
            tile2_resetdone1_r2   <=    tile2_resetdone1_r;
        end
    end
    always @(posedge tile3_rxusrclk20_i or negedge tile3_resetdone0_i)
    begin
        if (!tile3_resetdone0_i )
        begin
            tile3_resetdone0_r    <=    1'b0;
            tile3_resetdone0_r2   <=    1'b0;
        end
        else
        begin
            tile3_resetdone0_r    <=    tile3_resetdone0_i;
            tile3_resetdone0_r2   <=    tile3_resetdone0_r;
        end
    end
    always @(posedge tile3_rxusrclk21_i or negedge tile3_resetdone1_i)
    begin
        if (!tile3_resetdone1_i )
        begin
            tile3_resetdone1_r    <=    1'b0;
            tile3_resetdone1_r2   <=    1'b0;
        end
        else
        begin
            tile3_resetdone1_r    <=    tile3_resetdone1_i;
            tile3_resetdone1_r2   <=    tile3_resetdone1_r;
        end
    end

    //---------------------------- Frame Generators ---------------------------
    // The example design uses Block RAM based frame generators to provide test
    // data to the GTPs for transmission. By default the frame generators are 
    // loaded with an incrementing data sequence that includes commas/alignment
    // characters for alignment. If your protocol uses channel bonding, the 
    // frame generator will also be preloaded with a channel bonding sequence.
    
    // You can modify the data transmitted by changing the INIT values of the frame
    // generator in this file. Pay careful attention to bit order and the spacing
    // of your control and alignment characters.

    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile0_frame_gen0
    (
        // User Interface
        .TX_DATA                        ({tile0_txdata0_float_i,tile0_txdata0_i}),
        .TX_CHARISK                     ({tile0_txcharisk0_float_i,tile0_txcharisk0_i}),
           
        // System Interface
        .USER_CLK                       (tile0_txusrclk20_i),
        .SYSTEM_RESET                   (tile0_tx_system_reset0_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile0_frame_gen1
    (
        // User Interface
        .TX_DATA                        ({tile0_txdata1_float_i,tile0_txdata1_i}),
        .TX_CHARISK                     ({tile0_txcharisk1_float_i,tile0_txcharisk1_i}),
           
        // System Interface
        .USER_CLK                       (tile0_txusrclk20_i),
        .SYSTEM_RESET                   (tile0_tx_system_reset1_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile1_frame_gen0
    (
        // User Interface
        .TX_DATA                        ({tile1_txdata0_float_i,tile1_txdata0_i}),
        .TX_CHARISK                     ({tile1_txcharisk0_float_i,tile1_txcharisk0_i}),
           
        // System Interface
        .USER_CLK                       (tile1_txusrclk20_i),
        .SYSTEM_RESET                   (tile1_tx_system_reset0_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile1_frame_gen1
    (
        // User Interface
        .TX_DATA                        ({tile1_txdata1_float_i,tile1_txdata1_i}),
        .TX_CHARISK                     ({tile1_txcharisk1_float_i,tile1_txcharisk1_i}),
           
        // System Interface
        .USER_CLK                       (tile1_txusrclk20_i),
        .SYSTEM_RESET                   (tile1_tx_system_reset1_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile2_frame_gen0
    (
        // User Interface
        .TX_DATA                        ({tile2_txdata0_float_i,tile2_txdata0_i}),
        .TX_CHARISK                     ({tile2_txcharisk0_float_i,tile2_txcharisk0_i}),
           
        // System Interface
        .USER_CLK                       (tile2_txusrclk20_i),
        .SYSTEM_RESET                   (tile2_tx_system_reset0_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile2_frame_gen1
    (
        // User Interface
        .TX_DATA                        ({tile2_txdata1_float_i,tile2_txdata1_i}),
        .TX_CHARISK                     ({tile2_txcharisk1_float_i,tile2_txcharisk1_i}),
           
        // System Interface
        .USER_CLK                       (tile2_txusrclk20_i),
        .SYSTEM_RESET                   (tile2_tx_system_reset1_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile3_frame_gen0
    (
        // User Interface
        .TX_DATA                        ({tile3_txdata0_float_i,tile3_txdata0_i}),
        .TX_CHARISK                     ({tile3_txcharisk0_float_i,tile3_txcharisk0_i}),
           
        // System Interface
        .USER_CLK                       (tile3_txusrclk20_i),
        .SYSTEM_RESET                   (tile3_tx_system_reset0_c)
    );
    
    FRAME_GEN #
    (
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile3_frame_gen1
    (
        // User Interface
        .TX_DATA                        ({tile3_txdata1_float_i,tile3_txdata1_i}),
        .TX_CHARISK                     ({tile3_txcharisk1_float_i,tile3_txcharisk1_i}),
           
        // System Interface
        .USER_CLK                       (tile3_txusrclk20_i),
        .SYSTEM_RESET                   (tile3_tx_system_reset1_c)
    );
    


    //-------------------------------- Frame Checkers -------------------------
    // The example design uses Block RAM based frame checkers to verify incoming  
    // data. By default the frame generators are loaded with a data sequence that 
    // matches the outgoing sequence of the frame generators for the TX ports.
    
    // You can modify the expected data sequence by changing the INIT values of the frame
    // checkers in this file. Pay careful attention to bit order and the spacing
    // of your control and alignment characters.
    
    // When the frame checker receives data, it attempts to synchronise to the 
    // incoming pattern by looking for the first sequence in the pattern. Once it 
    // finds the first sequence, it increments through the sequence, and indicates an 
    // error whenever the next value received does not match the expected value.

    assign tile0_frame_check0_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile0_matchn0_i;

    // tile0_frame_check0 is always connected to the lane with the start of char
    // and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    assign tile0_inc_in0_i = 1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(1),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile0_frame_check0
    (
        // MGT Interface
        .RX_DATA                        (tile0_rxdata0_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile0_inc_in0_i),
        .INC_OUT                        (tile0_inc_out0_i),
        .PATTERN_MATCH_N                (tile0_matchn0_i),
        .RESET_ON_ERROR                 (tile0_frame_check0_reset_i),
        // System Interface
        .USER_CLK                       (tile0_rxusrclk20_i),
        .SYSTEM_RESET                   (tile0_rx_system_reset0_c),
        .ERROR_COUNT                    (tile0_error_count0_i),
        .TRACK_DATA                     (tile0_track_data0_i)
    );
    
    assign tile0_frame_check1_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile0_matchn1_i;

    // tile0_frame_check0 is always connected to the lane with the start of char
    // and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    assign tile0_inc_in1_i = 1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(1),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile0_frame_check1
    (
        // MGT Interface
        .RX_DATA                        (tile0_rxdata1_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile0_inc_in1_i),
        .INC_OUT                        (tile0_inc_out1_i),
        .PATTERN_MATCH_N                (tile0_matchn1_i),
        .RESET_ON_ERROR                 (tile0_frame_check1_reset_i),
        // System Interface
        .USER_CLK                       (tile0_rxusrclk21_i),
        .SYSTEM_RESET                   (tile0_rx_system_reset1_c),
        .ERROR_COUNT                    (tile0_error_count1_i),
        .TRACK_DATA                     (tile0_track_data1_i)
    );
    
    assign tile1_frame_check0_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile1_matchn0_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign tile1_inc_in0_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?tile0_inc_out0_i:1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile1_frame_check0
    (
        // MGT Interface
        .RX_DATA                        (tile1_rxdata0_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile1_inc_in0_i),
        .INC_OUT                        (tile1_inc_out0_i),
        .PATTERN_MATCH_N                (tile1_matchn0_i),
        .RESET_ON_ERROR                 (tile1_frame_check0_reset_i),
        // System Interface
        .USER_CLK                       (tile1_rxusrclk20_i),
        .SYSTEM_RESET                   (tile1_rx_system_reset0_c),
        .ERROR_COUNT                    (tile1_error_count0_i),
        .TRACK_DATA                     (tile1_track_data0_i)
    );
    
    assign tile1_frame_check1_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile1_matchn1_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign tile1_inc_in1_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?tile0_inc_out1_i:1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile1_frame_check1
    (
        // MGT Interface
        .RX_DATA                        (tile1_rxdata1_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile1_inc_in1_i),
        .INC_OUT                        (tile1_inc_out1_i),
        .PATTERN_MATCH_N                (tile1_matchn1_i),
        .RESET_ON_ERROR                 (tile1_frame_check1_reset_i),
        // System Interface
        .USER_CLK                       (tile1_rxusrclk21_i),
        .SYSTEM_RESET                   (tile1_rx_system_reset1_c),
        .ERROR_COUNT                    (tile1_error_count1_i),
        .TRACK_DATA                     (tile1_track_data1_i)
    );
    
    assign tile2_frame_check0_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile2_matchn0_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign tile2_inc_in0_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?tile0_inc_out0_i:1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile2_frame_check0
    (
        // MGT Interface
        .RX_DATA                        (tile2_rxdata0_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile2_inc_in0_i),
        .INC_OUT                        (tile2_inc_out0_i),
        .PATTERN_MATCH_N                (tile2_matchn0_i),
        .RESET_ON_ERROR                 (tile2_frame_check0_reset_i),
        // System Interface
        .USER_CLK                       (tile2_rxusrclk20_i),
        .SYSTEM_RESET                   (tile2_rx_system_reset0_c),
        .ERROR_COUNT                    (tile2_error_count0_i),
        .TRACK_DATA                     (tile2_track_data0_i)
    );
    
    assign tile2_frame_check1_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile2_matchn1_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign tile2_inc_in1_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?tile0_inc_out1_i:1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile2_frame_check1
    (
        // MGT Interface
        .RX_DATA                        (tile2_rxdata1_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile2_inc_in1_i),
        .INC_OUT                        (tile2_inc_out1_i),
        .PATTERN_MATCH_N                (tile2_matchn1_i),
        .RESET_ON_ERROR                 (tile2_frame_check1_reset_i),
        // System Interface
        .USER_CLK                       (tile2_rxusrclk21_i),
        .SYSTEM_RESET                   (tile2_rx_system_reset1_c),
        .ERROR_COUNT                    (tile2_error_count1_i),
        .TRACK_DATA                     (tile2_track_data1_i)
    );
    
    assign tile3_frame_check0_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile3_matchn0_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign tile3_inc_in0_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?tile0_inc_out0_i:1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile3_frame_check0
    (
        // MGT Interface
        .RX_DATA                        (tile3_rxdata0_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile3_inc_in0_i),
        .INC_OUT                        (tile3_inc_out0_i),
        .PATTERN_MATCH_N                (tile3_matchn0_i),
        .RESET_ON_ERROR                 (tile3_frame_check0_reset_i),
        // System Interface
        .USER_CLK                       (tile3_rxusrclk20_i),
        .SYSTEM_RESET                   (tile3_rx_system_reset0_c),
        .ERROR_COUNT                    (tile3_error_count0_i),
        .TRACK_DATA                     (tile3_track_data0_i)
    );
    
    assign tile3_frame_check1_reset_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?reset_on_data_error_i:tile3_matchn1_i;

    // in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    // in this case, the INC_IN port is tied off.
    // Else, the data checking is triggered by the "master" lane
    assign tile3_inc_in1_i = (EXAMPLE_CONFIG_INDEPENDENT_LANES==0)?tile0_inc_out1_i:1'b0;

    FRAME_CHECK #
    (
        .RX_DATA_WIDTH(16),
        .USE_COMMA(1),
        .WORDS_IN_BRAM(EXAMPLE_WORDS_IN_BRAM),
        .CONFIG_INDEPENDENT_LANES(EXAMPLE_CONFIG_INDEPENDENT_LANES),
        .START_OF_PACKET_CHAR(8'hbc),
        .MEM_00(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_01(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_02(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_03(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_04(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_05(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_06(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_07(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_08(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_09(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_0A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_0B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_0C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_0D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_0E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_0F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_10(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_11(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_12(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_13(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_14(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_15(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_16(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_17(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_18(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_19(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_1A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_1B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_1C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_1D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_1E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_1F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_20(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_21(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_22(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_23(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_24(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_25(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_26(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_27(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_28(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_29(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_2A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_2B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_2C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_2D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_2E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_2F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_30(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_31(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_32(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_33(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_34(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_35(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_36(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_37(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEM_38(256'h00000e0d00000c0b00000a09000008070000060500000403000002bc00000100),
        .MEM_39(256'h00001e1d00001c1b00001a19000018170000161500001413000012110000100f),
        .MEM_3A(256'h00002e2d00002c2b00002a29000028270000262500002423000022210000201f),
        .MEM_3B(256'h00003e3d00003c3b00003a39000038370000363500003433000032310000302f),
        .MEM_3C(256'h00004e4d00004c4b00004a49000048470000464500004443000042410000403f),
        .MEM_3D(256'h00005e5d00005c5b00005a59000058570000565500005453000052510000504f),
        .MEM_3E(256'h00006e6d00006c6b00006a69000068670000666500006463000062610000605f),
        .MEM_3F(256'h00007e7d00007c7b00007a79000078770000767500007473000072710000706f),
        .MEMP_00(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_01(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_02(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_03(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_04(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_05(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_06(256'h0000000000000000000000000000000000000000000000000000000000000010),
        .MEMP_07(256'h0000000000000000000000000000000000000000000000000000000000000010)
    )
    tile3_frame_check1
    (
        // MGT Interface
        .RX_DATA                        (tile3_rxdata1_i),  
        .RX_ENMCOMMA_ALIGN              ( ),
        .RX_ENPCOMMA_ALIGN              ( ),
        .RX_ENCHAN_SYNC                 ( ),
        .RX_CHANBOND_SEQ                (tied_to_ground_i),        
        // Control Interface
        .INC_IN                         (tile3_inc_in1_i),
        .INC_OUT                        (tile3_inc_out1_i),
        .PATTERN_MATCH_N                (tile3_matchn1_i),
        .RESET_ON_ERROR                 (tile3_frame_check1_reset_i),
        // System Interface
        .USER_CLK                       (tile3_rxusrclk21_i),
        .SYSTEM_RESET                   (tile3_rx_system_reset1_c),
        .ERROR_COUNT                    (tile3_error_count1_i),
        .TRACK_DATA                     (tile3_track_data1_i)
    );
    


    assign TRACK_DATA_OUT = track_data_out_i;

    assign track_data_out_i = 
                                tile0_track_data0_i &
                                tile0_track_data1_i &
                                tile1_track_data0_i &
                                tile1_track_data1_i &
                                tile2_track_data0_i &
                                tile2_track_data1_i &
                                tile3_track_data0_i &
                                tile3_track_data1_i ;



    //--------------------------- Chipscope Connections -----------------------
    // When the example design is run in hardware, it uses chipscope to allow the
    // example design and GTP wrapper to be controlled and monitored. The 
    // EXAMPLE_USE_CHIPSCOPE parameter allows chipscope to be removed for simulation.
    
generate
if (EXAMPLE_USE_CHIPSCOPE==1) 
begin : chipscope


    // Shared VIO for all tiles
    shared_vio shared_vio_i
    (
      .control                          (shared_vio_control_i),
      .async_in                         (shared_vio_in_i),
      .async_out                        (shared_vio_out_i)
    );
    
    // ICON for all VIOs 
    icon i_icon
    (
      .control0                         (shared_vio_control_i),
      .control1                         (tile0_data_vio_control_i),
      .control2                         (tile0_gtp0_ila_control_i),
      .control3                         (tile0_gtp1_ila_control_i),
      .control4                         (tile1_data_vio_control_i),
      .control5                         (tile1_gtp0_ila_control_i),
      .control6                         (tile1_gtp1_ila_control_i),
      .control7                         (tile2_data_vio_control_i),
      .control8                         (tile2_gtp0_ila_control_i),
      .control9                         (tile2_gtp1_ila_control_i),
      .control10                        (tile3_data_vio_control_i),
      .control11                        (tile3_gtp0_ila_control_i),
      .control12                        (tile3_gtp1_ila_control_i)
    );

    // TILE0 DATA VIO 
    data_vio tile0_data_vio_i
    (
      .control                          (tile0_data_vio_control_i),
      .async_in                         (tile0_data_vio_in_i),
      .async_out                        (tile0_data_vio_out_i)  
    );      
    // TILE1 DATA VIO 
    data_vio tile1_data_vio_i
    (
      .control                          (tile1_data_vio_control_i),
      .async_in                         (tile1_data_vio_in_i),
      .async_out                        (tile1_data_vio_out_i)  
    );      
    // TILE2 DATA VIO 
    data_vio tile2_data_vio_i
    (
      .control                          (tile2_data_vio_control_i),
      .async_in                         (tile2_data_vio_in_i),
      .async_out                        (tile2_data_vio_out_i)  
    );      
    // TILE3 DATA VIO 
    data_vio tile3_data_vio_i
    (
      .control                          (tile3_data_vio_control_i),
      .async_in                         (tile3_data_vio_in_i),
      .async_out                        (tile3_data_vio_out_i)  
    );      

    // TILE0 GTP0 RX ILA 
    ila tile0_gtp0_i
    (
      .control                          (tile0_gtp0_ila_control_i),
      .clk                              (tile0_rxusrclk20_i),
      .trig0                            (tile0_ila_in0_i)
    );

    // TILE0 GTP1 RX ILA 
    ila tile0_gtp1_i
    (
      .control                          (tile0_gtp1_ila_control_i),
      .clk                              (tile0_rxusrclk21_i),
      .trig0                            (tile0_ila_in1_i)
    );

    // TILE1 GTP0 RX ILA 
    ila tile1_gtp0_i
    (
      .control                          (tile1_gtp0_ila_control_i),
      .clk                              (tile1_rxusrclk20_i),
      .trig0                            (tile1_ila_in0_i)
    );

    // TILE1 GTP1 RX ILA 
    ila tile1_gtp1_i
    (
      .control                          (tile1_gtp1_ila_control_i),
      .clk                              (tile1_rxusrclk21_i),
      .trig0                            (tile1_ila_in1_i)
    );

    // TILE2 GTP0 RX ILA 
    ila tile2_gtp0_i
    (
      .control                          (tile2_gtp0_ila_control_i),
      .clk                              (tile2_rxusrclk20_i),
      .trig0                            (tile2_ila_in0_i)
    );

    // TILE2 GTP1 RX ILA 
    ila tile2_gtp1_i
    (
      .control                          (tile2_gtp1_ila_control_i),
      .clk                              (tile2_rxusrclk21_i),
      .trig0                            (tile2_ila_in1_i)
    );

    // TILE3 GTP0 RX ILA 
    ila tile3_gtp0_i
    (
      .control                          (tile3_gtp0_ila_control_i),
      .clk                              (tile3_rxusrclk20_i),
      .trig0                            (tile3_ila_in0_i)
    );

    // TILE3 GTP1 RX ILA 
    ila tile3_gtp1_i
    (
      .control                          (tile3_gtp1_ila_control_i),
      .clk                              (tile3_rxusrclk21_i),
      .trig0                            (tile3_ila_in1_i)
    );





    // assign resets for frame_gen and frame_check modules
    assign  tile0_tx_system_reset0_c = !tile0_tx_sync_done0_i || user_tx_reset_i;
    assign  tile0_tx_system_reset1_c = !tile0_tx_sync_done1_i || user_tx_reset_i;
    assign  tile1_tx_system_reset0_c = !tile1_tx_sync_done0_i || user_tx_reset_i;
    assign  tile1_tx_system_reset1_c = !tile1_tx_sync_done1_i || user_tx_reset_i;
    assign  tile2_tx_system_reset0_c = !tile2_tx_sync_done0_i || user_tx_reset_i;
    assign  tile2_tx_system_reset1_c = !tile2_tx_sync_done1_i || user_tx_reset_i;
    assign  tile3_tx_system_reset0_c = !tile3_tx_sync_done0_i || user_tx_reset_i;
    assign  tile3_tx_system_reset1_c = !tile3_tx_sync_done1_i || user_tx_reset_i;
    assign  tile0_rx_system_reset0_c = !tile0_rx_sync_done0_i || user_rx_reset_i;
    assign  tile0_rx_system_reset1_c = !tile0_rx_sync_done1_i || user_rx_reset_i;
    assign  tile1_rx_system_reset0_c = !tile1_rx_sync_done0_i || user_rx_reset_i;
    assign  tile1_rx_system_reset1_c = !tile1_rx_sync_done1_i || user_rx_reset_i;
    assign  tile2_rx_system_reset0_c = !tile2_rx_sync_done0_i || user_rx_reset_i;
    assign  tile2_rx_system_reset1_c = !tile2_rx_sync_done1_i || user_rx_reset_i;
    assign  tile3_rx_system_reset0_c = !tile3_rx_sync_done0_i || user_rx_reset_i;
    assign  tile3_rx_system_reset1_c = !tile3_rx_sync_done1_i || user_rx_reset_i;


    assign  tile0_gtpreset0_i = gtpreset0_i;
 
    assign  tile0_gtpreset1_i = gtpreset0_i;
    assign  tile1_gtpreset0_i = gtpreset0_i;
 
    assign  tile1_gtpreset1_i = gtpreset0_i;
    assign  tile2_gtpreset0_i = gtpreset0_i;
 
    assign  tile2_gtpreset1_i = gtpreset0_i;
    assign  tile3_gtpreset0_i = gtpreset0_i;
 
    assign  tile3_gtpreset1_i = gtpreset0_i;


    // Shared VIO Outputs
    assign  gtpreset0_i                     =  shared_vio_out_i[31];
    assign  user_tx_reset_i                 =  shared_vio_out_i[30];
    assign  user_rx_reset_i                 =  shared_vio_out_i[29];

    // Shared VIO Inputs
    assign  shared_vio_in_i[31]             =  tile0_plllkdet0_i;
    assign  shared_vio_in_i[30]             =  tile1_plllkdet0_i;
    assign  shared_vio_in_i[29]             =  tile2_plllkdet0_i;
    assign  shared_vio_in_i[28]             =  tile3_plllkdet0_i;
    assign  shared_vio_in_i[27:0]           =  tied_to_ground_vec_i[27:0];

    // Chipscope VIO input connections on Tile 0
    assign  tile0_data_vio_in_i[139]        =  tile0_resetdone0_i;
    assign  tile0_data_vio_in_i[138]        =  tile0_resetdone1_i;
    assign  tile0_data_vio_in_i[137:0]      =  tied_to_ground_vec_i[137:0];

    // Chipscope VIO ouptut connections on Tile 0
    assign  tile0_loopback0_i               =  tile0_data_vio_out_i[139:137];
    assign  tile0_loopback1_i               =  tile0_data_vio_out_i[136:134];
    assign  tile0_prbscntreset0_i           =  tile0_data_vio_out_i[133];
    assign  tile0_prbscntreset1_i           =  tile0_data_vio_out_i[132];
    assign  tile0_rxenprbstst0_i            =  tile0_data_vio_out_i[131:129];
    assign  tile0_rxenprbstst1_i            =  tile0_data_vio_out_i[128:126];
    assign  tile0_rxeqmix0_i                =  tile0_data_vio_out_i[125:124];
    assign  tile0_rxeqmix1_i                =  tile0_data_vio_out_i[123:122];
    assign  tile0_txenprbstst0_i            =  tile0_data_vio_out_i[121:119];
    assign  tile0_txenprbstst1_i            =  tile0_data_vio_out_i[118:116];

    // Chipscope ILA connections for GTP0 on Tile 0
    assign  tile0_ila_in0_i[84:83]          =  tile0_rxdisperr0_i;
    assign  tile0_ila_in0_i[82:81]          =  tile0_rxnotintable0_i;
    assign  tile0_ila_in0_i[80]             =  tile0_rxprbserr0_i;
    assign  tile0_ila_in0_i[79:64]          =  tile0_rxdata0_i;
    assign  tile0_ila_in0_i[63:56]          =  tile0_error_count0_i;
    assign  tile0_ila_in0_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope ILA connections for GTP1 on Tile 0
    assign  tile0_ila_in1_i[84:83]          =  tile0_rxdisperr1_i;
    assign  tile0_ila_in1_i[82:81]          =  tile0_rxnotintable1_i;
    assign  tile0_ila_in1_i[80]             =  tile0_rxprbserr1_i;
    assign  tile0_ila_in1_i[79:64]          =  tile0_rxdata1_i;
    assign  tile0_ila_in1_i[63:56]          =  tile0_error_count1_i;
    assign  tile0_ila_in1_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope VIO input connections on Tile 1
    assign  tile1_data_vio_in_i[139]        =  tile1_resetdone0_i;
    assign  tile1_data_vio_in_i[138]        =  tile1_resetdone1_i;
    assign  tile1_data_vio_in_i[137:0]      =  tied_to_ground_vec_i[137:0];

    // Chipscope VIO ouptut connections on Tile 1
    assign  tile1_loopback0_i               =  tile1_data_vio_out_i[139:137];
    assign  tile1_loopback1_i               =  tile1_data_vio_out_i[136:134];
    assign  tile1_prbscntreset0_i           =  tile1_data_vio_out_i[133];
    assign  tile1_prbscntreset1_i           =  tile1_data_vio_out_i[132];
    assign  tile1_rxenprbstst0_i            =  tile1_data_vio_out_i[131:129];
    assign  tile1_rxenprbstst1_i            =  tile1_data_vio_out_i[128:126];
    assign  tile1_rxeqmix0_i                =  tile1_data_vio_out_i[125:124];
    assign  tile1_rxeqmix1_i                =  tile1_data_vio_out_i[123:122];
    assign  tile1_txenprbstst0_i            =  tile1_data_vio_out_i[121:119];
    assign  tile1_txenprbstst1_i            =  tile1_data_vio_out_i[118:116];

    // Chipscope ILA connections for GTP0 on Tile 1
    assign  tile1_ila_in0_i[84:83]          =  tile1_rxdisperr0_i;
    assign  tile1_ila_in0_i[82:81]          =  tile1_rxnotintable0_i;
    assign  tile1_ila_in0_i[80]             =  tile1_rxprbserr0_i;
    assign  tile1_ila_in0_i[79:64]          =  tile1_rxdata0_i;
    assign  tile1_ila_in0_i[63:56]          =  tile1_error_count0_i;
    assign  tile1_ila_in0_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope ILA connections for GTP1 on Tile 1
    assign  tile1_ila_in1_i[84:83]          =  tile1_rxdisperr1_i;
    assign  tile1_ila_in1_i[82:81]          =  tile1_rxnotintable1_i;
    assign  tile1_ila_in1_i[80]             =  tile1_rxprbserr1_i;
    assign  tile1_ila_in1_i[79:64]          =  tile1_rxdata1_i;
    assign  tile1_ila_in1_i[63:56]          =  tile1_error_count1_i;
    assign  tile1_ila_in1_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope VIO input connections on Tile 2
    assign  tile2_data_vio_in_i[139]        =  tile2_resetdone0_i;
    assign  tile2_data_vio_in_i[138]        =  tile2_resetdone1_i;
    assign  tile2_data_vio_in_i[137:0]      =  tied_to_ground_vec_i[137:0];

    // Chipscope VIO ouptut connections on Tile 2
    assign  tile2_loopback0_i               =  tile2_data_vio_out_i[139:137];
    assign  tile2_loopback1_i               =  tile2_data_vio_out_i[136:134];
    assign  tile2_prbscntreset0_i           =  tile2_data_vio_out_i[133];
    assign  tile2_prbscntreset1_i           =  tile2_data_vio_out_i[132];
    assign  tile2_rxenprbstst0_i            =  tile2_data_vio_out_i[131:129];
    assign  tile2_rxenprbstst1_i            =  tile2_data_vio_out_i[128:126];
    assign  tile2_rxeqmix0_i                =  tile2_data_vio_out_i[125:124];
    assign  tile2_rxeqmix1_i                =  tile2_data_vio_out_i[123:122];
    assign  tile2_txenprbstst0_i            =  tile2_data_vio_out_i[121:119];
    assign  tile2_txenprbstst1_i            =  tile2_data_vio_out_i[118:116];

    // Chipscope ILA connections for GTP0 on Tile 2
    assign  tile2_ila_in0_i[84:83]          =  tile2_rxdisperr0_i;
    assign  tile2_ila_in0_i[82:81]          =  tile2_rxnotintable0_i;
    assign  tile2_ila_in0_i[80]             =  tile2_rxprbserr0_i;
    assign  tile2_ila_in0_i[79:64]          =  tile2_rxdata0_i;
    assign  tile2_ila_in0_i[63:56]          =  tile2_error_count0_i;
    assign  tile2_ila_in0_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope ILA connections for GTP1 on Tile 2
    assign  tile2_ila_in1_i[84:83]          =  tile2_rxdisperr1_i;
    assign  tile2_ila_in1_i[82:81]          =  tile2_rxnotintable1_i;
    assign  tile2_ila_in1_i[80]             =  tile2_rxprbserr1_i;
    assign  tile2_ila_in1_i[79:64]          =  tile2_rxdata1_i;
    assign  tile2_ila_in1_i[63:56]          =  tile2_error_count1_i;
    assign  tile2_ila_in1_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope VIO input connections on Tile 3
    assign  tile3_data_vio_in_i[139]        =  tile3_resetdone0_i;
    assign  tile3_data_vio_in_i[138]        =  tile3_resetdone1_i;
    assign  tile3_data_vio_in_i[137:0]      =  tied_to_ground_vec_i[137:0];

    // Chipscope VIO ouptut connections on Tile 3
    assign  tile3_loopback0_i               =  tile3_data_vio_out_i[139:137];
    assign  tile3_loopback1_i               =  tile3_data_vio_out_i[136:134];
    assign  tile3_prbscntreset0_i           =  tile3_data_vio_out_i[133];
    assign  tile3_prbscntreset1_i           =  tile3_data_vio_out_i[132];
    assign  tile3_rxenprbstst0_i            =  tile3_data_vio_out_i[131:129];
    assign  tile3_rxenprbstst1_i            =  tile3_data_vio_out_i[128:126];
    assign  tile3_rxeqmix0_i                =  tile3_data_vio_out_i[125:124];
    assign  tile3_rxeqmix1_i                =  tile3_data_vio_out_i[123:122];
    assign  tile3_txenprbstst0_i            =  tile3_data_vio_out_i[121:119];
    assign  tile3_txenprbstst1_i            =  tile3_data_vio_out_i[118:116];

    // Chipscope ILA connections for GTP0 on Tile 3
    assign  tile3_ila_in0_i[84:83]          =  tile3_rxdisperr0_i;
    assign  tile3_ila_in0_i[82:81]          =  tile3_rxnotintable0_i;
    assign  tile3_ila_in0_i[80]             =  tile3_rxprbserr0_i;
    assign  tile3_ila_in0_i[79:64]          =  tile3_rxdata0_i;
    assign  tile3_ila_in0_i[63:56]          =  tile3_error_count0_i;
    assign  tile3_ila_in0_i[55:0]           =  tied_to_ground_vec_i[55:0];

    // Chipscope ILA connections for GTP1 on Tile 3
    assign  tile3_ila_in1_i[84:83]          =  tile3_rxdisperr1_i;
    assign  tile3_ila_in1_i[82:81]          =  tile3_rxnotintable1_i;
    assign  tile3_ila_in1_i[80]             =  tile3_rxprbserr1_i;
    assign  tile3_ila_in1_i[79:64]          =  tile3_rxdata1_i;
    assign  tile3_ila_in1_i[63:56]          =  tile3_error_count1_i;
    assign  tile3_ila_in1_i[55:0]           =  tied_to_ground_vec_i[55:0];




   
end //end EXAMPLE_USE_CHIPSCOPE=1 generate section
else
begin: no_chipscope

    // If Chipscope is not being used, drive GTP reset signal
    // from the top level ports
    assign  tile0_gtpreset0_i = GTP0_RESET_IN;
    assign  tile0_gtpreset1_i = GTP1_RESET_IN;
    assign  tile1_gtpreset0_i = GTP0_RESET_IN;
    assign  tile1_gtpreset1_i = GTP1_RESET_IN;
    assign  tile2_gtpreset0_i = GTP0_RESET_IN;
    assign  tile2_gtpreset1_i = GTP1_RESET_IN;
    assign  tile3_gtpreset0_i = GTP0_RESET_IN;
    assign  tile3_gtpreset1_i = GTP1_RESET_IN;

    // assign resets for frame_gen modules
    assign  tile0_tx_system_reset0_c = !tile0_tx_sync_done0_i;
    assign  tile0_tx_system_reset1_c = !tile0_tx_sync_done1_i;
    assign  tile1_tx_system_reset0_c = !tile1_tx_sync_done0_i;
    assign  tile1_tx_system_reset1_c = !tile1_tx_sync_done1_i;
    assign  tile2_tx_system_reset0_c = !tile2_tx_sync_done0_i;
    assign  tile2_tx_system_reset1_c = !tile2_tx_sync_done1_i;
    assign  tile3_tx_system_reset0_c = !tile3_tx_sync_done0_i;
    assign  tile3_tx_system_reset1_c = !tile3_tx_sync_done1_i;

    // assign resets for frame_check modules
    assign  tile0_rx_system_reset0_c = !tile0_rx_sync_done0_i;
    assign  tile0_rx_system_reset1_c = !tile0_rx_sync_done1_i;
    assign  tile1_rx_system_reset0_c = !tile1_rx_sync_done0_i;
    assign  tile1_rx_system_reset1_c = !tile1_rx_sync_done1_i;
    assign  tile2_rx_system_reset0_c = !tile2_rx_sync_done0_i;
    assign  tile2_rx_system_reset1_c = !tile2_rx_sync_done1_i;
    assign  tile3_rx_system_reset0_c = !tile3_rx_sync_done0_i;
    assign  tile3_rx_system_reset1_c = !tile3_rx_sync_done1_i;

    assign  gtpreset0_i                     =  tied_to_ground_i;
    assign  user_tx_reset_i                 =  tied_to_ground_i;
    assign  user_rx_reset_i                 =  tied_to_ground_i;
    assign  tile0_loopback0_i               =  tied_to_ground_vec_i[2:0];
    assign  tile0_loopback1_i               =  tied_to_ground_vec_i[2:0];
    assign  tile0_prbscntreset0_i           =  tied_to_ground_i;
    assign  tile0_prbscntreset1_i           =  tied_to_ground_i;
    assign  tile0_rxenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile0_rxenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile0_rxeqmix0_i                =  tied_to_ground_vec_i[1:0];
    assign  tile0_rxeqmix1_i                =  tied_to_ground_vec_i[1:0];
    assign  tile0_txenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile0_txenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile1_loopback0_i               =  tied_to_ground_vec_i[2:0];
    assign  tile1_loopback1_i               =  tied_to_ground_vec_i[2:0];
    assign  tile1_prbscntreset0_i           =  tied_to_ground_i;
    assign  tile1_prbscntreset1_i           =  tied_to_ground_i;
    assign  tile1_rxenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile1_rxenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile1_rxeqmix0_i                =  tied_to_ground_vec_i[1:0];
    assign  tile1_rxeqmix1_i                =  tied_to_ground_vec_i[1:0];
    assign  tile1_txenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile1_txenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile2_loopback0_i               =  tied_to_ground_vec_i[2:0];
    assign  tile2_loopback1_i               =  tied_to_ground_vec_i[2:0];
    assign  tile2_prbscntreset0_i           =  tied_to_ground_i;
    assign  tile2_prbscntreset1_i           =  tied_to_ground_i;
    assign  tile2_rxenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile2_rxenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile2_rxeqmix0_i                =  tied_to_ground_vec_i[1:0];
    assign  tile2_rxeqmix1_i                =  tied_to_ground_vec_i[1:0];
    assign  tile2_txenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile2_txenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile3_loopback0_i               =  tied_to_ground_vec_i[2:0];
    assign  tile3_loopback1_i               =  tied_to_ground_vec_i[2:0];
    assign  tile3_prbscntreset0_i           =  tied_to_ground_i;
    assign  tile3_prbscntreset1_i           =  tied_to_ground_i;
    assign  tile3_rxenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile3_rxenprbstst1_i            =  tied_to_ground_vec_i[2:0];
    assign  tile3_rxeqmix0_i                =  tied_to_ground_vec_i[1:0];
    assign  tile3_rxeqmix1_i                =  tied_to_ground_vec_i[1:0];
    assign  tile3_txenprbstst0_i            =  tied_to_ground_vec_i[2:0];
    assign  tile3_txenprbstst1_i            =  tied_to_ground_vec_i[2:0];



end
endgenerate //End generate for EXAMPLE_USE_CHIPSCOPE


endmodule

//-------------------------------------------------------------------
//
//  VIO core module declaration 
//  This one is for driving shared ports and is asynchronous
//
//-------------------------------------------------------------------
module shared_vio
  (
    control,
    async_in,
    async_out
  );
  inout  [35:0] control;
  input  [31:0] async_in;
  output [31:0] async_out;
endmodule


//-------------------------------------------------------------------
//
//  VIO core module declaration 
//  This one is for driving shared ports and is asynchronous
//
//-------------------------------------------------------------------
module data_vio
  (
    control,
    async_in,
    async_out
  );
  inout  [35:0] control;
  input  [139:0] async_in;
  output [139:0] async_out;
endmodule

//-------------------------------------------------------------------
//
//  ICON core module declaration
//
//-------------------------------------------------------------------
module icon 
  (
      control0,
      control1,
      control2,
      control3,
      control4,
      control5,
      control6,
      control7,
      control8,
      control9,
      control10,
      control11,
      control12
  );
  inout [35:0] control0;
  inout [35:0] control1;
  inout [35:0] control2;
  inout [35:0] control3;
  inout [35:0] control4;
  inout [35:0] control5;
  inout [35:0] control6;
  inout [35:0] control7;
  inout [35:0] control8;
  inout [35:0] control9;
  inout [35:0] control10;
  inout [35:0] control11;
  inout [35:0] control12;
endmodule


//-------------------------------------------------------------------
//
//  ILA core module declaration
//  This is used to allow RX signals to be monitored
//
//-------------------------------------------------------------------
module ila
  (
    control,
    clk,
    trig0
  );
  inout [35:0] control;
  input clk;
  input [84:0] trig0;
endmodule


//-------------------------------------------------------------------
//
//  NULL VIO core module declaration
//
//-------------------------------------------------------------------
module null_vio
  (
    control
  );
  inout [35:0] control;
endmodule

