------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 1.11
--  \   \         Application : Spartan-6 FPGA GTP Transceiver Wizard
--  /   /         Filename : ser16a_top.vhd
-- /___/   /\       
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module SER16A_TOP
-- Generated by Xilinx Spartan-6 FPGA GTP Transceiver Wizard
-- 
-- 
-- (c) Copyright 2009 - 2011 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;



--***********************************Entity Declaration************************

entity ser16a_top is
generic
(
    EXAMPLE_CONFIG_INDEPENDENT_LANES        : integer   := 1;
    EXAMPLE_LANE_WITH_START_CHAR            : integer   := 0;
    EXAMPLE_WORDS_IN_BRAM                   : integer   := 512;
    EXAMPLE_SIM_GTPRESET_SPEEDUP            : integer   := 0;
    EXAMPLE_USE_CHIPSCOPE                   : integer   := 1;     -- Set to 1 to use Chipscope to drive resets
    EXAMPLE_SIMULATION                      : integer   := 0     -- Set to 1 in testbench for simulation
);
port
(
    TILE0_GTP0_REFCLK_PAD_N_IN              : in   std_logic;
    TILE0_GTP0_REFCLK_PAD_P_IN              : in   std_logic;
    TILE3_GTP0_REFCLK_PAD_N_IN              : in   std_logic;
    TILE3_GTP0_REFCLK_PAD_P_IN              : in   std_logic;
    GTP0_RESET_IN                           : in   std_logic;
    GTP1_RESET_IN                           : in   std_logic;
    TILE0_GTP0_PLLLKDET_OUT                 : out  std_logic;
    TILE1_GTP0_PLLLKDET_OUT                 : out  std_logic;
    TILE2_GTP0_PLLLKDET_OUT                 : out  std_logic;
    TILE3_GTP0_PLLLKDET_OUT                 : out  std_logic;
    TRACK_DATA_OUT                          : out  std_logic;
    RXN_IN                                  : in   std_logic_vector(7 downto 0);
    RXP_IN                                  : in   std_logic_vector(7 downto 0);
    TXN_OUT                                 : out  std_logic_vector(7 downto 0);
    TXP_OUT                                 : out  std_logic_vector(7 downto 0)
);
end ser16a_top;
    
architecture RTL of ser16a_top is

--**************************Component Declarations*****************************


component ser16a 
generic
(
    -- Simulation attributes  
    WRAPPER_SIM_GTPRESET_SPEEDUP    : integer   := 0; -- Set to 1 to speed up sim reset
    WRAPPER_CLK25_DIVIDER_0         : integer   := 4;
    WRAPPER_CLK25_DIVIDER_1         : integer   := 4;
    WRAPPER_PLL_DIVSEL_FB_0         : integer   := 5;
    WRAPPER_PLL_DIVSEL_FB_1         : integer   := 5;
    WRAPPER_PLL_DIVSEL_REF_0        : integer   := 2;
    WRAPPER_PLL_DIVSEL_REF_1        : integer   := 2;
    WRAPPER_SIMULATION              : integer   := 0  -- Set to 1 for simulation  
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE0  (X0_Y0)

 
    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE0_LOOPBACK0_IN                      : in   std_logic_vector(2 downto 0);
    TILE0_LOOPBACK1_IN                      : in   std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    TILE0_CLK00_IN                          : in   std_logic;
    TILE0_CLK01_IN                          : in   std_logic;
    TILE0_GTPRESET0_IN                      : in   std_logic;
    TILE0_GTPRESET1_IN                      : in   std_logic;
    TILE0_PLLLKDET0_OUT                     : out  std_logic;
    TILE0_RESETDONE0_OUT                    : out  std_logic;
    TILE0_RESETDONE1_OUT                    : out  std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE0_RXDISPERR0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE0_RXDISPERR1_OUT                    : out  std_logic_vector(1 downto 0);
    TILE0_RXNOTINTABLE0_OUT                 : out  std_logic_vector(1 downto 0);
    TILE0_RXNOTINTABLE1_OUT                 : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE0_RXBYTEISALIGNED0_OUT              : out  std_logic;
    TILE0_RXBYTEISALIGNED1_OUT              : out  std_logic;
    TILE0_RXBYTEREALIGN0_OUT                : out  std_logic;
    TILE0_RXBYTEREALIGN1_OUT                : out  std_logic;
    TILE0_RXCOMMADET0_OUT                   : out  std_logic;
    TILE0_RXCOMMADET1_OUT                   : out  std_logic;
    TILE0_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE0_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE0_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE0_RXENPCOMMAALIGN1_IN               : in   std_logic;
    TILE0_RXSLIDE0_IN                       : in   std_logic;
    TILE0_RXSLIDE1_IN                       : in   std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    TILE0_PRBSCNTRESET0_IN                  : in   std_logic;
    TILE0_PRBSCNTRESET1_IN                  : in   std_logic;
    TILE0_RXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_RXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_RXPRBSERR0_OUT                    : out  std_logic;
    TILE0_RXPRBSERR1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE0_RXDATA0_OUT                       : out  std_logic_vector(15 downto 0);
    TILE0_RXDATA1_OUT                       : out  std_logic_vector(15 downto 0);
    TILE0_RXRECCLK0_OUT                     : out  std_logic;
    TILE0_RXRECCLK1_OUT                     : out  std_logic;
    TILE0_RXRESET0_IN                       : in   std_logic;
    TILE0_RXRESET1_IN                       : in   std_logic;
    TILE0_RXUSRCLK0_IN                      : in   std_logic;
    TILE0_RXUSRCLK1_IN                      : in   std_logic;
    TILE0_RXUSRCLK20_IN                     : in   std_logic;
    TILE0_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE0_RXN0_IN                           : in   std_logic;
    TILE0_RXN1_IN                           : in   std_logic;
    TILE0_RXP0_IN                           : in   std_logic;
    TILE0_RXP1_IN                           : in   std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    TILE0_RXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE0_RXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE0_RXPMASETPHASE0_IN                 : in   std_logic;
    TILE0_RXPMASETPHASE1_IN                 : in   std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE0_GTPCLKFBEAST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE0_GTPCLKFBWEST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE0_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE0_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    TILE0_TXCHARISK0_IN                     : in   std_logic_vector(1 downto 0);
    TILE0_TXCHARISK1_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    TILE0_TXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE0_TXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE0_TXPMASETPHASE0_IN                 : in   std_logic;
    TILE0_TXPMASETPHASE1_IN                 : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE0_TXDATA0_IN                        : in   std_logic_vector(15 downto 0);
    TILE0_TXDATA1_IN                        : in   std_logic_vector(15 downto 0);
    TILE0_TXOUTCLK0_OUT                     : out  std_logic;
    TILE0_TXOUTCLK1_OUT                     : out  std_logic;
    TILE0_TXRESET0_IN                       : in   std_logic;
    TILE0_TXRESET1_IN                       : in   std_logic;
    TILE0_TXUSRCLK0_IN                      : in   std_logic;
    TILE0_TXUSRCLK1_IN                      : in   std_logic;
    TILE0_TXUSRCLK20_IN                     : in   std_logic;
    TILE0_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE0_TXN0_OUT                          : out  std_logic;
    TILE0_TXN1_OUT                          : out  std_logic;
    TILE0_TXP0_OUT                          : out  std_logic;
    TILE0_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE0_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE0_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE0_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE1  (X1_Y0)

 
    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE1_LOOPBACK0_IN                      : in   std_logic_vector(2 downto 0);
    TILE1_LOOPBACK1_IN                      : in   std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    TILE1_CLK00_IN                          : in   std_logic;
    TILE1_CLK01_IN                          : in   std_logic;
    TILE1_GTPRESET0_IN                      : in   std_logic;
    TILE1_GTPRESET1_IN                      : in   std_logic;
    TILE1_PLLLKDET0_OUT                     : out  std_logic;
    TILE1_RESETDONE0_OUT                    : out  std_logic;
    TILE1_RESETDONE1_OUT                    : out  std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE1_RXDISPERR0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE1_RXDISPERR1_OUT                    : out  std_logic_vector(1 downto 0);
    TILE1_RXNOTINTABLE0_OUT                 : out  std_logic_vector(1 downto 0);
    TILE1_RXNOTINTABLE1_OUT                 : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE1_RXBYTEISALIGNED0_OUT              : out  std_logic;
    TILE1_RXBYTEISALIGNED1_OUT              : out  std_logic;
    TILE1_RXBYTEREALIGN0_OUT                : out  std_logic;
    TILE1_RXBYTEREALIGN1_OUT                : out  std_logic;
    TILE1_RXCOMMADET0_OUT                   : out  std_logic;
    TILE1_RXCOMMADET1_OUT                   : out  std_logic;
    TILE1_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE1_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE1_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE1_RXENPCOMMAALIGN1_IN               : in   std_logic;
    TILE1_RXSLIDE0_IN                       : in   std_logic;
    TILE1_RXSLIDE1_IN                       : in   std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    TILE1_PRBSCNTRESET0_IN                  : in   std_logic;
    TILE1_PRBSCNTRESET1_IN                  : in   std_logic;
    TILE1_RXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_RXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_RXPRBSERR0_OUT                    : out  std_logic;
    TILE1_RXPRBSERR1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE1_RXDATA0_OUT                       : out  std_logic_vector(15 downto 0);
    TILE1_RXDATA1_OUT                       : out  std_logic_vector(15 downto 0);
    TILE1_RXRECCLK0_OUT                     : out  std_logic;
    TILE1_RXRECCLK1_OUT                     : out  std_logic;
    TILE1_RXRESET0_IN                       : in   std_logic;
    TILE1_RXRESET1_IN                       : in   std_logic;
    TILE1_RXUSRCLK0_IN                      : in   std_logic;
    TILE1_RXUSRCLK1_IN                      : in   std_logic;
    TILE1_RXUSRCLK20_IN                     : in   std_logic;
    TILE1_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE1_RXN0_IN                           : in   std_logic;
    TILE1_RXN1_IN                           : in   std_logic;
    TILE1_RXP0_IN                           : in   std_logic;
    TILE1_RXP1_IN                           : in   std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    TILE1_RXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE1_RXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE1_RXPMASETPHASE0_IN                 : in   std_logic;
    TILE1_RXPMASETPHASE1_IN                 : in   std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE1_GTPCLKFBEAST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE1_GTPCLKFBWEST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE1_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE1_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    TILE1_TXCHARISK0_IN                     : in   std_logic_vector(1 downto 0);
    TILE1_TXCHARISK1_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    TILE1_TXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE1_TXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE1_TXPMASETPHASE0_IN                 : in   std_logic;
    TILE1_TXPMASETPHASE1_IN                 : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE1_TXDATA0_IN                        : in   std_logic_vector(15 downto 0);
    TILE1_TXDATA1_IN                        : in   std_logic_vector(15 downto 0);
    TILE1_TXOUTCLK0_OUT                     : out  std_logic;
    TILE1_TXOUTCLK1_OUT                     : out  std_logic;
    TILE1_TXRESET0_IN                       : in   std_logic;
    TILE1_TXRESET1_IN                       : in   std_logic;
    TILE1_TXUSRCLK0_IN                      : in   std_logic;
    TILE1_TXUSRCLK1_IN                      : in   std_logic;
    TILE1_TXUSRCLK20_IN                     : in   std_logic;
    TILE1_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE1_TXN0_OUT                          : out  std_logic;
    TILE1_TXN1_OUT                          : out  std_logic;
    TILE1_TXP0_OUT                          : out  std_logic;
    TILE1_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE1_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE1_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE1_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE2  (X0_Y1)

 
    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE2_LOOPBACK0_IN                      : in   std_logic_vector(2 downto 0);
    TILE2_LOOPBACK1_IN                      : in   std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    TILE2_CLK00_IN                          : in   std_logic;
    TILE2_CLK01_IN                          : in   std_logic;
    TILE2_GTPRESET0_IN                      : in   std_logic;
    TILE2_GTPRESET1_IN                      : in   std_logic;
    TILE2_PLLLKDET0_OUT                     : out  std_logic;
    TILE2_RESETDONE0_OUT                    : out  std_logic;
    TILE2_RESETDONE1_OUT                    : out  std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE2_RXDISPERR0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE2_RXDISPERR1_OUT                    : out  std_logic_vector(1 downto 0);
    TILE2_RXNOTINTABLE0_OUT                 : out  std_logic_vector(1 downto 0);
    TILE2_RXNOTINTABLE1_OUT                 : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE2_RXBYTEISALIGNED0_OUT              : out  std_logic;
    TILE2_RXBYTEISALIGNED1_OUT              : out  std_logic;
    TILE2_RXBYTEREALIGN0_OUT                : out  std_logic;
    TILE2_RXBYTEREALIGN1_OUT                : out  std_logic;
    TILE2_RXCOMMADET0_OUT                   : out  std_logic;
    TILE2_RXCOMMADET1_OUT                   : out  std_logic;
    TILE2_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE2_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE2_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE2_RXENPCOMMAALIGN1_IN               : in   std_logic;
    TILE2_RXSLIDE0_IN                       : in   std_logic;
    TILE2_RXSLIDE1_IN                       : in   std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    TILE2_PRBSCNTRESET0_IN                  : in   std_logic;
    TILE2_PRBSCNTRESET1_IN                  : in   std_logic;
    TILE2_RXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_RXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_RXPRBSERR0_OUT                    : out  std_logic;
    TILE2_RXPRBSERR1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE2_RXDATA0_OUT                       : out  std_logic_vector(15 downto 0);
    TILE2_RXDATA1_OUT                       : out  std_logic_vector(15 downto 0);
    TILE2_RXRECCLK0_OUT                     : out  std_logic;
    TILE2_RXRECCLK1_OUT                     : out  std_logic;
    TILE2_RXRESET0_IN                       : in   std_logic;
    TILE2_RXRESET1_IN                       : in   std_logic;
    TILE2_RXUSRCLK0_IN                      : in   std_logic;
    TILE2_RXUSRCLK1_IN                      : in   std_logic;
    TILE2_RXUSRCLK20_IN                     : in   std_logic;
    TILE2_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE2_RXN0_IN                           : in   std_logic;
    TILE2_RXN1_IN                           : in   std_logic;
    TILE2_RXP0_IN                           : in   std_logic;
    TILE2_RXP1_IN                           : in   std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    TILE2_RXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE2_RXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE2_RXPMASETPHASE0_IN                 : in   std_logic;
    TILE2_RXPMASETPHASE1_IN                 : in   std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE2_GTPCLKFBEAST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE2_GTPCLKFBWEST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE2_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE2_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    TILE2_TXCHARISK0_IN                     : in   std_logic_vector(1 downto 0);
    TILE2_TXCHARISK1_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    TILE2_TXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE2_TXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE2_TXPMASETPHASE0_IN                 : in   std_logic;
    TILE2_TXPMASETPHASE1_IN                 : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE2_TXDATA0_IN                        : in   std_logic_vector(15 downto 0);
    TILE2_TXDATA1_IN                        : in   std_logic_vector(15 downto 0);
    TILE2_TXOUTCLK0_OUT                     : out  std_logic;
    TILE2_TXOUTCLK1_OUT                     : out  std_logic;
    TILE2_TXRESET0_IN                       : in   std_logic;
    TILE2_TXRESET1_IN                       : in   std_logic;
    TILE2_TXUSRCLK0_IN                      : in   std_logic;
    TILE2_TXUSRCLK1_IN                      : in   std_logic;
    TILE2_TXUSRCLK20_IN                     : in   std_logic;
    TILE2_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE2_TXN0_OUT                          : out  std_logic;
    TILE2_TXN1_OUT                          : out  std_logic;
    TILE2_TXP0_OUT                          : out  std_logic;
    TILE2_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE2_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE2_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE2_TXPRBSFORCEERR1_IN                : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --TILE3  (X1_Y1)

 
    ------------------------ Loopback and Powerdown Ports ----------------------
    TILE3_LOOPBACK0_IN                      : in   std_logic_vector(2 downto 0);
    TILE3_LOOPBACK1_IN                      : in   std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    TILE3_CLK00_IN                          : in   std_logic;
    TILE3_CLK01_IN                          : in   std_logic;
    TILE3_GTPRESET0_IN                      : in   std_logic;
    TILE3_GTPRESET1_IN                      : in   std_logic;
    TILE3_PLLLKDET0_OUT                     : out  std_logic;
    TILE3_RESETDONE0_OUT                    : out  std_logic;
    TILE3_RESETDONE1_OUT                    : out  std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    TILE3_RXDISPERR0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE3_RXDISPERR1_OUT                    : out  std_logic_vector(1 downto 0);
    TILE3_RXNOTINTABLE0_OUT                 : out  std_logic_vector(1 downto 0);
    TILE3_RXNOTINTABLE1_OUT                 : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    TILE3_RXBYTEISALIGNED0_OUT              : out  std_logic;
    TILE3_RXBYTEISALIGNED1_OUT              : out  std_logic;
    TILE3_RXBYTEREALIGN0_OUT                : out  std_logic;
    TILE3_RXBYTEREALIGN1_OUT                : out  std_logic;
    TILE3_RXCOMMADET0_OUT                   : out  std_logic;
    TILE3_RXCOMMADET1_OUT                   : out  std_logic;
    TILE3_RXENMCOMMAALIGN0_IN               : in   std_logic;
    TILE3_RXENMCOMMAALIGN1_IN               : in   std_logic;
    TILE3_RXENPCOMMAALIGN0_IN               : in   std_logic;
    TILE3_RXENPCOMMAALIGN1_IN               : in   std_logic;
    TILE3_RXSLIDE0_IN                       : in   std_logic;
    TILE3_RXSLIDE1_IN                       : in   std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    TILE3_PRBSCNTRESET0_IN                  : in   std_logic;
    TILE3_PRBSCNTRESET1_IN                  : in   std_logic;
    TILE3_RXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_RXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_RXPRBSERR0_OUT                    : out  std_logic;
    TILE3_RXPRBSERR1_OUT                    : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    TILE3_RXDATA0_OUT                       : out  std_logic_vector(15 downto 0);
    TILE3_RXDATA1_OUT                       : out  std_logic_vector(15 downto 0);
    TILE3_RXRECCLK0_OUT                     : out  std_logic;
    TILE3_RXRECCLK1_OUT                     : out  std_logic;
    TILE3_RXRESET0_IN                       : in   std_logic;
    TILE3_RXRESET1_IN                       : in   std_logic;
    TILE3_RXUSRCLK0_IN                      : in   std_logic;
    TILE3_RXUSRCLK1_IN                      : in   std_logic;
    TILE3_RXUSRCLK20_IN                     : in   std_logic;
    TILE3_RXUSRCLK21_IN                     : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    TILE3_RXN0_IN                           : in   std_logic;
    TILE3_RXN1_IN                           : in   std_logic;
    TILE3_RXP0_IN                           : in   std_logic;
    TILE3_RXP1_IN                           : in   std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    TILE3_RXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE3_RXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE3_RXPMASETPHASE0_IN                 : in   std_logic;
    TILE3_RXPMASETPHASE1_IN                 : in   std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    TILE3_GTPCLKFBEAST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE3_GTPCLKFBWEST_OUT                  : out  std_logic_vector(1 downto 0);
    TILE3_GTPCLKOUT0_OUT                    : out  std_logic_vector(1 downto 0);
    TILE3_GTPCLKOUT1_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    TILE3_TXCHARISK0_IN                     : in   std_logic_vector(1 downto 0);
    TILE3_TXCHARISK1_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    TILE3_TXENPMAPHASEALIGN0_IN             : in   std_logic;
    TILE3_TXENPMAPHASEALIGN1_IN             : in   std_logic;
    TILE3_TXPMASETPHASE0_IN                 : in   std_logic;
    TILE3_TXPMASETPHASE1_IN                 : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    TILE3_TXDATA0_IN                        : in   std_logic_vector(15 downto 0);
    TILE3_TXDATA1_IN                        : in   std_logic_vector(15 downto 0);
    TILE3_TXOUTCLK0_OUT                     : out  std_logic;
    TILE3_TXOUTCLK1_OUT                     : out  std_logic;
    TILE3_TXRESET0_IN                       : in   std_logic;
    TILE3_TXRESET1_IN                       : in   std_logic;
    TILE3_TXUSRCLK0_IN                      : in   std_logic;
    TILE3_TXUSRCLK1_IN                      : in   std_logic;
    TILE3_TXUSRCLK20_IN                     : in   std_logic;
    TILE3_TXUSRCLK21_IN                     : in   std_logic;
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    TILE3_TXN0_OUT                          : out  std_logic;
    TILE3_TXN1_OUT                          : out  std_logic;
    TILE3_TXP0_OUT                          : out  std_logic;
    TILE3_TXP1_OUT                          : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    TILE3_TXENPRBSTST0_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_TXENPRBSTST1_IN                   : in   std_logic_vector(2 downto 0);
    TILE3_TXPRBSFORCEERR0_IN                : in   std_logic;
    TILE3_TXPRBSFORCEERR1_IN                : in   std_logic


);
end component;


component MGT_USRCLK_SOURCE 
generic
(
    FREQUENCY_MODE   : string   := "LOW";
    DIVIDE_2         : boolean  := false;    
    FEEDBACK         : string   := "1X";
    DIVIDE           : real     := 2.0    
);
port
(
    DIV1_OUT                : out std_logic;
    DIV2_OUT                : out std_logic;
    CLK2X_OUT               : out std_logic;
    DCM_LOCKED_OUT          : out std_logic;
    CLK_IN                  : in  std_logic;
    FB_IN                   : in  std_logic;
    DCM_RESET_IN            : in  std_logic

);
end component;

component FRAME_GEN 
generic
(
    WORDS_IN_BRAM : integer    :=   256;
    MEM_00       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_01       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_02       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_03       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_04       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_05       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_06       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_07       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_08       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_09       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_10       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_11       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_12       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_13       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_14       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_15       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_16       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_17       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_18       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_19       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_20       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_21       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_22       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_23       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_24       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_25       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_26       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_27       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_28       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_29       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_30       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_31       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_32       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_33       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_34       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_35       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_36       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_37       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_38       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_39       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_00      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_01      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_02      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_03      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_04      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_05      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_06      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_07      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000"
);    
port
(
    -- User Interface
    TX_DATA             : out   std_logic_vector(39 downto 0);
    TX_CHARISK          : out   std_logic_vector(3 downto 0); 

    -- System Interface
    USER_CLK            : in    std_logic;
    SYSTEM_RESET        : in    std_logic
); 
end component;

component FRAME_CHECK 
generic
(
    RX_DATA_WIDTH            : integer := 16;
    USE_COMMA                : integer := 1;
    NONE_MSB_FIRST_DEC       : integer := 0;
    CHANBOND_SEQ_LEN         : integer := 1;
    WORDS_IN_BRAM            : integer := 256;
    CONFIG_INDEPENDENT_LANES : integer := 0;
    START_OF_PACKET_CHAR     : std_logic_vector := x"55fb";
    MEM_00       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_01       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_02       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_03       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_04       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_05       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_06       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_07       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_08       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_09       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_0F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_10       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_11       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_12       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_13       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_14       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_15       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_16       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_17       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_18       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_19       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_1F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_20       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_21       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_22       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_23       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_24       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_25       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_26       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_27       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_28       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_29       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_2F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_30       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_31       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_32       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_33       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_34       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_35       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_36       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_37       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_38       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_39       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3A       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3B       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3C       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3D       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3E       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEM_3F       : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_00      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_01      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_02      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_03      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_04      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_05      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_06      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000";
    MEMP_07      : bit_vector :=   X"0000000000000000000000000000000000000000000000000000000000000000"
);
port
(
    -- User Interface
    RX_DATA                  : in  std_logic_vector((RX_DATA_WIDTH-1) downto 0); 
    RX_ENMCOMMA_ALIGN        : out std_logic;
    RX_ENPCOMMA_ALIGN        : out std_logic;
    RX_ENCHAN_SYNC           : out std_logic; 
    RX_CHANBOND_SEQ          : in  std_logic; 

    -- Control Interface
    INC_IN                   : in std_logic; 
    INC_OUT                  : out std_logic; 
    PATTERN_MATCH_N          : out std_logic;
    RESET_ON_ERROR           : in std_logic; 
    
    -- Error Monitoring
    ERROR_COUNT              : out std_logic_vector(7 downto 0);

    -- Track Data
    TRACK_DATA               : out std_logic;

    -- System Interface
    USER_CLK                 : in std_logic;
    SYSTEM_RESET             : in std_logic
  
);
end component;

component MGT_USRCLK_SOURCE_PLL 
generic
(
    MULT                 : integer          := 2;
    DIVIDE               : integer          := 2;
    FEEDBACK             : string           := "CLKFBOUT";    
    CLK_PERIOD           : real             := 6.26;
    OUT0_DIVIDE          : integer          := 2;
    OUT1_DIVIDE          : integer          := 2;
    OUT2_DIVIDE          : integer          := 2;
    OUT3_DIVIDE          : integer          := 2   
);
port
( 
    CLK0_OUT                : out std_logic;
    CLK1_OUT                : out std_logic;
    CLK2_OUT                : out std_logic;
    CLK3_OUT                : out std_logic;
    CLK_IN                  : in  std_logic;
    CLKFB_IN                : in  std_logic;    
    CLKFB_OUT               : out std_logic;      
    PLL_LOCKED_OUT          : out std_logic;
    PLL_RESET_IN            : in  std_logic
);
end component;


component ser16a_tx_sync
generic
(
    PLL_DIVSEL_OUT       : integer := 1
);
port
(
    TXENPMAPHASEALIGN       : out std_logic;
    TXPMASETPHASE           : out std_logic;
    SYNC_DONE               : out std_logic;
    USER_CLK                : in  std_logic;
    RESET                   : in  std_logic
);
end component;

component ser16a_rx_sync 
port
(
    RXENPMAPHASEALIGN       : out std_logic;
    RXPMASETPHASE           : out std_logic;
    SYNC_DONE               : out std_logic;
    USER_CLK                : in  std_logic;
    RESET                   : in  std_logic

);
end component;


-- Chipscope modules
attribute syn_black_box                : boolean;
attribute syn_noprune                  : boolean;


component shared_vio
port
(
    control                 : inout  std_logic_vector(35 downto 0);
    async_in                : in  std_logic_vector(31 downto 0);
    async_out               : out std_logic_vector(31 downto 0)
);
end component;
attribute syn_black_box of shared_vio : component is TRUE;
attribute syn_noprune of shared_vio   : component is TRUE;


component data_vio
port
(
    control                 : inout  std_logic_vector(35 downto 0);
    async_in                : in  std_logic_vector(139 downto 0);
    async_out               : out std_logic_vector(139 downto 0)
);
end component;
attribute syn_black_box of data_vio : component is TRUE;
attribute syn_noprune of data_vio   : component is TRUE;


component icon
port
(
    control0                : inout std_logic_vector(35 downto 0);
    control1                : inout std_logic_vector(35 downto 0);
    control2                : inout std_logic_vector(35 downto 0);
    control3                : inout std_logic_vector(35 downto 0);
    control4                : inout std_logic_vector(35 downto 0);
    control5                : inout std_logic_vector(35 downto 0);
    control6                : inout std_logic_vector(35 downto 0);
    control7                : inout std_logic_vector(35 downto 0);
    control8                : inout std_logic_vector(35 downto 0);
    control9                : inout std_logic_vector(35 downto 0);
    control10               : inout std_logic_vector(35 downto 0);
    control11               : inout std_logic_vector(35 downto 0);
    control12               : inout std_logic_vector(35 downto 0)
);
end component;
attribute syn_black_box of icon : component is TRUE;
attribute syn_noprune of icon   : component is TRUE;


component ila
port
(
    control                 : inout  std_logic_vector(35 downto 0);
    clk                     : in  std_logic;
    trig0                   : in  std_logic_vector(84 downto 0)
);
end component;
attribute syn_black_box of ila : component is TRUE;
attribute syn_noprune of ila   : component is TRUE;


component null_vio
port
(
    control                 : inout  std_logic_vector(35 downto 0)
);
end component;
attribute syn_black_box of null_vio : component is TRUE;
attribute syn_noprune of null_vio   : component is TRUE;


--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;
    
--************************** Register Declarations ****************************

    signal     tile0_tx_resetdone0_r           : std_logic;
    signal     tile0_tx_resetdone0_r2          : std_logic;
    signal     tile0_rx_resetdone0_r           : std_logic;
    signal     tile0_rx_resetdone0_r2          : std_logic;
    signal     tile0_tx_resetdone1_r           : std_logic;
    signal     tile0_tx_resetdone1_r2          : std_logic;
    signal     tile0_rx_resetdone1_r           : std_logic;
    signal     tile0_rx_resetdone1_r2          : std_logic;
    signal     tile1_tx_resetdone0_r           : std_logic;
    signal     tile1_tx_resetdone0_r2          : std_logic;
    signal     tile1_rx_resetdone0_r           : std_logic;
    signal     tile1_rx_resetdone0_r2          : std_logic;
    signal     tile1_tx_resetdone1_r           : std_logic;
    signal     tile1_tx_resetdone1_r2          : std_logic;
    signal     tile1_rx_resetdone1_r           : std_logic;
    signal     tile1_rx_resetdone1_r2          : std_logic;
    signal     tile2_tx_resetdone0_r           : std_logic;
    signal     tile2_tx_resetdone0_r2          : std_logic;
    signal     tile2_rx_resetdone0_r           : std_logic;
    signal     tile2_rx_resetdone0_r2          : std_logic;
    signal     tile2_tx_resetdone1_r           : std_logic;
    signal     tile2_tx_resetdone1_r2          : std_logic;
    signal     tile2_rx_resetdone1_r           : std_logic;
    signal     tile2_rx_resetdone1_r2          : std_logic;
    signal     tile3_tx_resetdone0_r           : std_logic;
    signal     tile3_tx_resetdone0_r2          : std_logic;
    signal     tile3_rx_resetdone0_r           : std_logic;
    signal     tile3_rx_resetdone0_r2          : std_logic;
    signal     tile3_tx_resetdone1_r           : std_logic;
    signal     tile3_tx_resetdone1_r2          : std_logic;
    signal     tile3_rx_resetdone1_r           : std_logic;
    signal     tile3_rx_resetdone1_r2          : std_logic;

--**************************** Wire Declarations ******************************

    -------------------------- MGT Wrapper Wires ------------------------------

    --________________________________________________________________________
    --________________________________________________________________________
    --TILE0   (X0_Y0)

    ------------------------ Loopback and Powerdown Ports ----------------------
    signal  tile0_loopback0_i               : std_logic_vector(2 downto 0);
    signal  tile0_loopback1_i               : std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    signal  tile0_gtpreset0_i               : std_logic;
    signal  tile0_gtpreset1_i               : std_logic;
    signal  tile0_plllkdet0_i               : std_logic;
    signal  tile0_plllkdet1_i               : std_logic;
    signal  tile0_resetdone0_i              : std_logic;
    signal  tile0_resetdone1_i              : std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile0_rxdisperr0_i              : std_logic_vector(1 downto 0);
    signal  tile0_rxdisperr1_i              : std_logic_vector(1 downto 0);
    signal  tile0_rxnotintable0_i           : std_logic_vector(1 downto 0);
    signal  tile0_rxnotintable1_i           : std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile0_rxbyteisaligned0_i        : std_logic;
    signal  tile0_rxbyteisaligned1_i        : std_logic;
    signal  tile0_rxbyterealign0_i          : std_logic;
    signal  tile0_rxbyterealign1_i          : std_logic;
    signal  tile0_rxcommadet0_i             : std_logic;
    signal  tile0_rxcommadet1_i             : std_logic;
    signal  tile0_rxenmcommaalign0_i        : std_logic;
    signal  tile0_rxenmcommaalign1_i        : std_logic;
    signal  tile0_rxenpcommaalign0_i        : std_logic;
    signal  tile0_rxenpcommaalign1_i        : std_logic;
    signal  tile0_rxslide0_i                : std_logic;
    signal  tile0_rxslide1_i                : std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    signal  tile0_prbscntreset0_i           : std_logic;
    signal  tile0_prbscntreset1_i           : std_logic;
    signal  tile0_rxenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile0_rxenprbstst1_i            : std_logic_vector(2 downto 0);
    signal  tile0_rxprbserr0_i              : std_logic;
    signal  tile0_rxprbserr1_i              : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile0_rxdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile0_rxdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile0_rxrecclk0_i               : std_logic;
    signal  tile0_rxrecclk1_i               : std_logic;
    signal  tile0_rxreset0_i                : std_logic;
    signal  tile0_rxreset1_i                : std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    signal  tile0_rxenpmaphasealign0_i      : std_logic;
    signal  tile0_rxenpmaphasealign1_i      : std_logic;
    signal  tile0_rxpmasetphase0_i          : std_logic;
    signal  tile0_rxpmasetphase1_i          : std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    signal  tile0_gtpclkfbeast_i            : std_logic_vector(1 downto 0);
    signal  tile0_gtpclkfbwest_i            : std_logic_vector(1 downto 0);
    signal  tile0_gtpclkout0_i              : std_logic_vector(1 downto 0);
    signal  tile0_gtpclkout1_i              : std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    signal  tile0_txcharisk0_i              : std_logic_vector(1 downto 0);
    signal  tile0_txcharisk1_i              : std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    signal  tile0_txenpmaphasealign0_i      : std_logic;
    signal  tile0_txenpmaphasealign1_i      : std_logic;
    signal  tile0_txpmasetphase0_i          : std_logic;
    signal  tile0_txpmasetphase1_i          : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile0_txdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile0_txdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile0_txoutclk0_i               : std_logic;
    signal  tile0_txoutclk1_i               : std_logic;
    signal  tile0_txreset0_i                : std_logic;
    signal  tile0_txreset1_i                : std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    signal  tile0_txenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile0_txenprbstst1_i            : std_logic_vector(2 downto 0);



    --________________________________________________________________________
    --________________________________________________________________________
    --TILE1   (X1_Y0)

    ------------------------ Loopback and Powerdown Ports ----------------------
    signal  tile1_loopback0_i               : std_logic_vector(2 downto 0);
    signal  tile1_loopback1_i               : std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    signal  tile1_gtpreset0_i               : std_logic;
    signal  tile1_gtpreset1_i               : std_logic;
    signal  tile1_plllkdet0_i               : std_logic;
    signal  tile1_plllkdet1_i               : std_logic;
    signal  tile1_resetdone0_i              : std_logic;
    signal  tile1_resetdone1_i              : std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile1_rxdisperr0_i              : std_logic_vector(1 downto 0);
    signal  tile1_rxdisperr1_i              : std_logic_vector(1 downto 0);
    signal  tile1_rxnotintable0_i           : std_logic_vector(1 downto 0);
    signal  tile1_rxnotintable1_i           : std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile1_rxbyteisaligned0_i        : std_logic;
    signal  tile1_rxbyteisaligned1_i        : std_logic;
    signal  tile1_rxbyterealign0_i          : std_logic;
    signal  tile1_rxbyterealign1_i          : std_logic;
    signal  tile1_rxcommadet0_i             : std_logic;
    signal  tile1_rxcommadet1_i             : std_logic;
    signal  tile1_rxenmcommaalign0_i        : std_logic;
    signal  tile1_rxenmcommaalign1_i        : std_logic;
    signal  tile1_rxenpcommaalign0_i        : std_logic;
    signal  tile1_rxenpcommaalign1_i        : std_logic;
    signal  tile1_rxslide0_i                : std_logic;
    signal  tile1_rxslide1_i                : std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    signal  tile1_prbscntreset0_i           : std_logic;
    signal  tile1_prbscntreset1_i           : std_logic;
    signal  tile1_rxenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile1_rxenprbstst1_i            : std_logic_vector(2 downto 0);
    signal  tile1_rxprbserr0_i              : std_logic;
    signal  tile1_rxprbserr1_i              : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile1_rxdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile1_rxdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile1_rxrecclk0_i               : std_logic;
    signal  tile1_rxrecclk1_i               : std_logic;
    signal  tile1_rxreset0_i                : std_logic;
    signal  tile1_rxreset1_i                : std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    signal  tile1_rxenpmaphasealign0_i      : std_logic;
    signal  tile1_rxenpmaphasealign1_i      : std_logic;
    signal  tile1_rxpmasetphase0_i          : std_logic;
    signal  tile1_rxpmasetphase1_i          : std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    signal  tile1_gtpclkfbeast_i            : std_logic_vector(1 downto 0);
    signal  tile1_gtpclkfbwest_i            : std_logic_vector(1 downto 0);
    signal  tile1_gtpclkout0_i              : std_logic_vector(1 downto 0);
    signal  tile1_gtpclkout1_i              : std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    signal  tile1_txcharisk0_i              : std_logic_vector(1 downto 0);
    signal  tile1_txcharisk1_i              : std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    signal  tile1_txenpmaphasealign0_i      : std_logic;
    signal  tile1_txenpmaphasealign1_i      : std_logic;
    signal  tile1_txpmasetphase0_i          : std_logic;
    signal  tile1_txpmasetphase1_i          : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile1_txdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile1_txdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile1_txoutclk0_i               : std_logic;
    signal  tile1_txoutclk1_i               : std_logic;
    signal  tile1_txreset0_i                : std_logic;
    signal  tile1_txreset1_i                : std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    signal  tile1_txenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile1_txenprbstst1_i            : std_logic_vector(2 downto 0);



    --________________________________________________________________________
    --________________________________________________________________________
    --TILE2   (X0_Y1)

    ------------------------ Loopback and Powerdown Ports ----------------------
    signal  tile2_loopback0_i               : std_logic_vector(2 downto 0);
    signal  tile2_loopback1_i               : std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    signal  tile2_gtpreset0_i               : std_logic;
    signal  tile2_gtpreset1_i               : std_logic;
    signal  tile2_plllkdet0_i               : std_logic;
    signal  tile2_plllkdet1_i               : std_logic;
    signal  tile2_resetdone0_i              : std_logic;
    signal  tile2_resetdone1_i              : std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile2_rxdisperr0_i              : std_logic_vector(1 downto 0);
    signal  tile2_rxdisperr1_i              : std_logic_vector(1 downto 0);
    signal  tile2_rxnotintable0_i           : std_logic_vector(1 downto 0);
    signal  tile2_rxnotintable1_i           : std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile2_rxbyteisaligned0_i        : std_logic;
    signal  tile2_rxbyteisaligned1_i        : std_logic;
    signal  tile2_rxbyterealign0_i          : std_logic;
    signal  tile2_rxbyterealign1_i          : std_logic;
    signal  tile2_rxcommadet0_i             : std_logic;
    signal  tile2_rxcommadet1_i             : std_logic;
    signal  tile2_rxenmcommaalign0_i        : std_logic;
    signal  tile2_rxenmcommaalign1_i        : std_logic;
    signal  tile2_rxenpcommaalign0_i        : std_logic;
    signal  tile2_rxenpcommaalign1_i        : std_logic;
    signal  tile2_rxslide0_i                : std_logic;
    signal  tile2_rxslide1_i                : std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    signal  tile2_prbscntreset0_i           : std_logic;
    signal  tile2_prbscntreset1_i           : std_logic;
    signal  tile2_rxenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile2_rxenprbstst1_i            : std_logic_vector(2 downto 0);
    signal  tile2_rxprbserr0_i              : std_logic;
    signal  tile2_rxprbserr1_i              : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile2_rxdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile2_rxdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile2_rxrecclk0_i               : std_logic;
    signal  tile2_rxrecclk1_i               : std_logic;
    signal  tile2_rxreset0_i                : std_logic;
    signal  tile2_rxreset1_i                : std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    signal  tile2_rxenpmaphasealign0_i      : std_logic;
    signal  tile2_rxenpmaphasealign1_i      : std_logic;
    signal  tile2_rxpmasetphase0_i          : std_logic;
    signal  tile2_rxpmasetphase1_i          : std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    signal  tile2_gtpclkfbeast_i            : std_logic_vector(1 downto 0);
    signal  tile2_gtpclkfbwest_i            : std_logic_vector(1 downto 0);
    signal  tile2_gtpclkout0_i              : std_logic_vector(1 downto 0);
    signal  tile2_gtpclkout1_i              : std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    signal  tile2_txcharisk0_i              : std_logic_vector(1 downto 0);
    signal  tile2_txcharisk1_i              : std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    signal  tile2_txenpmaphasealign0_i      : std_logic;
    signal  tile2_txenpmaphasealign1_i      : std_logic;
    signal  tile2_txpmasetphase0_i          : std_logic;
    signal  tile2_txpmasetphase1_i          : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile2_txdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile2_txdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile2_txoutclk0_i               : std_logic;
    signal  tile2_txoutclk1_i               : std_logic;
    signal  tile2_txreset0_i                : std_logic;
    signal  tile2_txreset1_i                : std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    signal  tile2_txenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile2_txenprbstst1_i            : std_logic_vector(2 downto 0);



    --________________________________________________________________________
    --________________________________________________________________________
    --TILE3   (X1_Y1)

    ------------------------ Loopback and Powerdown Ports ----------------------
    signal  tile3_loopback0_i               : std_logic_vector(2 downto 0);
    signal  tile3_loopback1_i               : std_logic_vector(2 downto 0);
    --------------------------------- PLL Ports --------------------------------
    signal  tile3_gtpreset0_i               : std_logic;
    signal  tile3_gtpreset1_i               : std_logic;
    signal  tile3_plllkdet0_i               : std_logic;
    signal  tile3_plllkdet1_i               : std_logic;
    signal  tile3_resetdone0_i              : std_logic;
    signal  tile3_resetdone1_i              : std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    signal  tile3_rxdisperr0_i              : std_logic_vector(1 downto 0);
    signal  tile3_rxdisperr1_i              : std_logic_vector(1 downto 0);
    signal  tile3_rxnotintable0_i           : std_logic_vector(1 downto 0);
    signal  tile3_rxnotintable1_i           : std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    signal  tile3_rxbyteisaligned0_i        : std_logic;
    signal  tile3_rxbyteisaligned1_i        : std_logic;
    signal  tile3_rxbyterealign0_i          : std_logic;
    signal  tile3_rxbyterealign1_i          : std_logic;
    signal  tile3_rxcommadet0_i             : std_logic;
    signal  tile3_rxcommadet1_i             : std_logic;
    signal  tile3_rxenmcommaalign0_i        : std_logic;
    signal  tile3_rxenmcommaalign1_i        : std_logic;
    signal  tile3_rxenpcommaalign0_i        : std_logic;
    signal  tile3_rxenpcommaalign1_i        : std_logic;
    signal  tile3_rxslide0_i                : std_logic;
    signal  tile3_rxslide1_i                : std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    signal  tile3_prbscntreset0_i           : std_logic;
    signal  tile3_prbscntreset1_i           : std_logic;
    signal  tile3_rxenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile3_rxenprbstst1_i            : std_logic_vector(2 downto 0);
    signal  tile3_rxprbserr0_i              : std_logic;
    signal  tile3_rxprbserr1_i              : std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    signal  tile3_rxdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile3_rxdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile3_rxrecclk0_i               : std_logic;
    signal  tile3_rxrecclk1_i               : std_logic;
    signal  tile3_rxreset0_i                : std_logic;
    signal  tile3_rxreset1_i                : std_logic;
    ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
    signal  tile3_rxenpmaphasealign0_i      : std_logic;
    signal  tile3_rxenpmaphasealign1_i      : std_logic;
    signal  tile3_rxpmasetphase0_i          : std_logic;
    signal  tile3_rxpmasetphase1_i          : std_logic;
    ---------------------------- TX/RX Datapath Ports --------------------------
    signal  tile3_gtpclkfbeast_i            : std_logic_vector(1 downto 0);
    signal  tile3_gtpclkfbwest_i            : std_logic_vector(1 downto 0);
    signal  tile3_gtpclkout0_i              : std_logic_vector(1 downto 0);
    signal  tile3_gtpclkout1_i              : std_logic_vector(1 downto 0);
    ------------------- Transmit Ports - 8b10b Encoder Control -----------------
    signal  tile3_txcharisk0_i              : std_logic_vector(1 downto 0);
    signal  tile3_txcharisk1_i              : std_logic_vector(1 downto 0);
    --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
    signal  tile3_txenpmaphasealign0_i      : std_logic;
    signal  tile3_txenpmaphasealign1_i      : std_logic;
    signal  tile3_txpmasetphase0_i          : std_logic;
    signal  tile3_txpmasetphase1_i          : std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  tile3_txdata0_i                 : std_logic_vector(15 downto 0);
    signal  tile3_txdata1_i                 : std_logic_vector(15 downto 0);
    signal  tile3_txoutclk0_i               : std_logic;
    signal  tile3_txoutclk1_i               : std_logic;
    signal  tile3_txreset0_i                : std_logic;
    signal  tile3_txreset1_i                : std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    signal  tile3_txenprbstst0_i            : std_logic_vector(2 downto 0);
    signal  tile3_txenprbstst1_i            : std_logic_vector(2 downto 0);


    ------------------------------- Global Signals -----------------------------
    signal  tile0_tx_system_reset0_c        : std_logic;
    signal  tile0_rx_system_reset0_c        : std_logic;
    signal  tile0_tx_system_reset1_c        : std_logic;
    signal  tile0_rx_system_reset1_c        : std_logic;
    signal  tile1_tx_system_reset0_c        : std_logic;
    signal  tile1_rx_system_reset0_c        : std_logic;
    signal  tile1_tx_system_reset1_c        : std_logic;
    signal  tile1_rx_system_reset1_c        : std_logic;
    signal  tile2_tx_system_reset0_c        : std_logic;
    signal  tile2_rx_system_reset0_c        : std_logic;
    signal  tile2_tx_system_reset1_c        : std_logic;
    signal  tile2_rx_system_reset1_c        : std_logic;
    signal  tile3_tx_system_reset0_c        : std_logic;
    signal  tile3_rx_system_reset0_c        : std_logic;
    signal  tile3_tx_system_reset1_c        : std_logic;
    signal  tile3_rx_system_reset1_c        : std_logic;
    signal  tied_to_ground_i                : std_logic;
    signal  tied_to_ground_vec_i            : std_logic_vector(191 downto 0);
    signal  tied_to_vcc_i                   : std_logic;
    signal  tied_to_vcc_vec_i               : std_logic_vector(7 downto 0);
    signal  drp_clk_in_i                    : std_logic;
    signal  tile0_refclkout_bufg_i          : std_logic;
    
    
    ----------------------------- User Clocks ---------------------------------
    signal  tile0_txusrclk0_i               : std_logic;
    signal  tile0_txusrclk20_i              : std_logic;
    signal  tile0_rxusrclk0_i               : std_logic;
    signal  tile0_rxusrclk20_i              : std_logic;
    signal  tile0_rxusrclk1_i               : std_logic;
    signal  tile0_rxusrclk21_i              : std_logic;
    signal  tile1_rxusrclk0_i               : std_logic;
    signal  tile1_rxusrclk20_i              : std_logic;
    signal  tile1_rxusrclk1_i               : std_logic;
    signal  tile1_rxusrclk21_i              : std_logic;
    signal  tile2_txusrclk0_i               : std_logic;
    signal  tile2_txusrclk20_i              : std_logic;
    signal  tile2_rxusrclk0_i               : std_logic;
    signal  tile2_rxusrclk20_i              : std_logic;
    signal  tile2_rxusrclk1_i               : std_logic;
    signal  tile2_rxusrclk21_i              : std_logic;
    signal  tile3_rxusrclk0_i               : std_logic;
    signal  tile3_rxusrclk20_i              : std_logic;
    signal  tile3_rxusrclk1_i               : std_logic;
    signal  tile3_rxusrclk21_i              : std_logic;
    signal  gtpclkout0_0_pll0_locked_i      : std_logic;
    signal  gtpclkout0_0_pll0_reset_i       : std_logic;
    signal  tile0_gtpclkout0_0_to_cmt_i     : std_logic;
    signal  pll0_fb_out_i                   : std_logic;
    signal  pll0_fb_in_i                    : std_logic;
    signal  gtpclkout0_1_dcm1_locked_i      : std_logic;
    signal  gtpclkout0_1_dcm1_reset_i       : std_logic;
    signal  tile0_gtpclkout0_1_to_dcm_i     : std_logic;
    signal  dcm1_fb_in_i                    : std_logic;
    signal  gtpclkout1_1_dcm2_locked_i      : std_logic;
    signal  gtpclkout1_1_dcm2_reset_i       : std_logic;
    signal  tile0_gtpclkout1_1_to_dcm_i     : std_logic;
    signal  dcm2_fb_in_i                    : std_logic;
    signal  gtpclkout0_1_dcm3_locked_i      : std_logic;
    signal  gtpclkout0_1_dcm3_reset_i       : std_logic;
    signal  tile1_gtpclkout0_1_to_dcm_i     : std_logic;
    signal  dcm3_fb_in_i                    : std_logic;
    signal  gtpclkout1_1_dcm4_locked_i      : std_logic;
    signal  gtpclkout1_1_dcm4_reset_i       : std_logic;
    signal  tile1_gtpclkout1_1_to_dcm_i     : std_logic;
    signal  dcm4_fb_in_i                    : std_logic;
    signal  gtpclkout0_0_pll5_locked_i      : std_logic;
    signal  gtpclkout0_0_pll5_reset_i       : std_logic;
    signal  tile2_gtpclkout0_0_to_cmt_i     : std_logic;
    signal  pll5_fb_out_i                   : std_logic;
    signal  pll5_fb_in_i                    : std_logic;
    signal  gtpclkout0_1_dcm6_locked_i      : std_logic;
    signal  gtpclkout0_1_dcm6_reset_i       : std_logic;
    signal  tile2_gtpclkout0_1_to_dcm_i     : std_logic;
    signal  dcm6_fb_in_i                    : std_logic;
    signal  gtpclkout1_1_dcm7_locked_i      : std_logic;
    signal  gtpclkout1_1_dcm7_reset_i       : std_logic;
    signal  tile2_gtpclkout1_1_to_dcm_i     : std_logic;
    signal  dcm7_fb_in_i                    : std_logic;
    signal  gtpclkout0_1_dcm8_locked_i      : std_logic;
    signal  gtpclkout0_1_dcm8_reset_i       : std_logic;
    signal  tile3_gtpclkout0_1_to_dcm_i     : std_logic;
    signal  dcm8_fb_in_i                    : std_logic;
    signal  gtpclkout1_1_dcm9_locked_i      : std_logic;
    signal  gtpclkout1_1_dcm9_reset_i       : std_logic;
    signal  tile3_gtpclkout1_1_to_dcm_i     : std_logic;
    signal  dcm9_fb_in_i                    : std_logic;


    ----------------------- Frame check/gen Module Signals --------------------
    signal  tile0_gtp0_refclk_i             : std_logic;
    signal  tile3_gtp0_refclk_i             : std_logic;
    signal  tile0_matchn0_i                 : std_logic;
    
    signal  tile0_txcharisk0_float_i        : std_logic_vector(1 downto 0);
    signal  tile0_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile0_track_data0_i             : std_logic;
    signal  tile0_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile0_frame_check0_reset_i      : std_logic;
    signal  tile0_inc_in0_i                 : std_logic;
    signal  tile0_inc_out0_i                : std_logic;
    signal  tile0_matchn1_i                 : std_logic;
    
    signal  tile0_txcharisk1_float_i        : std_logic_vector(1 downto 0);
    signal  tile0_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile0_track_data1_i             : std_logic;
    signal  tile0_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile0_frame_check1_reset_i      : std_logic;
    signal  tile0_inc_in1_i                 : std_logic;
    signal  tile0_inc_out1_i                : std_logic;

    signal  tile1_matchn0_i                 : std_logic;
    
    signal  tile1_txcharisk0_float_i        : std_logic_vector(1 downto 0);
    signal  tile1_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile1_track_data0_i             : std_logic;
    signal  tile1_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile1_frame_check0_reset_i      : std_logic;
    signal  tile1_inc_in0_i                 : std_logic;
    signal  tile1_inc_out0_i                : std_logic;
    signal  tile1_matchn1_i                 : std_logic;
    
    signal  tile1_txcharisk1_float_i        : std_logic_vector(1 downto 0);
    signal  tile1_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile1_track_data1_i             : std_logic;
    signal  tile1_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile1_frame_check1_reset_i      : std_logic;
    signal  tile1_inc_in1_i                 : std_logic;
    signal  tile1_inc_out1_i                : std_logic;

    signal  tile2_matchn0_i                 : std_logic;
    
    signal  tile2_txcharisk0_float_i        : std_logic_vector(1 downto 0);
    signal  tile2_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile2_track_data0_i             : std_logic;
    signal  tile2_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile2_frame_check0_reset_i      : std_logic;
    signal  tile2_inc_in0_i                 : std_logic;
    signal  tile2_inc_out0_i                : std_logic;
    signal  tile2_matchn1_i                 : std_logic;
    
    signal  tile2_txcharisk1_float_i        : std_logic_vector(1 downto 0);
    signal  tile2_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile2_track_data1_i             : std_logic;
    signal  tile2_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile2_frame_check1_reset_i      : std_logic;
    signal  tile2_inc_in1_i                 : std_logic;
    signal  tile2_inc_out1_i                : std_logic;

    signal  tile3_matchn0_i                 : std_logic;
    
    signal  tile3_txcharisk0_float_i        : std_logic_vector(1 downto 0);
    signal  tile3_txdata0_float_i           : std_logic_vector(23 downto 0);
    signal  tile3_track_data0_i             : std_logic;
    signal  tile3_error_count0_i            : std_logic_vector(7 downto 0);
    signal  tile3_frame_check0_reset_i      : std_logic;
    signal  tile3_inc_in0_i                 : std_logic;
    signal  tile3_inc_out0_i                : std_logic;
    signal  tile3_matchn1_i                 : std_logic;
    
    signal  tile3_txcharisk1_float_i        : std_logic_vector(1 downto 0);
    signal  tile3_txdata1_float_i           : std_logic_vector(23 downto 0);
    signal  tile3_track_data1_i             : std_logic;
    signal  tile3_error_count1_i            : std_logic_vector(7 downto 0);
    signal  tile3_frame_check1_reset_i      : std_logic;
    signal  tile3_inc_in1_i                 : std_logic;
    signal  tile3_inc_out1_i                : std_logic;

    signal  reset_on_data_error_i           : std_logic;
    signal  track_data_out_i                : std_logic;
    
    ------------------------- Sync Module Signals -----------------------------
    signal  tile0_rx_sync_done0_i           : std_logic;
    signal  tile0_reset_rxsync0_c           : std_logic;
    signal  tile0_tx_sync_done0_i           : std_logic;
    signal  tile0_reset_txsync0_c           : std_logic;
    signal  tile0_rx_sync_done1_i           : std_logic;
    signal  tile0_reset_rxsync1_c           : std_logic;
    signal  tile0_tx_sync_done1_i           : std_logic;
    signal  tile0_reset_txsync1_c           : std_logic;
    signal  tile1_rx_sync_done0_i           : std_logic;
    signal  tile1_reset_rxsync0_c           : std_logic;
    signal  tile1_tx_sync_done0_i           : std_logic;
    signal  tile1_reset_txsync0_c           : std_logic;
    signal  tile1_rx_sync_done1_i           : std_logic;
    signal  tile1_reset_rxsync1_c           : std_logic;
    signal  tile1_tx_sync_done1_i           : std_logic;
    signal  tile1_reset_txsync1_c           : std_logic;
    signal  tile2_rx_sync_done0_i           : std_logic;
    signal  tile2_reset_rxsync0_c           : std_logic;
    signal  tile2_tx_sync_done0_i           : std_logic;
    signal  tile2_reset_txsync0_c           : std_logic;
    signal  tile2_rx_sync_done1_i           : std_logic;
    signal  tile2_reset_rxsync1_c           : std_logic;
    signal  tile2_tx_sync_done1_i           : std_logic;
    signal  tile2_reset_txsync1_c           : std_logic;
    signal  tile3_rx_sync_done0_i           : std_logic;
    signal  tile3_reset_rxsync0_c           : std_logic;
    signal  tile3_tx_sync_done0_i           : std_logic;
    signal  tile3_reset_txsync0_c           : std_logic;
    signal  tile3_rx_sync_done1_i           : std_logic;
    signal  tile3_reset_rxsync1_c           : std_logic;
    signal  tile3_tx_sync_done1_i           : std_logic;
    signal  tile3_reset_txsync1_c           : std_logic;

    ----------------------- Chipscope Signals ---------------------------------

    signal  shared_vio_control_i            : std_logic_vector(35 downto 0);
    signal  tile0_data_vio_control_i        : std_logic_vector(35 downto 0);
    signal  tile1_data_vio_control_i        : std_logic_vector(35 downto 0);
    signal  tile2_data_vio_control_i        : std_logic_vector(35 downto 0);
    signal  tile3_data_vio_control_i        : std_logic_vector(35 downto 0);
    signal  tile0_gtp0_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile0_gtp1_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile1_gtp0_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile1_gtp1_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile2_gtp0_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile2_gtp1_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile3_gtp0_ila_control_i        : std_logic_vector(35 downto 0);
    signal  tile3_gtp1_ila_control_i        : std_logic_vector(35 downto 0);
    signal  shared_vio_in_i                 : std_logic_vector(31 downto 0);
    signal  shared_vio_out_i                : std_logic_vector(31 downto 0);

    signal  tile0_data_vio_in_i             : std_logic_vector(139 downto 0);
    signal  tile0_data_vio_out_i            : std_logic_vector(139 downto 0);
    signal  tile1_data_vio_in_i             : std_logic_vector(139 downto 0);
    signal  tile1_data_vio_out_i            : std_logic_vector(139 downto 0);
    signal  tile2_data_vio_in_i             : std_logic_vector(139 downto 0);
    signal  tile2_data_vio_out_i            : std_logic_vector(139 downto 0);
    signal  tile3_data_vio_in_i             : std_logic_vector(139 downto 0);
    signal  tile3_data_vio_out_i            : std_logic_vector(139 downto 0);
    signal  tile0_ila_in0_i                 : std_logic_vector(84 downto 0);
    signal  tile0_ila_in1_i                 : std_logic_vector(84 downto 0);

    signal  tile1_ila_in0_i                 : std_logic_vector(84 downto 0);
    signal  tile1_ila_in1_i                 : std_logic_vector(84 downto 0);

    signal  tile2_ila_in0_i                 : std_logic_vector(84 downto 0);
    signal  tile2_ila_in1_i                 : std_logic_vector(84 downto 0);

    signal  tile3_ila_in0_i                 : std_logic_vector(84 downto 0);
    signal  tile3_ila_in1_i                 : std_logic_vector(84 downto 0);


    signal  gtpreset0_i                     : std_logic;
    signal  gtpreset1_i                     : std_logic;
    signal  user_tx_reset_i                 : std_logic;
    signal  user_rx_reset_i                 : std_logic;

--**************************** Main Body of Code *******************************
begin

    --  Static signal Assigments
    tied_to_ground_i                        <= '0';
    tied_to_ground_vec_i                    <= x"000000000000000000000000000000000000000000000000";
    tied_to_vcc_i                           <= '1';
    tied_to_vcc_vec_i                       <= x"ff";


    


    -----------------------Dedicated GTP Reference Clock Inputs ---------------
    -- The dedicated reference clock inputs you selected in the GUI are implemented using
    -- IBUFDS instances.
    --
    -- In the UCF file for this example design, you will see that each of
    -- these IBUFDS instances has been LOCed to a particular set of pins. By LOCing to these
    -- locations, we tell the tools to use the dedicated input buffers to the GTP reference
    -- clock network, rather than general purpose IOs. To select other pins, consult the 
    -- Implementation chapter of UG___, or rerun the wizard.
    --
    -- This network is the highest performace (lowest jitter) option for providing clocks
    -- to the GTP transceivers.
    
    tile0_gtp0_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile0_gtp0_refclk_i,
        I                               =>      tile0_gtp0_REFCLK_PAD_P_IN,
        IB                              =>      tile0_gtp0_REFCLK_PAD_N_IN
    );

    tile3_gtp0_refclk_ibufds_i : IBUFDS
    port map
    (
        O                               =>      tile3_gtp0_refclk_i,
        I                               =>      tile3_gtp0_REFCLK_PAD_P_IN,
        IB                              =>      tile3_gtp0_REFCLK_PAD_N_IN
    );

    ----------------------------------- User Clocks ---------------------------
    
    -- The clock resources in this section were added based on userclk source selections on
    -- the Latency, Buffering, and Clocking page of the GUI. A few notes about user clocks:
    -- * The userclk and userclk2 for each GTP datapath (TX and RX) must be phase aligned to 
    --   avoid data errors in the fabric interface whenever the datapath is wider than 10 bits
    -- * To minimize clock resources, you can share clocks between GTPs. GTPs using the same frequency
    --   or multiples of the same frequency can be accomadated using DCMs and PLLs. Use caution when
    --   using RXRECCLK as a clock source, however - these clocks can typically only be shared if all
    --   the channels using the clock are receiving data from TX channels that share a reference clock 
    --   source with each other.

    gtpclkout0_0_pll0_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile0_gtpclkout0_i(0),
        DIVCLK                          =>      tile0_gtpclkout0_0_to_cmt_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout0_0_pll0_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile0_gtpclkfbwest_i(0),
        O                               =>      pll0_fb_in_i
    );

    gtpclkout0_0_pll0_reset_i               <= not tile0_plllkdet0_i;
    gtpclkout0_0_pll0_i : MGT_USRCLK_SOURCE_PLL
    generic map
    (
        MULT                            =>      4,
        DIVIDE                          =>      2,
        FEEDBACK                        =>      "CLKOUT0",
        CLK_PERIOD                      =>      6.25,
        OUT0_DIVIDE                     =>      2,
        OUT1_DIVIDE                     =>      4,
        OUT2_DIVIDE                     =>      1,
        OUT3_DIVIDE                     =>      1
    )
    port map
    (
        CLK0_OUT                        =>      tile0_txusrclk0_i,
        CLK1_OUT                        =>      tile0_txusrclk20_i,
        CLK2_OUT                        =>      open,
        CLK3_OUT                        =>      open,
        CLK_IN                          =>      tile0_gtpclkout0_0_to_cmt_i,
        CLKFB_IN                        =>      pll0_fb_in_i,
        CLKFB_OUT                       =>      pll0_fb_out_i,
        PLL_LOCKED_OUT                  =>      gtpclkout0_0_pll0_locked_i,
        PLL_RESET_IN                    =>      gtpclkout0_0_pll0_reset_i
    );


    gtpclkout0_1_dcm1_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile0_gtpclkout0_i(1),
        DIVCLK                          =>      tile0_gtpclkout0_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout0_1_dcm1_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile0_gtpclkfbwest_i(1),
        O                               =>      dcm1_fb_in_i
    );

    gtpclkout0_1_dcm1_reset_i               <= not tile0_plllkdet0_i;
    gtpclkout0_1_dcm1_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile0_rxusrclk20_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile0_rxusrclk0_i,
        DCM_LOCKED_OUT                  =>      gtpclkout0_1_dcm1_locked_i,
        CLK_IN                          =>      tile0_gtpclkout0_1_to_dcm_i,
        FB_IN                           =>      dcm1_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout0_1_dcm1_reset_i
    );


    gtpclkout1_1_dcm2_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile0_gtpclkout1_i(1),
        DIVCLK                          =>      tile0_gtpclkout1_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout1_1_dcm2_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile0_gtpclkfbeast_i(1),
        O                               =>      dcm2_fb_in_i
    );

    gtpclkout1_1_dcm2_reset_i               <= not tile0_plllkdet0_i;
    gtpclkout1_1_dcm2_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile0_rxusrclk21_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile0_rxusrclk1_i,
        DCM_LOCKED_OUT                  =>      gtpclkout1_1_dcm2_locked_i,
        CLK_IN                          =>      tile0_gtpclkout1_1_to_dcm_i,
        FB_IN                           =>      dcm2_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout1_1_dcm2_reset_i
    );


    gtpclkout0_1_dcm3_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile1_gtpclkout0_i(1),
        DIVCLK                          =>      tile1_gtpclkout0_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout0_1_dcm3_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile1_gtpclkfbwest_i(1),
        O                               =>      dcm3_fb_in_i
    );

    gtpclkout0_1_dcm3_reset_i               <= not tile1_plllkdet0_i;
    gtpclkout0_1_dcm3_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile1_rxusrclk20_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile1_rxusrclk0_i,
        DCM_LOCKED_OUT                  =>      gtpclkout0_1_dcm3_locked_i,
        CLK_IN                          =>      tile1_gtpclkout0_1_to_dcm_i,
        FB_IN                           =>      dcm3_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout0_1_dcm3_reset_i
    );


    gtpclkout1_1_dcm4_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile1_gtpclkout1_i(1),
        DIVCLK                          =>      tile1_gtpclkout1_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout1_1_dcm4_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile1_gtpclkfbeast_i(1),
        O                               =>      dcm4_fb_in_i
    );

    gtpclkout1_1_dcm4_reset_i               <= not tile1_plllkdet0_i;
    gtpclkout1_1_dcm4_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile1_rxusrclk21_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile1_rxusrclk1_i,
        DCM_LOCKED_OUT                  =>      gtpclkout1_1_dcm4_locked_i,
        CLK_IN                          =>      tile1_gtpclkout1_1_to_dcm_i,
        FB_IN                           =>      dcm4_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout1_1_dcm4_reset_i
    );


    gtpclkout0_0_pll5_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile2_gtpclkout0_i(0),
        DIVCLK                          =>      tile2_gtpclkout0_0_to_cmt_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout0_0_pll5_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile2_gtpclkfbwest_i(0),
        O                               =>      pll5_fb_in_i
    );

    gtpclkout0_0_pll5_reset_i               <= not tile2_plllkdet0_i;
    gtpclkout0_0_pll5_i : MGT_USRCLK_SOURCE_PLL
    generic map
    (
        MULT                            =>      4,
        DIVIDE                          =>      2,
        FEEDBACK                        =>      "CLKOUT0",
        CLK_PERIOD                      =>      6.25,
        OUT0_DIVIDE                     =>      2,
        OUT1_DIVIDE                     =>      4,
        OUT2_DIVIDE                     =>      1,
        OUT3_DIVIDE                     =>      1
    )
    port map
    (
        CLK0_OUT                        =>      tile2_txusrclk0_i,
        CLK1_OUT                        =>      tile2_txusrclk20_i,
        CLK2_OUT                        =>      open,
        CLK3_OUT                        =>      open,
        CLK_IN                          =>      tile2_gtpclkout0_0_to_cmt_i,
        CLKFB_IN                        =>      pll5_fb_in_i,
        CLKFB_OUT                       =>      pll5_fb_out_i,
        PLL_LOCKED_OUT                  =>      gtpclkout0_0_pll5_locked_i,
        PLL_RESET_IN                    =>      gtpclkout0_0_pll5_reset_i
    );


    gtpclkout0_1_dcm6_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile2_gtpclkout0_i(1),
        DIVCLK                          =>      tile2_gtpclkout0_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout0_1_dcm6_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile2_gtpclkfbwest_i(1),
        O                               =>      dcm6_fb_in_i
    );

    gtpclkout0_1_dcm6_reset_i               <= not tile2_plllkdet0_i;
    gtpclkout0_1_dcm6_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile2_rxusrclk20_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile2_rxusrclk0_i,
        DCM_LOCKED_OUT                  =>      gtpclkout0_1_dcm6_locked_i,
        CLK_IN                          =>      tile2_gtpclkout0_1_to_dcm_i,
        FB_IN                           =>      dcm6_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout0_1_dcm6_reset_i
    );


    gtpclkout1_1_dcm7_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile2_gtpclkout1_i(1),
        DIVCLK                          =>      tile2_gtpclkout1_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout1_1_dcm7_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile2_gtpclkfbeast_i(1),
        O                               =>      dcm7_fb_in_i
    );

    gtpclkout1_1_dcm7_reset_i               <= not tile2_plllkdet0_i;
    gtpclkout1_1_dcm7_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile2_rxusrclk21_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile2_rxusrclk1_i,
        DCM_LOCKED_OUT                  =>      gtpclkout1_1_dcm7_locked_i,
        CLK_IN                          =>      tile2_gtpclkout1_1_to_dcm_i,
        FB_IN                           =>      dcm7_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout1_1_dcm7_reset_i
    );


    gtpclkout0_1_dcm8_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile3_gtpclkout0_i(1),
        DIVCLK                          =>      tile3_gtpclkout0_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout0_1_dcm8_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile3_gtpclkfbwest_i(1),
        O                               =>      dcm8_fb_in_i
    );

    gtpclkout0_1_dcm8_reset_i               <= not tile3_plllkdet0_i;
    gtpclkout0_1_dcm8_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile3_rxusrclk20_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile3_rxusrclk0_i,
        DCM_LOCKED_OUT                  =>      gtpclkout0_1_dcm8_locked_i,
        CLK_IN                          =>      tile3_gtpclkout0_1_to_dcm_i,
        FB_IN                           =>      dcm8_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout0_1_dcm8_reset_i
    );


    gtpclkout1_1_dcm9_bufio2_i : BUFIO2
    generic map
    (
        DIVIDE                          =>      1,
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile3_gtpclkout1_i(1),
        DIVCLK                          =>      tile3_gtpclkout1_1_to_dcm_i,
        IOCLK                           =>      open,
        SERDESSTROBE                    =>      open
    );

    gtpclkout1_1_dcm9_bufio2fb_i : BUFIO2FB
    generic map
    (
        DIVIDE_BYPASS                   =>      TRUE
    )
    port map
    (
        I                               =>      tile3_gtpclkfbeast_i(1),
        O                               =>      dcm9_fb_in_i
    );

    gtpclkout1_1_dcm9_reset_i               <= not tile3_plllkdet0_i;
    gtpclkout1_1_dcm9_i : MGT_USRCLK_SOURCE
    generic map
    (
        FREQUENCY_MODE                  =>      "LOW",
        DIVIDE_2                        =>      true,
        FEEDBACK                        =>      "2X",
        DIVIDE                          =>      2.0
    )
    port map
    (
        DIV1_OUT                        =>      tile3_rxusrclk21_i,
        DIV2_OUT                        =>      open,
        CLK2X_OUT                       =>      tile3_rxusrclk1_i,
        DCM_LOCKED_OUT                  =>      gtpclkout1_1_dcm9_locked_i,
        CLK_IN                          =>      tile3_gtpclkout1_1_to_dcm_i,
        FB_IN                           =>      dcm9_fb_in_i,
        DCM_RESET_IN                    =>      gtpclkout1_1_dcm9_reset_i
    );






    ----------------------------- The GTP Wrapper -----------------------------
    
    -- Use the instantiation template in the top directory to add the GTP wrapper to your design.
    -- In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    -- checker. The GTPs will reset, then attempt to align and transmit data. If channel bonding is 
    -- enabled, bonding should occur after alignment.
    

    -- Wire all PLLLKDET signals to the top level as output ports
    TILE0_GTP0_PLLLKDET_OUT                 <= tile0_plllkdet0_i;
    TILE1_GTP0_PLLLKDET_OUT                 <= tile1_plllkdet0_i;
    TILE2_GTP0_PLLLKDET_OUT                 <= tile2_plllkdet0_i;
    TILE3_GTP0_PLLLKDET_OUT                 <= tile3_plllkdet0_i;

    -- Hold the TX in reset till the TX user clocks are stable
    tile0_txreset0_i                    <= not (tile0_plllkdet0_i and gtpclkout0_0_pll0_locked_i);
    tile0_txreset1_i                    <= not (tile0_plllkdet0_i and gtpclkout0_0_pll0_locked_i);
    tile1_txreset0_i                    <= not (tile1_plllkdet0_i and gtpclkout0_0_pll0_locked_i);
    tile1_txreset1_i                    <= not (tile1_plllkdet0_i and gtpclkout0_0_pll0_locked_i);
    tile2_txreset0_i                    <= not (tile2_plllkdet0_i and gtpclkout0_0_pll5_locked_i);
    tile2_txreset1_i                    <= not (tile2_plllkdet0_i and gtpclkout0_0_pll5_locked_i);
    tile3_txreset0_i                    <= not (tile3_plllkdet0_i and gtpclkout0_0_pll5_locked_i);
    tile3_txreset1_i                    <= not (tile3_plllkdet0_i and gtpclkout0_0_pll5_locked_i);

    -- Hold the RX in reset till the RX user clocks are stable
    tile0_rxreset0_i                    <= not (tile0_plllkdet0_i and gtpclkout0_1_dcm1_locked_i);
    tile0_rxreset1_i                    <= not (tile0_plllkdet0_i and gtpclkout1_1_dcm2_locked_i);
    tile1_rxreset0_i                    <= not (tile1_plllkdet0_i and gtpclkout0_1_dcm3_locked_i);
    tile1_rxreset1_i                    <= not (tile1_plllkdet0_i and gtpclkout1_1_dcm4_locked_i);
    tile2_rxreset0_i                    <= not (tile2_plllkdet0_i and gtpclkout0_1_dcm6_locked_i);
    tile2_rxreset1_i                    <= not (tile2_plllkdet0_i and gtpclkout1_1_dcm7_locked_i);
    tile3_rxreset0_i                    <= not (tile3_plllkdet0_i and gtpclkout0_1_dcm8_locked_i);
    tile3_rxreset1_i                    <= not (tile3_plllkdet0_i and gtpclkout1_1_dcm9_locked_i);

    ser16a_i : ser16a
    generic map
    (
        WRAPPER_SIM_GTPRESET_SPEEDUP    =>      EXAMPLE_SIM_GTPRESET_SPEEDUP,
        WRAPPER_CLK25_DIVIDER_0         =>      10,
        WRAPPER_CLK25_DIVIDER_1         =>      10,
        WRAPPER_PLL_DIVSEL_FB_0         =>      2,
        WRAPPER_PLL_DIVSEL_FB_1         =>      2,
        WRAPPER_PLL_DIVSEL_REF_0        =>      1,
        WRAPPER_PLL_DIVSEL_REF_1        =>      1,
        WRAPPER_SIMULATION              =>      EXAMPLE_SIMULATION
    )
    port map
    (
 
 
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE0  (X0_Y0)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE0_LOOPBACK0_IN              =>      tile0_loopback0_i,
        TILE0_LOOPBACK1_IN              =>      tile0_loopback1_i,
        --------------------------------- PLL Ports --------------------------------
        TILE0_CLK00_IN                  =>      tile0_gtp0_refclk_i,
        TILE0_CLK01_IN                  =>      tied_to_ground_i,
        TILE0_GTPRESET0_IN              =>      tile0_gtpreset0_i,
        TILE0_GTPRESET1_IN              =>      tile0_gtpreset0_i,
        TILE0_PLLLKDET0_OUT             =>      tile0_plllkdet0_i,
        TILE0_RESETDONE0_OUT            =>      tile0_resetdone0_i,
        TILE0_RESETDONE1_OUT            =>      tile0_resetdone1_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE0_RXDISPERR0_OUT            =>      tile0_rxdisperr0_i,
        TILE0_RXDISPERR1_OUT            =>      tile0_rxdisperr1_i,
        TILE0_RXNOTINTABLE0_OUT         =>      tile0_rxnotintable0_i,
        TILE0_RXNOTINTABLE1_OUT         =>      tile0_rxnotintable1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE0_RXBYTEISALIGNED0_OUT      =>      tile0_rxbyteisaligned0_i,
        TILE0_RXBYTEISALIGNED1_OUT      =>      tile0_rxbyteisaligned1_i,
        TILE0_RXBYTEREALIGN0_OUT        =>      tile0_rxbyterealign0_i,
        TILE0_RXBYTEREALIGN1_OUT        =>      tile0_rxbyterealign1_i,
        TILE0_RXCOMMADET0_OUT           =>      tile0_rxcommadet0_i,
        TILE0_RXCOMMADET1_OUT           =>      tile0_rxcommadet1_i,
        TILE0_RXENMCOMMAALIGN0_IN       =>      tile0_rxenmcommaalign0_i,
        TILE0_RXENMCOMMAALIGN1_IN       =>      tile0_rxenmcommaalign1_i,
        TILE0_RXENPCOMMAALIGN0_IN       =>      tile0_rxenpcommaalign0_i,
        TILE0_RXENPCOMMAALIGN1_IN       =>      tile0_rxenpcommaalign1_i,
        TILE0_RXSLIDE0_IN               =>      tile0_rxslide0_i,
        TILE0_RXSLIDE1_IN               =>      tile0_rxslide1_i,
        ----------------------- Receive Ports - PRBS Detection ---------------------
        TILE0_PRBSCNTRESET0_IN          =>      tile0_prbscntreset0_i,
        TILE0_PRBSCNTRESET1_IN          =>      tile0_prbscntreset1_i,
        TILE0_RXENPRBSTST0_IN           =>      tile0_rxenprbstst0_i,
        TILE0_RXENPRBSTST1_IN           =>      tile0_rxenprbstst1_i,
        TILE0_RXPRBSERR0_OUT            =>      tile0_rxprbserr0_i,
        TILE0_RXPRBSERR1_OUT            =>      tile0_rxprbserr1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE0_RXDATA0_OUT               =>      tile0_rxdata0_i,
        TILE0_RXDATA1_OUT               =>      tile0_rxdata1_i,
        TILE0_RXRECCLK0_OUT             =>      tile0_rxrecclk0_i,
        TILE0_RXRECCLK1_OUT             =>      tile0_rxrecclk1_i,
        TILE0_RXRESET0_IN               =>      tile0_rxreset0_i,
        TILE0_RXRESET1_IN               =>      tile0_rxreset1_i,
        TILE0_RXUSRCLK0_IN              =>      tile0_rxusrclk0_i,
        TILE0_RXUSRCLK1_IN              =>      tile0_rxusrclk1_i,
        TILE0_RXUSRCLK20_IN             =>      tile0_rxusrclk20_i,
        TILE0_RXUSRCLK21_IN             =>      tile0_rxusrclk21_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE0_RXN0_IN                   =>      RXN_IN(0),
        TILE0_RXN1_IN                   =>      RXN_IN(1),
        TILE0_RXP0_IN                   =>      RXP_IN(0),
        TILE0_RXP1_IN                   =>      RXP_IN(1),
        ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        TILE0_RXENPMAPHASEALIGN0_IN     =>      tile0_rxenpmaphasealign0_i,
        TILE0_RXENPMAPHASEALIGN1_IN     =>      tile0_rxenpmaphasealign1_i,
        TILE0_RXPMASETPHASE0_IN         =>      tile0_rxpmasetphase0_i,
        TILE0_RXPMASETPHASE1_IN         =>      tile0_rxpmasetphase1_i,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE0_GTPCLKFBEAST_OUT          =>      tile0_gtpclkfbeast_i,
        TILE0_GTPCLKFBWEST_OUT          =>      tile0_gtpclkfbwest_i,
        TILE0_GTPCLKOUT0_OUT            =>      tile0_gtpclkout0_i,
        TILE0_GTPCLKOUT1_OUT            =>      tile0_gtpclkout1_i,
        ------------------- Transmit Ports - 8b10b Encoder Control -----------------
        TILE0_TXCHARISK0_IN             =>      tile0_txcharisk0_i,
        TILE0_TXCHARISK1_IN             =>      tile0_txcharisk1_i,
        --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        TILE0_TXENPMAPHASEALIGN0_IN     =>      tile0_txenpmaphasealign0_i,
        TILE0_TXENPMAPHASEALIGN1_IN     =>      tile0_txenpmaphasealign1_i,
        TILE0_TXPMASETPHASE0_IN         =>      tile0_txpmasetphase0_i,
        TILE0_TXPMASETPHASE1_IN         =>      tile0_txpmasetphase1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE0_TXDATA0_IN                =>      tile0_txdata0_i,
        TILE0_TXDATA1_IN                =>      tile0_txdata1_i,
        TILE0_TXOUTCLK0_OUT             =>      tile0_txoutclk0_i,
        TILE0_TXOUTCLK1_OUT             =>      tile0_txoutclk1_i,
        TILE0_TXRESET0_IN               =>      tile0_txreset0_i,
        TILE0_TXRESET1_IN               =>      tile0_txreset1_i,
        TILE0_TXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE0_TXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE0_TXUSRCLK20_IN             =>      tile0_txusrclk20_i,
        TILE0_TXUSRCLK21_IN             =>      tile0_txusrclk20_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE0_TXN0_OUT                  =>      TXN_OUT(0),
        TILE0_TXN1_OUT                  =>      TXN_OUT(1),
        TILE0_TXP0_OUT                  =>      TXP_OUT(0),
        TILE0_TXP1_OUT                  =>      TXP_OUT(1),
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE0_TXENPRBSTST0_IN           =>      tile0_txenprbstst0_i,
        TILE0_TXENPRBSTST1_IN           =>      tile0_txenprbstst1_i,
        TILE0_TXPRBSFORCEERR0_IN        =>      tied_to_ground_i,
        TILE0_TXPRBSFORCEERR1_IN        =>      tied_to_ground_i,


 
 
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE1  (X1_Y0)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE1_LOOPBACK0_IN              =>      tile1_loopback0_i,
        TILE1_LOOPBACK1_IN              =>      tile1_loopback1_i,
        --------------------------------- PLL Ports --------------------------------
        TILE1_CLK00_IN                  =>      tile0_gtp0_refclk_i,
        TILE1_CLK01_IN                  =>      tied_to_ground_i,
        TILE1_GTPRESET0_IN              =>      tile1_gtpreset0_i,
        TILE1_GTPRESET1_IN              =>      tile1_gtpreset0_i,
        TILE1_PLLLKDET0_OUT             =>      tile1_plllkdet0_i,
        TILE1_RESETDONE0_OUT            =>      tile1_resetdone0_i,
        TILE1_RESETDONE1_OUT            =>      tile1_resetdone1_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE1_RXDISPERR0_OUT            =>      tile1_rxdisperr0_i,
        TILE1_RXDISPERR1_OUT            =>      tile1_rxdisperr1_i,
        TILE1_RXNOTINTABLE0_OUT         =>      tile1_rxnotintable0_i,
        TILE1_RXNOTINTABLE1_OUT         =>      tile1_rxnotintable1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE1_RXBYTEISALIGNED0_OUT      =>      tile1_rxbyteisaligned0_i,
        TILE1_RXBYTEISALIGNED1_OUT      =>      tile1_rxbyteisaligned1_i,
        TILE1_RXBYTEREALIGN0_OUT        =>      tile1_rxbyterealign0_i,
        TILE1_RXBYTEREALIGN1_OUT        =>      tile1_rxbyterealign1_i,
        TILE1_RXCOMMADET0_OUT           =>      tile1_rxcommadet0_i,
        TILE1_RXCOMMADET1_OUT           =>      tile1_rxcommadet1_i,
        TILE1_RXENMCOMMAALIGN0_IN       =>      tile1_rxenmcommaalign0_i,
        TILE1_RXENMCOMMAALIGN1_IN       =>      tile1_rxenmcommaalign1_i,
        TILE1_RXENPCOMMAALIGN0_IN       =>      tile1_rxenpcommaalign0_i,
        TILE1_RXENPCOMMAALIGN1_IN       =>      tile1_rxenpcommaalign1_i,
        TILE1_RXSLIDE0_IN               =>      tile1_rxslide0_i,
        TILE1_RXSLIDE1_IN               =>      tile1_rxslide1_i,
        ----------------------- Receive Ports - PRBS Detection ---------------------
        TILE1_PRBSCNTRESET0_IN          =>      tile1_prbscntreset0_i,
        TILE1_PRBSCNTRESET1_IN          =>      tile1_prbscntreset1_i,
        TILE1_RXENPRBSTST0_IN           =>      tile1_rxenprbstst0_i,
        TILE1_RXENPRBSTST1_IN           =>      tile1_rxenprbstst1_i,
        TILE1_RXPRBSERR0_OUT            =>      tile1_rxprbserr0_i,
        TILE1_RXPRBSERR1_OUT            =>      tile1_rxprbserr1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE1_RXDATA0_OUT               =>      tile1_rxdata0_i,
        TILE1_RXDATA1_OUT               =>      tile1_rxdata1_i,
        TILE1_RXRECCLK0_OUT             =>      tile1_rxrecclk0_i,
        TILE1_RXRECCLK1_OUT             =>      tile1_rxrecclk1_i,
        TILE1_RXRESET0_IN               =>      tile1_rxreset0_i,
        TILE1_RXRESET1_IN               =>      tile1_rxreset1_i,
        TILE1_RXUSRCLK0_IN              =>      tile1_rxusrclk0_i,
        TILE1_RXUSRCLK1_IN              =>      tile1_rxusrclk1_i,
        TILE1_RXUSRCLK20_IN             =>      tile1_rxusrclk20_i,
        TILE1_RXUSRCLK21_IN             =>      tile1_rxusrclk21_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE1_RXN0_IN                   =>      RXN_IN(2),
        TILE1_RXN1_IN                   =>      RXN_IN(3),
        TILE1_RXP0_IN                   =>      RXP_IN(2),
        TILE1_RXP1_IN                   =>      RXP_IN(3),
        ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        TILE1_RXENPMAPHASEALIGN0_IN     =>      tile1_rxenpmaphasealign0_i,
        TILE1_RXENPMAPHASEALIGN1_IN     =>      tile1_rxenpmaphasealign1_i,
        TILE1_RXPMASETPHASE0_IN         =>      tile1_rxpmasetphase0_i,
        TILE1_RXPMASETPHASE1_IN         =>      tile1_rxpmasetphase1_i,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE1_GTPCLKFBEAST_OUT          =>      tile1_gtpclkfbeast_i,
        TILE1_GTPCLKFBWEST_OUT          =>      tile1_gtpclkfbwest_i,
        TILE1_GTPCLKOUT0_OUT            =>      tile1_gtpclkout0_i,
        TILE1_GTPCLKOUT1_OUT            =>      tile1_gtpclkout1_i,
        ------------------- Transmit Ports - 8b10b Encoder Control -----------------
        TILE1_TXCHARISK0_IN             =>      tile1_txcharisk0_i,
        TILE1_TXCHARISK1_IN             =>      tile1_txcharisk1_i,
        --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        TILE1_TXENPMAPHASEALIGN0_IN     =>      tile1_txenpmaphasealign0_i,
        TILE1_TXENPMAPHASEALIGN1_IN     =>      tile1_txenpmaphasealign1_i,
        TILE1_TXPMASETPHASE0_IN         =>      tile1_txpmasetphase0_i,
        TILE1_TXPMASETPHASE1_IN         =>      tile1_txpmasetphase1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE1_TXDATA0_IN                =>      tile1_txdata0_i,
        TILE1_TXDATA1_IN                =>      tile1_txdata1_i,
        TILE1_TXOUTCLK0_OUT             =>      tile1_txoutclk0_i,
        TILE1_TXOUTCLK1_OUT             =>      tile1_txoutclk1_i,
        TILE1_TXRESET0_IN               =>      tile1_txreset0_i,
        TILE1_TXRESET1_IN               =>      tile1_txreset1_i,
        TILE1_TXUSRCLK0_IN              =>      tile0_txusrclk0_i,
        TILE1_TXUSRCLK1_IN              =>      tile0_txusrclk0_i,
        TILE1_TXUSRCLK20_IN             =>      tile0_txusrclk20_i,
        TILE1_TXUSRCLK21_IN             =>      tile0_txusrclk20_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE1_TXN0_OUT                  =>      TXN_OUT(2),
        TILE1_TXN1_OUT                  =>      TXN_OUT(3),
        TILE1_TXP0_OUT                  =>      TXP_OUT(2),
        TILE1_TXP1_OUT                  =>      TXP_OUT(3),
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE1_TXENPRBSTST0_IN           =>      tile1_txenprbstst0_i,
        TILE1_TXENPRBSTST1_IN           =>      tile1_txenprbstst1_i,
        TILE1_TXPRBSFORCEERR0_IN        =>      tied_to_ground_i,
        TILE1_TXPRBSFORCEERR1_IN        =>      tied_to_ground_i,


 
 
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE2  (X0_Y1)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE2_LOOPBACK0_IN              =>      tile2_loopback0_i,
        TILE2_LOOPBACK1_IN              =>      tile2_loopback1_i,
        --------------------------------- PLL Ports --------------------------------
        TILE2_CLK00_IN                  =>      tile3_gtp0_refclk_i,
        TILE2_CLK01_IN                  =>      tied_to_ground_i,
        TILE2_GTPRESET0_IN              =>      tile2_gtpreset0_i,
        TILE2_GTPRESET1_IN              =>      tile2_gtpreset0_i,
        TILE2_PLLLKDET0_OUT             =>      tile2_plllkdet0_i,
        TILE2_RESETDONE0_OUT            =>      tile2_resetdone0_i,
        TILE2_RESETDONE1_OUT            =>      tile2_resetdone1_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE2_RXDISPERR0_OUT            =>      tile2_rxdisperr0_i,
        TILE2_RXDISPERR1_OUT            =>      tile2_rxdisperr1_i,
        TILE2_RXNOTINTABLE0_OUT         =>      tile2_rxnotintable0_i,
        TILE2_RXNOTINTABLE1_OUT         =>      tile2_rxnotintable1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE2_RXBYTEISALIGNED0_OUT      =>      tile2_rxbyteisaligned0_i,
        TILE2_RXBYTEISALIGNED1_OUT      =>      tile2_rxbyteisaligned1_i,
        TILE2_RXBYTEREALIGN0_OUT        =>      tile2_rxbyterealign0_i,
        TILE2_RXBYTEREALIGN1_OUT        =>      tile2_rxbyterealign1_i,
        TILE2_RXCOMMADET0_OUT           =>      tile2_rxcommadet0_i,
        TILE2_RXCOMMADET1_OUT           =>      tile2_rxcommadet1_i,
        TILE2_RXENMCOMMAALIGN0_IN       =>      tile2_rxenmcommaalign0_i,
        TILE2_RXENMCOMMAALIGN1_IN       =>      tile2_rxenmcommaalign1_i,
        TILE2_RXENPCOMMAALIGN0_IN       =>      tile2_rxenpcommaalign0_i,
        TILE2_RXENPCOMMAALIGN1_IN       =>      tile2_rxenpcommaalign1_i,
        TILE2_RXSLIDE0_IN               =>      tile2_rxslide0_i,
        TILE2_RXSLIDE1_IN               =>      tile2_rxslide1_i,
        ----------------------- Receive Ports - PRBS Detection ---------------------
        TILE2_PRBSCNTRESET0_IN          =>      tile2_prbscntreset0_i,
        TILE2_PRBSCNTRESET1_IN          =>      tile2_prbscntreset1_i,
        TILE2_RXENPRBSTST0_IN           =>      tile2_rxenprbstst0_i,
        TILE2_RXENPRBSTST1_IN           =>      tile2_rxenprbstst1_i,
        TILE2_RXPRBSERR0_OUT            =>      tile2_rxprbserr0_i,
        TILE2_RXPRBSERR1_OUT            =>      tile2_rxprbserr1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE2_RXDATA0_OUT               =>      tile2_rxdata0_i,
        TILE2_RXDATA1_OUT               =>      tile2_rxdata1_i,
        TILE2_RXRECCLK0_OUT             =>      tile2_rxrecclk0_i,
        TILE2_RXRECCLK1_OUT             =>      tile2_rxrecclk1_i,
        TILE2_RXRESET0_IN               =>      tile2_rxreset0_i,
        TILE2_RXRESET1_IN               =>      tile2_rxreset1_i,
        TILE2_RXUSRCLK0_IN              =>      tile2_rxusrclk0_i,
        TILE2_RXUSRCLK1_IN              =>      tile2_rxusrclk1_i,
        TILE2_RXUSRCLK20_IN             =>      tile2_rxusrclk20_i,
        TILE2_RXUSRCLK21_IN             =>      tile2_rxusrclk21_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE2_RXN0_IN                   =>      RXN_IN(4),
        TILE2_RXN1_IN                   =>      RXN_IN(5),
        TILE2_RXP0_IN                   =>      RXP_IN(4),
        TILE2_RXP1_IN                   =>      RXP_IN(5),
        ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        TILE2_RXENPMAPHASEALIGN0_IN     =>      tile2_rxenpmaphasealign0_i,
        TILE2_RXENPMAPHASEALIGN1_IN     =>      tile2_rxenpmaphasealign1_i,
        TILE2_RXPMASETPHASE0_IN         =>      tile2_rxpmasetphase0_i,
        TILE2_RXPMASETPHASE1_IN         =>      tile2_rxpmasetphase1_i,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE2_GTPCLKFBEAST_OUT          =>      tile2_gtpclkfbeast_i,
        TILE2_GTPCLKFBWEST_OUT          =>      tile2_gtpclkfbwest_i,
        TILE2_GTPCLKOUT0_OUT            =>      tile2_gtpclkout0_i,
        TILE2_GTPCLKOUT1_OUT            =>      tile2_gtpclkout1_i,
        ------------------- Transmit Ports - 8b10b Encoder Control -----------------
        TILE2_TXCHARISK0_IN             =>      tile2_txcharisk0_i,
        TILE2_TXCHARISK1_IN             =>      tile2_txcharisk1_i,
        --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        TILE2_TXENPMAPHASEALIGN0_IN     =>      tile2_txenpmaphasealign0_i,
        TILE2_TXENPMAPHASEALIGN1_IN     =>      tile2_txenpmaphasealign1_i,
        TILE2_TXPMASETPHASE0_IN         =>      tile2_txpmasetphase0_i,
        TILE2_TXPMASETPHASE1_IN         =>      tile2_txpmasetphase1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE2_TXDATA0_IN                =>      tile2_txdata0_i,
        TILE2_TXDATA1_IN                =>      tile2_txdata1_i,
        TILE2_TXOUTCLK0_OUT             =>      tile2_txoutclk0_i,
        TILE2_TXOUTCLK1_OUT             =>      tile2_txoutclk1_i,
        TILE2_TXRESET0_IN               =>      tile2_txreset0_i,
        TILE2_TXRESET1_IN               =>      tile2_txreset1_i,
        TILE2_TXUSRCLK0_IN              =>      tile2_txusrclk0_i,
        TILE2_TXUSRCLK1_IN              =>      tile2_txusrclk0_i,
        TILE2_TXUSRCLK20_IN             =>      tile2_txusrclk20_i,
        TILE2_TXUSRCLK21_IN             =>      tile2_txusrclk20_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE2_TXN0_OUT                  =>      TXN_OUT(4),
        TILE2_TXN1_OUT                  =>      TXN_OUT(5),
        TILE2_TXP0_OUT                  =>      TXP_OUT(4),
        TILE2_TXP1_OUT                  =>      TXP_OUT(5),
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE2_TXENPRBSTST0_IN           =>      tile2_txenprbstst0_i,
        TILE2_TXENPRBSTST1_IN           =>      tile2_txenprbstst1_i,
        TILE2_TXPRBSFORCEERR0_IN        =>      tied_to_ground_i,
        TILE2_TXPRBSFORCEERR1_IN        =>      tied_to_ground_i,


 
 
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --TILE3  (X1_Y1)

        ------------------------ Loopback and Powerdown Ports ----------------------
        TILE3_LOOPBACK0_IN              =>      tile3_loopback0_i,
        TILE3_LOOPBACK1_IN              =>      tile3_loopback1_i,
        --------------------------------- PLL Ports --------------------------------
        TILE3_CLK00_IN                  =>      tile3_gtp0_refclk_i,
        TILE3_CLK01_IN                  =>      tied_to_ground_i,
        TILE3_GTPRESET0_IN              =>      tile3_gtpreset0_i,
        TILE3_GTPRESET1_IN              =>      tile3_gtpreset0_i,
        TILE3_PLLLKDET0_OUT             =>      tile3_plllkdet0_i,
        TILE3_RESETDONE0_OUT            =>      tile3_resetdone0_i,
        TILE3_RESETDONE1_OUT            =>      tile3_resetdone1_i,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        TILE3_RXDISPERR0_OUT            =>      tile3_rxdisperr0_i,
        TILE3_RXDISPERR1_OUT            =>      tile3_rxdisperr1_i,
        TILE3_RXNOTINTABLE0_OUT         =>      tile3_rxnotintable0_i,
        TILE3_RXNOTINTABLE1_OUT         =>      tile3_rxnotintable1_i,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        TILE3_RXBYTEISALIGNED0_OUT      =>      tile3_rxbyteisaligned0_i,
        TILE3_RXBYTEISALIGNED1_OUT      =>      tile3_rxbyteisaligned1_i,
        TILE3_RXBYTEREALIGN0_OUT        =>      tile3_rxbyterealign0_i,
        TILE3_RXBYTEREALIGN1_OUT        =>      tile3_rxbyterealign1_i,
        TILE3_RXCOMMADET0_OUT           =>      tile3_rxcommadet0_i,
        TILE3_RXCOMMADET1_OUT           =>      tile3_rxcommadet1_i,
        TILE3_RXENMCOMMAALIGN0_IN       =>      tile3_rxenmcommaalign0_i,
        TILE3_RXENMCOMMAALIGN1_IN       =>      tile3_rxenmcommaalign1_i,
        TILE3_RXENPCOMMAALIGN0_IN       =>      tile3_rxenpcommaalign0_i,
        TILE3_RXENPCOMMAALIGN1_IN       =>      tile3_rxenpcommaalign1_i,
        TILE3_RXSLIDE0_IN               =>      tile3_rxslide0_i,
        TILE3_RXSLIDE1_IN               =>      tile3_rxslide1_i,
        ----------------------- Receive Ports - PRBS Detection ---------------------
        TILE3_PRBSCNTRESET0_IN          =>      tile3_prbscntreset0_i,
        TILE3_PRBSCNTRESET1_IN          =>      tile3_prbscntreset1_i,
        TILE3_RXENPRBSTST0_IN           =>      tile3_rxenprbstst0_i,
        TILE3_RXENPRBSTST1_IN           =>      tile3_rxenprbstst1_i,
        TILE3_RXPRBSERR0_OUT            =>      tile3_rxprbserr0_i,
        TILE3_RXPRBSERR1_OUT            =>      tile3_rxprbserr1_i,
        ------------------- Receive Ports - RX Data Path interface -----------------
        TILE3_RXDATA0_OUT               =>      tile3_rxdata0_i,
        TILE3_RXDATA1_OUT               =>      tile3_rxdata1_i,
        TILE3_RXRECCLK0_OUT             =>      tile3_rxrecclk0_i,
        TILE3_RXRECCLK1_OUT             =>      tile3_rxrecclk1_i,
        TILE3_RXRESET0_IN               =>      tile3_rxreset0_i,
        TILE3_RXRESET1_IN               =>      tile3_rxreset1_i,
        TILE3_RXUSRCLK0_IN              =>      tile3_rxusrclk0_i,
        TILE3_RXUSRCLK1_IN              =>      tile3_rxusrclk1_i,
        TILE3_RXUSRCLK20_IN             =>      tile3_rxusrclk20_i,
        TILE3_RXUSRCLK21_IN             =>      tile3_rxusrclk21_i,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        TILE3_RXN0_IN                   =>      RXN_IN(6),
        TILE3_RXN1_IN                   =>      RXN_IN(7),
        TILE3_RXP0_IN                   =>      RXP_IN(6),
        TILE3_RXP1_IN                   =>      RXP_IN(7),
        ----------- Receive Ports - RX Elastic Buffer and Phase Alignment ----------
        TILE3_RXENPMAPHASEALIGN0_IN     =>      tile3_rxenpmaphasealign0_i,
        TILE3_RXENPMAPHASEALIGN1_IN     =>      tile3_rxenpmaphasealign1_i,
        TILE3_RXPMASETPHASE0_IN         =>      tile3_rxpmasetphase0_i,
        TILE3_RXPMASETPHASE1_IN         =>      tile3_rxpmasetphase1_i,
        ---------------------------- TX/RX Datapath Ports --------------------------
        TILE3_GTPCLKFBEAST_OUT          =>      tile3_gtpclkfbeast_i,
        TILE3_GTPCLKFBWEST_OUT          =>      tile3_gtpclkfbwest_i,
        TILE3_GTPCLKOUT0_OUT            =>      tile3_gtpclkout0_i,
        TILE3_GTPCLKOUT1_OUT            =>      tile3_gtpclkout1_i,
        ------------------- Transmit Ports - 8b10b Encoder Control -----------------
        TILE3_TXCHARISK0_IN             =>      tile3_txcharisk0_i,
        TILE3_TXCHARISK1_IN             =>      tile3_txcharisk1_i,
        --------------- Transmit Ports - TX Buffer and Phase Alignment -------------
        TILE3_TXENPMAPHASEALIGN0_IN     =>      tile3_txenpmaphasealign0_i,
        TILE3_TXENPMAPHASEALIGN1_IN     =>      tile3_txenpmaphasealign1_i,
        TILE3_TXPMASETPHASE0_IN         =>      tile3_txpmasetphase0_i,
        TILE3_TXPMASETPHASE1_IN         =>      tile3_txpmasetphase1_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        TILE3_TXDATA0_IN                =>      tile3_txdata0_i,
        TILE3_TXDATA1_IN                =>      tile3_txdata1_i,
        TILE3_TXOUTCLK0_OUT             =>      tile3_txoutclk0_i,
        TILE3_TXOUTCLK1_OUT             =>      tile3_txoutclk1_i,
        TILE3_TXRESET0_IN               =>      tile3_txreset0_i,
        TILE3_TXRESET1_IN               =>      tile3_txreset1_i,
        TILE3_TXUSRCLK0_IN              =>      tile2_txusrclk0_i,
        TILE3_TXUSRCLK1_IN              =>      tile2_txusrclk0_i,
        TILE3_TXUSRCLK20_IN             =>      tile2_txusrclk20_i,
        TILE3_TXUSRCLK21_IN             =>      tile2_txusrclk20_i,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        TILE3_TXN0_OUT                  =>      TXN_OUT(6),
        TILE3_TXN1_OUT                  =>      TXN_OUT(7),
        TILE3_TXP0_OUT                  =>      TXP_OUT(6),
        TILE3_TXP1_OUT                  =>      TXP_OUT(7),
        --------------------- Transmit Ports - TX PRBS Generator -------------------
        TILE3_TXENPRBSTST0_IN           =>      tile3_txenprbstst0_i,
        TILE3_TXENPRBSTST1_IN           =>      tile3_txenprbstst1_i,
        TILE3_TXPRBSFORCEERR0_IN        =>      tied_to_ground_i,
        TILE3_TXPRBSFORCEERR1_IN        =>      tied_to_ground_i


    );




    ------------------------------ TXSYNC module ------------------------------
    -- The TXSYNC module performs phase synchronization for all the active TX datapaths. It
    -- waits for the user clocks to be stable, then drives the phase align signals on each
    -- GTP. When phase synchronization is complete, it asserts SYNC_DONE
    
    -- Include the tx_sync module in your own design to perform phase synchronization if
    -- your protocol bypasses the TX Buffers
  
    
    tile0_reset_txsync0_c  <=  not tile0_tx_resetdone0_r2;  
    
    tile0_txsync0_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile0_txenpmaphasealign0_i,
        TXPMASETPHASE                   =>      tile0_txpmasetphase0_i,
        SYNC_DONE                       =>      tile0_tx_sync_done0_i,
        USER_CLK                        =>      tile0_txusrclk20_i,
        RESET                           =>      tile0_reset_txsync0_c
    );
    
    tile1_reset_txsync0_c  <=  not tile1_tx_resetdone0_r2;  
    
    tile1_txsync0_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile1_txenpmaphasealign0_i,
        TXPMASETPHASE                   =>      tile1_txpmasetphase0_i,
        SYNC_DONE                       =>      tile1_tx_sync_done0_i,
        USER_CLK                        =>      tile0_txusrclk20_i,
        RESET                           =>      tile1_reset_txsync0_c
    );
    
    tile2_reset_txsync0_c  <=  not tile2_tx_resetdone0_r2;  
    
    tile2_txsync0_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile2_txenpmaphasealign0_i,
        TXPMASETPHASE                   =>      tile2_txpmasetphase0_i,
        SYNC_DONE                       =>      tile2_tx_sync_done0_i,
        USER_CLK                        =>      tile2_txusrclk20_i,
        RESET                           =>      tile2_reset_txsync0_c
    );
    
    tile3_reset_txsync0_c  <=  not tile3_tx_resetdone0_r2;  
    
    tile3_txsync0_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile3_txenpmaphasealign0_i,
        TXPMASETPHASE                   =>      tile3_txpmasetphase0_i,
        SYNC_DONE                       =>      tile3_tx_sync_done0_i,
        USER_CLK                        =>      tile2_txusrclk20_i,
        RESET                           =>      tile3_reset_txsync0_c
    );
    
  
    
    tile0_reset_txsync1_c  <=  not tile0_tx_resetdone1_r2;  
    
    tile0_txsync1_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile0_txenpmaphasealign1_i,
        TXPMASETPHASE                   =>      tile0_txpmasetphase1_i,
        SYNC_DONE                       =>      tile0_tx_sync_done1_i,
        USER_CLK                        =>      tile0_txusrclk20_i,
        RESET                           =>      tile0_reset_txsync1_c
    );
    
    tile1_reset_txsync1_c  <=  not tile1_tx_resetdone1_r2;  
    
    tile1_txsync1_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile1_txenpmaphasealign1_i,
        TXPMASETPHASE                   =>      tile1_txpmasetphase1_i,
        SYNC_DONE                       =>      tile1_tx_sync_done1_i,
        USER_CLK                        =>      tile0_txusrclk20_i,
        RESET                           =>      tile1_reset_txsync1_c
    );
    
    tile2_reset_txsync1_c  <=  not tile2_tx_resetdone1_r2;  
    
    tile2_txsync1_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile2_txenpmaphasealign1_i,
        TXPMASETPHASE                   =>      tile2_txpmasetphase1_i,
        SYNC_DONE                       =>      tile2_tx_sync_done1_i,
        USER_CLK                        =>      tile2_txusrclk20_i,
        RESET                           =>      tile2_reset_txsync1_c
    );
    
    tile3_reset_txsync1_c  <=  not tile3_tx_resetdone1_r2;  
    
    tile3_txsync1_i : ser16a_tx_sync
    generic map
    (
        PLL_DIVSEL_OUT                  =>      1
    )
    port map
    (
        TXENPMAPHASEALIGN               =>      tile3_txenpmaphasealign1_i,
        TXPMASETPHASE                   =>      tile3_txpmasetphase1_i,
        SYNC_DONE                       =>      tile3_tx_sync_done1_i,
        USER_CLK                        =>      tile2_txusrclk20_i,
        RESET                           =>      tile3_reset_txsync1_c
    );
    

    ---------------------------- RXSYNC modules -------------------------------
    -- The RXSYNC module performs phase synchronization for all the active RX datapaths. It
    -- waits for the user clocks to be stable, then drives the RX phase align signals on each
    -- GTX. When phase synchronization is complete, it asserts SYNC_DONE
    
    -- Include one rx_sync module per Buffer bypassed RX datapath in your own design. rx_sync modules
    -- can also be shared, but when sharing, make sure to hold the module in reset until all lanes have 
    -- a stable clock
    
  
    
    tile0_reset_rxsync0_c    <=  not tile0_rx_resetdone0_r2;      
    
    tile0_rxsync0_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile0_rxenpmaphasealign0_i,
        RXPMASETPHASE                   =>      tile0_rxpmasetphase0_i,
        SYNC_DONE                       =>      tile0_rx_sync_done0_i,
        USER_CLK                        =>      tile0_rxusrclk20_i,
        RESET                           =>      tile0_reset_rxsync0_c
    );
    
    
    tile1_reset_rxsync0_c    <=  not tile1_rx_resetdone0_r2;      
    
    tile1_rxsync0_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile1_rxenpmaphasealign0_i,
        RXPMASETPHASE                   =>      tile1_rxpmasetphase0_i,
        SYNC_DONE                       =>      tile1_rx_sync_done0_i,
        USER_CLK                        =>      tile1_rxusrclk20_i,
        RESET                           =>      tile1_reset_rxsync0_c
    );
    
    
    tile2_reset_rxsync0_c    <=  not tile2_rx_resetdone0_r2;      
    
    tile2_rxsync0_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile2_rxenpmaphasealign0_i,
        RXPMASETPHASE                   =>      tile2_rxpmasetphase0_i,
        SYNC_DONE                       =>      tile2_rx_sync_done0_i,
        USER_CLK                        =>      tile2_rxusrclk20_i,
        RESET                           =>      tile2_reset_rxsync0_c
    );
    
    
    tile3_reset_rxsync0_c    <=  not tile3_rx_resetdone0_r2;      
    
    tile3_rxsync0_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile3_rxenpmaphasealign0_i,
        RXPMASETPHASE                   =>      tile3_rxpmasetphase0_i,
        SYNC_DONE                       =>      tile3_rx_sync_done0_i,
        USER_CLK                        =>      tile3_rxusrclk20_i,
        RESET                           =>      tile3_reset_rxsync0_c
    );
    
    
  
    
    tile0_reset_rxsync1_c    <=  not tile0_rx_resetdone1_r2;      
    
    tile0_rxsync1_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile0_rxenpmaphasealign1_i,
        RXPMASETPHASE                   =>      tile0_rxpmasetphase1_i,
        SYNC_DONE                       =>      tile0_rx_sync_done1_i,
        USER_CLK                        =>      tile0_rxusrclk21_i,
        RESET                           =>      tile0_reset_rxsync1_c
    );
    
    
    tile1_reset_rxsync1_c    <=  not tile1_rx_resetdone1_r2;      
    
    tile1_rxsync1_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile1_rxenpmaphasealign1_i,
        RXPMASETPHASE                   =>      tile1_rxpmasetphase1_i,
        SYNC_DONE                       =>      tile1_rx_sync_done1_i,
        USER_CLK                        =>      tile1_rxusrclk21_i,
        RESET                           =>      tile1_reset_rxsync1_c
    );
    
    
    tile2_reset_rxsync1_c    <=  not tile2_rx_resetdone1_r2;      
    
    tile2_rxsync1_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile2_rxenpmaphasealign1_i,
        RXPMASETPHASE                   =>      tile2_rxpmasetphase1_i,
        SYNC_DONE                       =>      tile2_rx_sync_done1_i,
        USER_CLK                        =>      tile2_rxusrclk21_i,
        RESET                           =>      tile2_reset_rxsync1_c
    );
    
    
    tile3_reset_rxsync1_c    <=  not tile3_rx_resetdone1_r2;      
    
    tile3_rxsync1_i : ser16a_rx_sync
    port map
    (
        RXENPMAPHASEALIGN               =>      tile3_rxenpmaphasealign1_i,
        RXPMASETPHASE                   =>      tile3_rxpmasetphase1_i,
        SYNC_DONE                       =>      tile3_rx_sync_done1_i,
        USER_CLK                        =>      tile3_rxusrclk21_i,
        RESET                           =>      tile3_reset_rxsync1_c
    );
    
    



    -------------------------- User Module Resets -----------------------------
    -- All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    -- are held in reset till the RESETDONE goes high. 
    -- The RESETDONE is registered a couple of times on USRCLK2 and connected 
    -- to the reset of the modules
    
    process( tile0_rxusrclk20_i,tile0_resetdone0_i)
    begin
        if(tile0_resetdone0_i = '0') then
            tile0_rx_resetdone0_r  <= '0'   ;
            tile0_rx_resetdone0_r2 <= '0'   ;
        elsif(tile0_rxusrclk20_i'event and tile0_rxusrclk20_i = '1') then
            tile0_rx_resetdone0_r  <= tile0_resetdone0_i   ;
            tile0_rx_resetdone0_r2 <= tile0_rx_resetdone0_r   ;
        end if;
    end process;
    
    process( tile0_rxusrclk21_i,tile0_resetdone1_i)
    begin
        if(tile0_resetdone1_i = '0') then
            tile0_rx_resetdone1_r  <= '0'   ;
            tile0_rx_resetdone1_r2 <= '0'   ;
        elsif(tile0_rxusrclk21_i'event and tile0_rxusrclk21_i = '1') then
            tile0_rx_resetdone1_r  <= tile0_resetdone1_i   ;
            tile0_rx_resetdone1_r2 <= tile0_rx_resetdone1_r   ;
        end if;
    end process;
    
    process( tile1_rxusrclk20_i,tile1_resetdone0_i)
    begin
        if(tile1_resetdone0_i = '0') then
            tile1_rx_resetdone0_r  <= '0'   ;
            tile1_rx_resetdone0_r2 <= '0'   ;
        elsif(tile1_rxusrclk20_i'event and tile1_rxusrclk20_i = '1') then
            tile1_rx_resetdone0_r  <= tile1_resetdone0_i   ;
            tile1_rx_resetdone0_r2 <= tile1_rx_resetdone0_r   ;
        end if;
    end process;
    
    process( tile1_rxusrclk21_i,tile1_resetdone1_i)
    begin
        if(tile1_resetdone1_i = '0') then
            tile1_rx_resetdone1_r  <= '0'   ;
            tile1_rx_resetdone1_r2 <= '0'   ;
        elsif(tile1_rxusrclk21_i'event and tile1_rxusrclk21_i = '1') then
            tile1_rx_resetdone1_r  <= tile1_resetdone1_i   ;
            tile1_rx_resetdone1_r2 <= tile1_rx_resetdone1_r   ;
        end if;
    end process;
    
    process( tile2_rxusrclk20_i,tile2_resetdone0_i)
    begin
        if(tile2_resetdone0_i = '0') then
            tile2_rx_resetdone0_r  <= '0'   ;
            tile2_rx_resetdone0_r2 <= '0'   ;
        elsif(tile2_rxusrclk20_i'event and tile2_rxusrclk20_i = '1') then
            tile2_rx_resetdone0_r  <= tile2_resetdone0_i   ;
            tile2_rx_resetdone0_r2 <= tile2_rx_resetdone0_r   ;
        end if;
    end process;
    
    process( tile2_rxusrclk21_i,tile2_resetdone1_i)
    begin
        if(tile2_resetdone1_i = '0') then
            tile2_rx_resetdone1_r  <= '0'   ;
            tile2_rx_resetdone1_r2 <= '0'   ;
        elsif(tile2_rxusrclk21_i'event and tile2_rxusrclk21_i = '1') then
            tile2_rx_resetdone1_r  <= tile2_resetdone1_i   ;
            tile2_rx_resetdone1_r2 <= tile2_rx_resetdone1_r   ;
        end if;
    end process;
    
    process( tile3_rxusrclk20_i,tile3_resetdone0_i)
    begin
        if(tile3_resetdone0_i = '0') then
            tile3_rx_resetdone0_r  <= '0'   ;
            tile3_rx_resetdone0_r2 <= '0'   ;
        elsif(tile3_rxusrclk20_i'event and tile3_rxusrclk20_i = '1') then
            tile3_rx_resetdone0_r  <= tile3_resetdone0_i   ;
            tile3_rx_resetdone0_r2 <= tile3_rx_resetdone0_r   ;
        end if;
    end process;
    
    process( tile3_rxusrclk21_i,tile3_resetdone1_i)
    begin
        if(tile3_resetdone1_i = '0') then
            tile3_rx_resetdone1_r  <= '0'   ;
            tile3_rx_resetdone1_r2 <= '0'   ;
        elsif(tile3_rxusrclk21_i'event and tile3_rxusrclk21_i = '1') then
            tile3_rx_resetdone1_r  <= tile3_resetdone1_i   ;
            tile3_rx_resetdone1_r2 <= tile3_rx_resetdone1_r   ;
        end if;
    end process;
    
    process( tile0_txusrclk20_i,tile0_resetdone0_i)
    begin
        if (tile0_resetdone0_i = '0') then 
            tile0_tx_resetdone0_r    <=   '0'   ;
            tile0_tx_resetdone0_r2   <=   '0'   ;
        elsif(tile0_txusrclk20_i'event and tile0_txusrclk20_i = '1') then
            tile0_tx_resetdone0_r    <=   tile0_resetdone0_i  ;
            tile0_tx_resetdone0_r2   <=   tile0_tx_resetdone0_r   ;
        end if;
    end process; 
    process( tile0_txusrclk20_i,tile0_resetdone1_i)
    begin
        if (tile0_resetdone1_i = '0') then 
            tile0_tx_resetdone1_r    <=   '0'   ;
            tile0_tx_resetdone1_r2   <=   '0'   ;
        elsif(tile0_txusrclk20_i'event and tile0_txusrclk20_i = '1') then
            tile0_tx_resetdone1_r    <=   tile0_resetdone1_i  ;
            tile0_tx_resetdone1_r2   <=   tile0_tx_resetdone1_r   ;
        end if;
    end process; 
    process( tile0_txusrclk20_i,tile1_resetdone0_i)
    begin
        if (tile1_resetdone0_i = '0') then 
            tile1_tx_resetdone0_r    <=   '0'   ;
            tile1_tx_resetdone0_r2   <=   '0'   ;
        elsif(tile0_txusrclk20_i'event and tile0_txusrclk20_i = '1') then
            tile1_tx_resetdone0_r    <=   tile1_resetdone0_i  ;
            tile1_tx_resetdone0_r2   <=   tile1_tx_resetdone0_r   ;
        end if;
    end process; 
    process( tile0_txusrclk20_i,tile1_resetdone1_i)
    begin
        if (tile1_resetdone1_i = '0') then 
            tile1_tx_resetdone1_r    <=   '0'   ;
            tile1_tx_resetdone1_r2   <=   '0'   ;
        elsif(tile0_txusrclk20_i'event and tile0_txusrclk20_i = '1') then
            tile1_tx_resetdone1_r    <=   tile1_resetdone1_i  ;
            tile1_tx_resetdone1_r2   <=   tile1_tx_resetdone1_r   ;
        end if;
    end process; 
    process( tile2_txusrclk20_i,tile2_resetdone0_i)
    begin
        if (tile2_resetdone0_i = '0') then 
            tile2_tx_resetdone0_r    <=   '0'   ;
            tile2_tx_resetdone0_r2   <=   '0'   ;
        elsif(tile2_txusrclk20_i'event and tile2_txusrclk20_i = '1') then
            tile2_tx_resetdone0_r    <=   tile2_resetdone0_i  ;
            tile2_tx_resetdone0_r2   <=   tile2_tx_resetdone0_r   ;
        end if;
    end process; 
    process( tile2_txusrclk20_i,tile2_resetdone1_i)
    begin
        if (tile2_resetdone1_i = '0') then 
            tile2_tx_resetdone1_r    <=   '0'   ;
            tile2_tx_resetdone1_r2   <=   '0'   ;
        elsif(tile2_txusrclk20_i'event and tile2_txusrclk20_i = '1') then
            tile2_tx_resetdone1_r    <=   tile2_resetdone1_i  ;
            tile2_tx_resetdone1_r2   <=   tile2_tx_resetdone1_r   ;
        end if;
    end process; 
    process( tile2_txusrclk20_i,tile3_resetdone0_i)
    begin
        if (tile3_resetdone0_i = '0') then 
            tile3_tx_resetdone0_r    <=   '0'   ;
            tile3_tx_resetdone0_r2   <=   '0'   ;
        elsif(tile2_txusrclk20_i'event and tile2_txusrclk20_i = '1') then
            tile3_tx_resetdone0_r    <=   tile3_resetdone0_i  ;
            tile3_tx_resetdone0_r2   <=   tile3_tx_resetdone0_r   ;
        end if;
    end process; 
    process( tile2_txusrclk20_i,tile3_resetdone1_i)
    begin
        if (tile3_resetdone1_i = '0') then 
            tile3_tx_resetdone1_r    <=   '0'   ;
            tile3_tx_resetdone1_r2   <=   '0'   ;
        elsif(tile2_txusrclk20_i'event and tile2_txusrclk20_i = '1') then
            tile3_tx_resetdone1_r    <=   tile3_resetdone1_i  ;
            tile3_tx_resetdone1_r2   <=   tile3_tx_resetdone1_r   ;
        end if;
    end process; 

    ------------------------------ Frame Generators ---------------------------
    -- The example design uses Block RAM based frame generators to provide test
    -- data to the GTPs for transmission. By default the frame generators are 
    -- loaded with an incrementing data sequence that includes commas/alignment
    -- characters for alignment. If your protocol uses channel bonding, the 
    -- frame generator will also be preloaded with a channel bonding sequence.
    
    -- You can modify the data transmitted by changing the INIT values of the frame
    -- generator in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.

    tile0_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile0_txdata0_float_i,
        TX_DATA(15 downto 0)            =>      tile0_txdata0_i,
 
        TX_CHARISK(3 downto 2)          =>      tile0_txcharisk0_float_i,
        TX_CHARISK(1 downto 0)          =>      tile0_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk20_i,
        SYSTEM_RESET                    =>      tile0_tx_system_reset0_c
    );
    
    tile0_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile0_txdata1_float_i,
        TX_DATA(15 downto 0)            =>      tile0_txdata1_i,
 
        TX_CHARISK(3 downto 2)          =>      tile0_txcharisk1_float_i,
        TX_CHARISK(1 downto 0)          =>      tile0_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk20_i,
        SYSTEM_RESET                    =>      tile0_tx_system_reset1_c
    );
    
    tile1_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile1_txdata0_float_i,
        TX_DATA(15 downto 0)            =>      tile1_txdata0_i,
 
        TX_CHARISK(3 downto 2)          =>      tile1_txcharisk0_float_i,
        TX_CHARISK(1 downto 0)          =>      tile1_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk20_i,
        SYSTEM_RESET                    =>      tile1_tx_system_reset0_c
    );
    
    tile1_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile1_txdata1_float_i,
        TX_DATA(15 downto 0)            =>      tile1_txdata1_i,
 
        TX_CHARISK(3 downto 2)          =>      tile1_txcharisk1_float_i,
        TX_CHARISK(1 downto 0)          =>      tile1_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile0_txusrclk20_i,
        SYSTEM_RESET                    =>      tile1_tx_system_reset1_c
    );
    
    tile2_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile2_txdata0_float_i,
        TX_DATA(15 downto 0)            =>      tile2_txdata0_i,
 
        TX_CHARISK(3 downto 2)          =>      tile2_txcharisk0_float_i,
        TX_CHARISK(1 downto 0)          =>      tile2_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile2_txusrclk20_i,
        SYSTEM_RESET                    =>      tile2_tx_system_reset0_c
    );
    
    tile2_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile2_txdata1_float_i,
        TX_DATA(15 downto 0)            =>      tile2_txdata1_i,
 
        TX_CHARISK(3 downto 2)          =>      tile2_txcharisk1_float_i,
        TX_CHARISK(1 downto 0)          =>      tile2_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile2_txusrclk20_i,
        SYSTEM_RESET                    =>      tile2_tx_system_reset1_c
    );
    
    tile3_frame_gen0 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile3_txdata0_float_i,
        TX_DATA(15 downto 0)            =>      tile3_txdata0_i,
 
        TX_CHARISK(3 downto 2)          =>      tile3_txcharisk0_float_i,
        TX_CHARISK(1 downto 0)          =>      tile3_txcharisk0_i,
        -- System Interface
        USER_CLK                        =>      tile2_txusrclk20_i,
        SYSTEM_RESET                    =>      tile3_tx_system_reset0_c
    );
    
    tile3_frame_gen1 : FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- User Interface
        TX_DATA(39 downto 16)           =>      tile3_txdata1_float_i,
        TX_DATA(15 downto 0)            =>      tile3_txdata1_i,
 
        TX_CHARISK(3 downto 2)          =>      tile3_txcharisk1_float_i,
        TX_CHARISK(1 downto 0)          =>      tile3_txcharisk1_i,
        -- System Interface
        USER_CLK                        =>      tile2_txusrclk20_i,
        SYSTEM_RESET                    =>      tile3_tx_system_reset1_c
    );
    


    ---------------------------------- Frame Checkers -------------------------
    -- The example design uses Block RAM based frame checkers to verify incoming  
    -- data. By default the frame generators are loaded with a data sequence that 
    -- matches the outgoing sequence of the frame generators for the TX ports.
    
    -- You can modify the expected data sequence by changing the INIT values of the frame
    -- checkers in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.
    
    -- When the frame checker receives data, it attempts to synchronise to the 
    -- incoming pattern by looking for the first sequence in the pattern. Once it 
    -- finds the first sequence, it increments through the sequence, and indicates an 
    -- error whenever the next value received does not match the expected value.

    tile0_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile0_matchn0_i;

    -- tile0_frame_check0 is always connected to the lane with the start of char
    -- and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    tile0_inc_in0_i                         <= '0';

    tile0_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      1,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile0_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile0_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile0_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile0_inc_in0_i,
        INC_OUT                         =>      tile0_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile0_matchn0_i,
        RESET_ON_ERROR                  =>      tile0_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_rxusrclk20_i,
        SYSTEM_RESET                    =>      tile0_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile0_error_count0_i,
        TRACK_DATA                      =>      tile0_track_data0_i
    );
    
    tile0_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile0_matchn1_i;

    -- tile0_frame_check0 is always connected to the lane with the start of char
    -- and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
    tile0_inc_in1_i                         <= '0';

    tile0_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      1,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile0_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile0_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile0_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile0_inc_in1_i,
        INC_OUT                         =>      tile0_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile0_matchn1_i,
        RESET_ON_ERROR                  =>      tile0_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile0_rxusrclk21_i,
        SYSTEM_RESET                    =>      tile0_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile0_error_count1_i,
        TRACK_DATA                      =>      tile0_track_data1_i
    );
    
    tile1_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile1_matchn0_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile1_inc_in0_i                         <= tile0_inc_out0_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile1_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile1_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile1_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile1_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile1_inc_in0_i,
        INC_OUT                         =>      tile1_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile1_matchn0_i,
        RESET_ON_ERROR                  =>      tile1_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile1_rxusrclk20_i,
        SYSTEM_RESET                    =>      tile1_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile1_error_count0_i,
        TRACK_DATA                      =>      tile1_track_data0_i
    );
    
    tile1_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile1_matchn1_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile1_inc_in1_i                         <= tile0_inc_out1_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile1_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile1_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile1_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile1_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile1_inc_in1_i,
        INC_OUT                         =>      tile1_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile1_matchn1_i,
        RESET_ON_ERROR                  =>      tile1_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile1_rxusrclk21_i,
        SYSTEM_RESET                    =>      tile1_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile1_error_count1_i,
        TRACK_DATA                      =>      tile1_track_data1_i
    );
    
    tile2_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile2_matchn0_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile2_inc_in0_i                         <= tile0_inc_out0_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile2_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile2_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile2_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile2_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile2_inc_in0_i,
        INC_OUT                         =>      tile2_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile2_matchn0_i,
        RESET_ON_ERROR                  =>      tile2_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile2_rxusrclk20_i,
        SYSTEM_RESET                    =>      tile2_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile2_error_count0_i,
        TRACK_DATA                      =>      tile2_track_data0_i
    );
    
    tile2_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile2_matchn1_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile2_inc_in1_i                         <= tile0_inc_out1_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile2_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile2_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile2_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile2_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile2_inc_in1_i,
        INC_OUT                         =>      tile2_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile2_matchn1_i,
        RESET_ON_ERROR                  =>      tile2_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile2_rxusrclk21_i,
        SYSTEM_RESET                    =>      tile2_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile2_error_count1_i,
        TRACK_DATA                      =>      tile2_track_data1_i
    );
    
    tile3_frame_check0_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile3_matchn0_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile3_inc_in0_i                         <= tile0_inc_out0_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile3_frame_check0 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile3_rxdata0_i,
        RX_ENMCOMMA_ALIGN               =>      tile3_rxenmcommaalign0_i,
        RX_ENPCOMMA_ALIGN               =>      tile3_rxenpcommaalign0_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile3_inc_in0_i,
        INC_OUT                         =>      tile3_inc_out0_i,
        PATTERN_MATCH_N                 =>      tile3_matchn0_i,
        RESET_ON_ERROR                  =>      tile3_frame_check0_reset_i,
        -- System Interface
        USER_CLK                        =>      tile3_rxusrclk20_i,
        SYSTEM_RESET                    =>      tile3_rx_system_reset0_c,
        ERROR_COUNT                     =>      tile3_error_count0_i,
        TRACK_DATA                      =>      tile3_track_data0_i
    );
    
    tile3_frame_check1_reset_i              <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else tile3_matchn1_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
    tile3_inc_in1_i                         <= tile0_inc_out1_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    tile3_frame_check1 : FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        USE_COMMA                       =>      1,
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        CONFIG_INDEPENDENT_LANES        =>      EXAMPLE_CONFIG_INDEPENDENT_LANES,
        START_OF_PACKET_CHAR            =>      x"bc",
        MEM_00                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_01                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_02                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_03                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_04                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_05                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_06                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_07                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_08                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_09                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_0A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_0B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_0C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_0D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_0E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_0F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_10                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_11                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_12                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_13                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_14                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_15                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_16                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_17                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_18                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_19                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_1A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_1B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_1C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_1D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_1E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_1F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_20                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_21                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_22                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_23                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_24                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_25                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_26                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_27                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_28                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_29                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_2A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_2B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_2C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_2D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_2E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_2F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_30                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_31                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_32                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_33                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_34                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_35                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_36                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_37                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEM_38                  =>  x"00000e0d00000c0b00000a09000008070000060500000403000002bc00000100",
        MEM_39                  =>  x"00001e1d00001c1b00001a19000018170000161500001413000012110000100f",
        MEM_3A                  =>  x"00002e2d00002c2b00002a29000028270000262500002423000022210000201f",
        MEM_3B                  =>  x"00003e3d00003c3b00003a39000038370000363500003433000032310000302f",
        MEM_3C                  =>  x"00004e4d00004c4b00004a49000048470000464500004443000042410000403f",
        MEM_3D                  =>  x"00005e5d00005c5b00005a59000058570000565500005453000052510000504f",
        MEM_3E                  =>  x"00006e6d00006c6b00006a69000068670000666500006463000062610000605f",
        MEM_3F                  =>  x"00007e7d00007c7b00007a79000078770000767500007473000072710000706f",
        MEMP_00                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_01                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_02                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_03                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_04                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_05                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_06                  =>  x"0000000000000000000000000000000000000000000000000000000000000010",
        MEMP_07                  =>  x"0000000000000000000000000000000000000000000000000000000000000010"
    )
    port map
    (
        -- MGT Interface
        RX_DATA                         =>      tile3_rxdata1_i,
        RX_ENMCOMMA_ALIGN               =>      tile3_rxenmcommaalign1_i,
        RX_ENPCOMMA_ALIGN               =>      tile3_rxenpcommaalign1_i,
        RX_ENCHAN_SYNC                  =>      open,
        RX_CHANBOND_SEQ                 =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      tile3_inc_in1_i,
        INC_OUT                         =>      tile3_inc_out1_i,
        PATTERN_MATCH_N                 =>      tile3_matchn1_i,
        RESET_ON_ERROR                  =>      tile3_frame_check1_reset_i,
        -- System Interface
        USER_CLK                        =>      tile3_rxusrclk21_i,
        SYSTEM_RESET                    =>      tile3_rx_system_reset1_c,
        ERROR_COUNT                     =>      tile3_error_count1_i,
        TRACK_DATA                      =>      tile3_track_data1_i
    );
    

    TRACK_DATA_OUT                          <= track_data_out_i;

    track_data_out_i                        <= 
                                tile0_track_data0_i  and
                                tile0_track_data1_i  and
                                tile1_track_data0_i  and
                                tile1_track_data1_i  and
                                tile2_track_data0_i  and
                                tile2_track_data1_i  and
                                tile3_track_data0_i  and
                                tile3_track_data1_i ;


    reset_on_data_error_i                   <= '0';



    ----------------------------- Chipscope Connections -----------------------
    -- When the example design is run in hardware, it uses chipscope to allow the
    -- example design and GTP wrapper to be controlled and monitored. The 
    -- EXAMPLE_USE_CHIPSCOPE parameter allows chipscope to be removed for simulation.
    
chipscope : if EXAMPLE_USE_CHIPSCOPE = 1 generate


    -- Shared VIO for all tiles
    shared_vio_i : shared_vio
    port map
    (
        control                         =>      shared_vio_control_i,
        async_in                        =>      shared_vio_in_i,
        async_out                       =>      shared_vio_out_i
    );

    
    -- ICON for all VIOs 
    i_icon : icon
    port map
    (
        control0                        =>      shared_vio_control_i,
        control1                        =>      tile0_data_vio_control_i,
        control2                        =>      tile0_gtp0_ila_control_i,
        control3                        =>      tile0_gtp1_ila_control_i,
        control4                        =>      tile1_data_vio_control_i,
        control5                        =>      tile1_gtp0_ila_control_i,
        control6                        =>      tile1_gtp1_ila_control_i,
        control7                        =>      tile2_data_vio_control_i,
        control8                        =>      tile2_gtp0_ila_control_i,
        control9                        =>      tile2_gtp1_ila_control_i,
        control10                       =>      tile3_data_vio_control_i,
        control11                       =>      tile3_gtp0_ila_control_i,
        control12                       =>      tile3_gtp1_ila_control_i
    );

    -- TILE0 DATA VIO 
    tile0_data_vio_i : data_vio
    port map
    (
        control                         =>      tile0_data_vio_control_i,
        async_in                        =>      tile0_data_vio_in_i,
        async_out                       =>      tile0_data_vio_out_i    
    );
    -- TILE1 DATA VIO 
    tile1_data_vio_i : data_vio
    port map
    (
        control                         =>      tile1_data_vio_control_i,
        async_in                        =>      tile1_data_vio_in_i,
        async_out                       =>      tile1_data_vio_out_i    
    );
    -- TILE2 DATA VIO 
    tile2_data_vio_i : data_vio
    port map
    (
        control                         =>      tile2_data_vio_control_i,
        async_in                        =>      tile2_data_vio_in_i,
        async_out                       =>      tile2_data_vio_out_i    
    );
    -- TILE3 DATA VIO 
    tile3_data_vio_i : data_vio
    port map
    (
        control                         =>      tile3_data_vio_control_i,
        async_in                        =>      tile3_data_vio_in_i,
        async_out                       =>      tile3_data_vio_out_i    
    );
    
    -- TILE0 GTP0 RX ILA 
    tile0_gtp0_i : ila
    port map
    (
        control                         =>      tile0_gtp0_ila_control_i,
        clk                             =>      tile0_rxusrclk20_i,
        trig0                           =>      tile0_ila_in0_i
    );
    -- TILE0 GTP1 RX ILA 
    tile0_gtp1_i : ila
    port map
    (
        control                         =>      tile0_gtp1_ila_control_i,
        clk                             =>      tile0_rxusrclk21_i,
        trig0                           =>      tile0_ila_in1_i
    );
    -- TILE1 GTP0 RX ILA 
    tile1_gtp0_i : ila
    port map
    (
        control                         =>      tile1_gtp0_ila_control_i,
        clk                             =>      tile1_rxusrclk20_i,
        trig0                           =>      tile1_ila_in0_i
    );
    -- TILE1 GTP1 RX ILA 
    tile1_gtp1_i : ila
    port map
    (
        control                         =>      tile1_gtp1_ila_control_i,
        clk                             =>      tile1_rxusrclk21_i,
        trig0                           =>      tile1_ila_in1_i
    );
    -- TILE2 GTP0 RX ILA 
    tile2_gtp0_i : ila
    port map
    (
        control                         =>      tile2_gtp0_ila_control_i,
        clk                             =>      tile2_rxusrclk20_i,
        trig0                           =>      tile2_ila_in0_i
    );
    -- TILE2 GTP1 RX ILA 
    tile2_gtp1_i : ila
    port map
    (
        control                         =>      tile2_gtp1_ila_control_i,
        clk                             =>      tile2_rxusrclk21_i,
        trig0                           =>      tile2_ila_in1_i
    );
    -- TILE3 GTP0 RX ILA 
    tile3_gtp0_i : ila
    port map
    (
        control                         =>      tile3_gtp0_ila_control_i,
        clk                             =>      tile3_rxusrclk20_i,
        trig0                           =>      tile3_ila_in0_i
    );
    -- TILE3 GTP1 RX ILA 
    tile3_gtp1_i : ila
    port map
    (
        control                         =>      tile3_gtp1_ila_control_i,
        clk                             =>      tile3_rxusrclk21_i,
        trig0                           =>      tile3_ila_in1_i
    );
    




    -- Connect resets for frame generators
    tile0_tx_system_reset0_c                <= not tile0_tx_sync_done0_i or user_tx_reset_i;
    tile0_tx_system_reset1_c                <= not tile0_tx_sync_done1_i or user_tx_reset_i;
    tile1_tx_system_reset0_c                <= not tile1_tx_sync_done0_i or user_tx_reset_i;
    tile1_tx_system_reset1_c                <= not tile1_tx_sync_done1_i or user_tx_reset_i;
    tile2_tx_system_reset0_c                <= not tile2_tx_sync_done0_i or user_tx_reset_i;
    tile2_tx_system_reset1_c                <= not tile2_tx_sync_done1_i or user_tx_reset_i;
    tile3_tx_system_reset0_c                <= not tile3_tx_sync_done0_i or user_tx_reset_i;
    tile3_tx_system_reset1_c                <= not tile3_tx_sync_done1_i or user_tx_reset_i;
    tile0_rx_system_reset0_c                <= not tile0_rx_sync_done0_i or user_rx_reset_i;
    tile0_rx_system_reset1_c                <= not tile0_rx_sync_done1_i or user_rx_reset_i;
    tile1_rx_system_reset0_c                <= not tile1_rx_sync_done0_i or user_rx_reset_i;
    tile1_rx_system_reset1_c                <= not tile1_rx_sync_done1_i or user_rx_reset_i;
    tile2_rx_system_reset0_c                <= not tile2_rx_sync_done0_i or user_rx_reset_i;
    tile2_rx_system_reset1_c                <= not tile2_rx_sync_done1_i or user_rx_reset_i;
    tile3_rx_system_reset0_c                <= not tile3_rx_sync_done0_i or user_rx_reset_i;
    tile3_rx_system_reset1_c                <= not tile3_rx_sync_done1_i or user_rx_reset_i;


    tile0_gtpreset0_i                       <= gtpreset0_i;
    tile0_gtpreset1_i                       <= gtpreset0_i;   
    tile1_gtpreset0_i                       <= gtpreset0_i;
    tile1_gtpreset1_i                       <= gtpreset0_i;   
    tile2_gtpreset0_i                       <= gtpreset0_i;
    tile2_gtpreset1_i                       <= gtpreset0_i;   
    tile3_gtpreset0_i                       <= gtpreset0_i;
    tile3_gtpreset1_i                       <= gtpreset0_i;   


    -- Shared VIO Outputs
    gtpreset0_i                             <= shared_vio_out_i(31);
    user_tx_reset_i                         <= shared_vio_out_i(30);
    user_rx_reset_i                         <= shared_vio_out_i(29);

    -- Shared VIO Inputs
    shared_vio_in_i(31)                     <= tile0_plllkdet0_i;
    shared_vio_in_i(30)                     <= tile1_plllkdet0_i;
    shared_vio_in_i(29)                     <= tile2_plllkdet0_i;
    shared_vio_in_i(28)                     <= tile3_plllkdet0_i;
    shared_vio_in_i(27 downto 0)            <= tied_to_ground_vec_i(27 downto 0);

    -- Chipscope VIO input connections on Tile 0
    tile0_data_vio_in_i(139)                <= tile0_resetdone0_i;
    tile0_data_vio_in_i(138)                <= tile0_resetdone1_i;
    tile0_data_vio_in_i(137 downto 0)       <= tied_to_ground_vec_i(137 downto 0);

    -- Chipscope VIO ouptut connections on Tile 0
    tile0_loopback0_i                       <= tile0_data_vio_out_i(139 downto 137);
    tile0_loopback1_i                       <= tile0_data_vio_out_i(136 downto 134);
    tile0_rxslide0_i                        <= tile0_data_vio_out_i(133);
    tile0_rxslide1_i                        <= tile0_data_vio_out_i(132);
    tile0_prbscntreset0_i                   <= tile0_data_vio_out_i(131);
    tile0_prbscntreset1_i                   <= tile0_data_vio_out_i(130);
    tile0_rxenprbstst0_i                    <= tile0_data_vio_out_i(129 downto 127);
    tile0_rxenprbstst1_i                    <= tile0_data_vio_out_i(126 downto 124);
    tile0_txenprbstst0_i                    <= tile0_data_vio_out_i(123 downto 121);
    tile0_txenprbstst1_i                    <= tile0_data_vio_out_i(120 downto 118);

    -- Chipscope ILA connections for GTP0 on Tile 0
    tile0_ila_in0_i(84 downto 83)           <= tile0_rxdisperr0_i;
    tile0_ila_in0_i(82 downto 81)           <= tile0_rxnotintable0_i;
    tile0_ila_in0_i(80)                     <= tile0_rxbyteisaligned0_i;
    tile0_ila_in0_i(79)                     <= tile0_rxbyterealign0_i;
    tile0_ila_in0_i(78)                     <= tile0_rxcommadet0_i;
    tile0_ila_in0_i(77)                     <= tile0_rxprbserr0_i;
    tile0_ila_in0_i(76 downto 61)           <= tile0_rxdata0_i;
    tile0_ila_in0_i(60 downto 53)           <= tile0_error_count0_i;
    tile0_ila_in0_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope ILA connections for GTP1 on Tile 0
    tile0_ila_in1_i(84 downto 83)           <= tile0_rxdisperr1_i;
    tile0_ila_in1_i(82 downto 81)           <= tile0_rxnotintable1_i;
    tile0_ila_in1_i(80)                     <= tile0_rxbyteisaligned1_i;
    tile0_ila_in1_i(79)                     <= tile0_rxbyterealign1_i;
    tile0_ila_in1_i(78)                     <= tile0_rxcommadet1_i;
    tile0_ila_in1_i(77)                     <= tile0_rxprbserr1_i;
    tile0_ila_in1_i(76 downto 61)           <= tile0_rxdata1_i;
    tile0_ila_in1_i(60 downto 53)           <= tile0_error_count1_i;
    tile0_ila_in1_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope VIO input connections on Tile 1
    tile1_data_vio_in_i(139)                <= tile1_resetdone0_i;
    tile1_data_vio_in_i(138)                <= tile1_resetdone1_i;
    tile1_data_vio_in_i(137 downto 0)       <= tied_to_ground_vec_i(137 downto 0);

    -- Chipscope VIO ouptut connections on Tile 1
    tile1_loopback0_i                       <= tile1_data_vio_out_i(139 downto 137);
    tile1_loopback1_i                       <= tile1_data_vio_out_i(136 downto 134);
    tile1_rxslide0_i                        <= tile1_data_vio_out_i(133);
    tile1_rxslide1_i                        <= tile1_data_vio_out_i(132);
    tile1_prbscntreset0_i                   <= tile1_data_vio_out_i(131);
    tile1_prbscntreset1_i                   <= tile1_data_vio_out_i(130);
    tile1_rxenprbstst0_i                    <= tile1_data_vio_out_i(129 downto 127);
    tile1_rxenprbstst1_i                    <= tile1_data_vio_out_i(126 downto 124);
    tile1_txenprbstst0_i                    <= tile1_data_vio_out_i(123 downto 121);
    tile1_txenprbstst1_i                    <= tile1_data_vio_out_i(120 downto 118);

    -- Chipscope ILA connections for GTP0 on Tile 1
    tile1_ila_in0_i(84 downto 83)           <= tile1_rxdisperr0_i;
    tile1_ila_in0_i(82 downto 81)           <= tile1_rxnotintable0_i;
    tile1_ila_in0_i(80)                     <= tile1_rxbyteisaligned0_i;
    tile1_ila_in0_i(79)                     <= tile1_rxbyterealign0_i;
    tile1_ila_in0_i(78)                     <= tile1_rxcommadet0_i;
    tile1_ila_in0_i(77)                     <= tile1_rxprbserr0_i;
    tile1_ila_in0_i(76 downto 61)           <= tile1_rxdata0_i;
    tile1_ila_in0_i(60 downto 53)           <= tile1_error_count0_i;
    tile1_ila_in0_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope ILA connections for GTP1 on Tile 1
    tile1_ila_in1_i(84 downto 83)           <= tile1_rxdisperr1_i;
    tile1_ila_in1_i(82 downto 81)           <= tile1_rxnotintable1_i;
    tile1_ila_in1_i(80)                     <= tile1_rxbyteisaligned1_i;
    tile1_ila_in1_i(79)                     <= tile1_rxbyterealign1_i;
    tile1_ila_in1_i(78)                     <= tile1_rxcommadet1_i;
    tile1_ila_in1_i(77)                     <= tile1_rxprbserr1_i;
    tile1_ila_in1_i(76 downto 61)           <= tile1_rxdata1_i;
    tile1_ila_in1_i(60 downto 53)           <= tile1_error_count1_i;
    tile1_ila_in1_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope VIO input connections on Tile 2
    tile2_data_vio_in_i(139)                <= tile2_resetdone0_i;
    tile2_data_vio_in_i(138)                <= tile2_resetdone1_i;
    tile2_data_vio_in_i(137 downto 0)       <= tied_to_ground_vec_i(137 downto 0);

    -- Chipscope VIO ouptut connections on Tile 2
    tile2_loopback0_i                       <= tile2_data_vio_out_i(139 downto 137);
    tile2_loopback1_i                       <= tile2_data_vio_out_i(136 downto 134);
    tile2_rxslide0_i                        <= tile2_data_vio_out_i(133);
    tile2_rxslide1_i                        <= tile2_data_vio_out_i(132);
    tile2_prbscntreset0_i                   <= tile2_data_vio_out_i(131);
    tile2_prbscntreset1_i                   <= tile2_data_vio_out_i(130);
    tile2_rxenprbstst0_i                    <= tile2_data_vio_out_i(129 downto 127);
    tile2_rxenprbstst1_i                    <= tile2_data_vio_out_i(126 downto 124);
    tile2_txenprbstst0_i                    <= tile2_data_vio_out_i(123 downto 121);
    tile2_txenprbstst1_i                    <= tile2_data_vio_out_i(120 downto 118);

    -- Chipscope ILA connections for GTP0 on Tile 2
    tile2_ila_in0_i(84 downto 83)           <= tile2_rxdisperr0_i;
    tile2_ila_in0_i(82 downto 81)           <= tile2_rxnotintable0_i;
    tile2_ila_in0_i(80)                     <= tile2_rxbyteisaligned0_i;
    tile2_ila_in0_i(79)                     <= tile2_rxbyterealign0_i;
    tile2_ila_in0_i(78)                     <= tile2_rxcommadet0_i;
    tile2_ila_in0_i(77)                     <= tile2_rxprbserr0_i;
    tile2_ila_in0_i(76 downto 61)           <= tile2_rxdata0_i;
    tile2_ila_in0_i(60 downto 53)           <= tile2_error_count0_i;
    tile2_ila_in0_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope ILA connections for GTP1 on Tile 2
    tile2_ila_in1_i(84 downto 83)           <= tile2_rxdisperr1_i;
    tile2_ila_in1_i(82 downto 81)           <= tile2_rxnotintable1_i;
    tile2_ila_in1_i(80)                     <= tile2_rxbyteisaligned1_i;
    tile2_ila_in1_i(79)                     <= tile2_rxbyterealign1_i;
    tile2_ila_in1_i(78)                     <= tile2_rxcommadet1_i;
    tile2_ila_in1_i(77)                     <= tile2_rxprbserr1_i;
    tile2_ila_in1_i(76 downto 61)           <= tile2_rxdata1_i;
    tile2_ila_in1_i(60 downto 53)           <= tile2_error_count1_i;
    tile2_ila_in1_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope VIO input connections on Tile 3
    tile3_data_vio_in_i(139)                <= tile3_resetdone0_i;
    tile3_data_vio_in_i(138)                <= tile3_resetdone1_i;
    tile3_data_vio_in_i(137 downto 0)       <= tied_to_ground_vec_i(137 downto 0);

    -- Chipscope VIO ouptut connections on Tile 3
    tile3_loopback0_i                       <= tile3_data_vio_out_i(139 downto 137);
    tile3_loopback1_i                       <= tile3_data_vio_out_i(136 downto 134);
    tile3_rxslide0_i                        <= tile3_data_vio_out_i(133);
    tile3_rxslide1_i                        <= tile3_data_vio_out_i(132);
    tile3_prbscntreset0_i                   <= tile3_data_vio_out_i(131);
    tile3_prbscntreset1_i                   <= tile3_data_vio_out_i(130);
    tile3_rxenprbstst0_i                    <= tile3_data_vio_out_i(129 downto 127);
    tile3_rxenprbstst1_i                    <= tile3_data_vio_out_i(126 downto 124);
    tile3_txenprbstst0_i                    <= tile3_data_vio_out_i(123 downto 121);
    tile3_txenprbstst1_i                    <= tile3_data_vio_out_i(120 downto 118);

    -- Chipscope ILA connections for GTP0 on Tile 3
    tile3_ila_in0_i(84 downto 83)           <= tile3_rxdisperr0_i;
    tile3_ila_in0_i(82 downto 81)           <= tile3_rxnotintable0_i;
    tile3_ila_in0_i(80)                     <= tile3_rxbyteisaligned0_i;
    tile3_ila_in0_i(79)                     <= tile3_rxbyterealign0_i;
    tile3_ila_in0_i(78)                     <= tile3_rxcommadet0_i;
    tile3_ila_in0_i(77)                     <= tile3_rxprbserr0_i;
    tile3_ila_in0_i(76 downto 61)           <= tile3_rxdata0_i;
    tile3_ila_in0_i(60 downto 53)           <= tile3_error_count0_i;
    tile3_ila_in0_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);

    -- Chipscope ILA connections for GTP1 on Tile 3
    tile3_ila_in1_i(84 downto 83)           <= tile3_rxdisperr1_i;
    tile3_ila_in1_i(82 downto 81)           <= tile3_rxnotintable1_i;
    tile3_ila_in1_i(80)                     <= tile3_rxbyteisaligned1_i;
    tile3_ila_in1_i(79)                     <= tile3_rxbyterealign1_i;
    tile3_ila_in1_i(78)                     <= tile3_rxcommadet1_i;
    tile3_ila_in1_i(77)                     <= tile3_rxprbserr1_i;
    tile3_ila_in1_i(76 downto 61)           <= tile3_rxdata1_i;
    tile3_ila_in1_i(60 downto 53)           <= tile3_error_count1_i;
    tile3_ila_in1_i(52 downto 0)            <= tied_to_ground_vec_i(52 downto 0);


   
end generate chipscope;


no_chipscope : if EXAMPLE_USE_CHIPSCOPE = 0 generate

    -- If Chipscope is not being used, drive GTP reset signal
    -- from the top level ports
    tile0_gtpreset0_i                       <= GTP0_RESET_IN;
    tile0_gtpreset1_i                       <= GTP1_RESET_IN;
    tile1_gtpreset0_i                       <= GTP0_RESET_IN;
    tile1_gtpreset1_i                       <= GTP1_RESET_IN;
    tile2_gtpreset0_i                       <= GTP0_RESET_IN;
    tile2_gtpreset1_i                       <= GTP1_RESET_IN;
    tile3_gtpreset0_i                       <= GTP0_RESET_IN;
    tile3_gtpreset1_i                       <= GTP1_RESET_IN;

    -- assign resets for frame_gen and frame_check modules
    tile0_tx_system_reset0_c                <= not tile0_tx_sync_done0_i;
    tile0_tx_system_reset1_c                <= not tile0_tx_sync_done1_i;
    tile1_tx_system_reset0_c                <= not tile1_tx_sync_done0_i;
    tile1_tx_system_reset1_c                <= not tile1_tx_sync_done1_i;
    tile2_tx_system_reset0_c                <= not tile2_tx_sync_done0_i;
    tile2_tx_system_reset1_c                <= not tile2_tx_sync_done1_i;
    tile3_tx_system_reset0_c                <= not tile3_tx_sync_done0_i;
    tile3_tx_system_reset1_c                <= not tile3_tx_sync_done1_i;
    tile0_rx_system_reset0_c                <= not tile0_rx_sync_done0_i;
    tile0_rx_system_reset1_c                <= not tile0_rx_sync_done1_i;
    tile1_rx_system_reset0_c                <= not tile1_rx_sync_done0_i;
    tile1_rx_system_reset1_c                <= not tile1_rx_sync_done1_i;
    tile2_rx_system_reset0_c                <= not tile2_rx_sync_done0_i;
    tile2_rx_system_reset1_c                <= not tile2_rx_sync_done1_i;
    tile3_rx_system_reset0_c                <= not tile3_rx_sync_done0_i;
    tile3_rx_system_reset1_c                <= not tile3_rx_sync_done1_i;

    gtpreset0_i                             <= tied_to_ground_i;
    user_tx_reset_i                         <= tied_to_ground_i;
    user_rx_reset_i                         <= tied_to_ground_i;
    tile0_loopback0_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile0_loopback1_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile0_rxslide0_i                        <= tied_to_ground_i;
    tile0_rxslide1_i                        <= tied_to_ground_i;
    tile0_prbscntreset0_i                   <= tied_to_ground_i;
    tile0_prbscntreset1_i                   <= tied_to_ground_i;
    tile0_rxenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile0_rxenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile0_txenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile0_txenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile1_loopback0_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile1_loopback1_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile1_rxslide0_i                        <= tied_to_ground_i;
    tile1_rxslide1_i                        <= tied_to_ground_i;
    tile1_prbscntreset0_i                   <= tied_to_ground_i;
    tile1_prbscntreset1_i                   <= tied_to_ground_i;
    tile1_rxenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile1_rxenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile1_txenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile1_txenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile2_loopback0_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile2_loopback1_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile2_rxslide0_i                        <= tied_to_ground_i;
    tile2_rxslide1_i                        <= tied_to_ground_i;
    tile2_prbscntreset0_i                   <= tied_to_ground_i;
    tile2_prbscntreset1_i                   <= tied_to_ground_i;
    tile2_rxenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile2_rxenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile2_txenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile2_txenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile3_loopback0_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile3_loopback1_i                       <= tied_to_ground_vec_i(2 downto 0);
    tile3_rxslide0_i                        <= tied_to_ground_i;
    tile3_rxslide1_i                        <= tied_to_ground_i;
    tile3_prbscntreset0_i                   <= tied_to_ground_i;
    tile3_prbscntreset1_i                   <= tied_to_ground_i;
    tile3_rxenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile3_rxenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile3_txenprbstst0_i                    <= tied_to_ground_vec_i(2 downto 0);
    tile3_txenprbstst1_i                    <= tied_to_ground_vec_i(2 downto 0);



end generate no_chipscope;


end RTL;

